Package: bold
Title: Interface to Bold Systems API
Description: A programmatic interface to the Web Service methods provided by
    Bold Systems (<http://www.boldsystems.org/>) for genetic 'barcode' data.
    Functions include methods for searching by sequences by taxonomic names,
    ids, collectors, and institutions; as well as a function for searching
    for specimens, and downloading trace files.
Version: 0.9.0
License: MIT + file LICENSE
Authors@R: c(person("Scott", "Chamberlain",
    role = c("aut", "cre"),
    email = "myrmecocystus@gmail.com",
    comment = c(ORCID="0000-0003-1444-9135")))
URL: https://github.com/ropensci/bold
BugReports: https://github.com/ropensci/bold/issues
VignetteBuilder: knitr
LazyData: yes
Encoding: UTF-8
Imports: xml2, crul (>= 0.3.8), stringr, jsonlite, reshape, plyr,
        data.table, tibble
Suggests: roxygen2 (>= 6.1.1), sangerseqR, knitr, testthat, vcr (>=
        0.2.2)
RoxygenNote: 6.1.1
X-schema.org-applicationCategory: Data Access
X-schema.org-keywords: biodiversity, barcode, DNA, sequences, fasta
X-schema.org-isPartOf: https://ropensci.org
NeedsCompilation: no
Packaged: 2019-06-27 18:13:58 UTC; sckott
Author: Scott Chamberlain [aut, cre] (<https://orcid.org/0000-0003-1444-9135>)
Maintainer: Scott Chamberlain <myrmecocystus@gmail.com>
Repository: CRAN
Date/Publication: 2019-06-27 18:40:03 UTC

Package: bold
Version: 1.3.0
Title: Interface to Bold Systems API
Authors@R: c(person("Salix", "Dubois", role = c("aut", "cre"), 
                    email = "salixdubois+bold@gmail.com"),
             person("Scott", "Chamberlain", role = c("aut"),
                    email = "myrmecocystus@gmail.com",
                    comment = c(ORCID="0000-0003-1444-9135")))
Depends: R (>= 2.10)
Suggests: sangerseqR, testthat, vcr (>= 0.5.4), tibble
Imports: xml2, crul (>= 0.3.8), stringi, jsonlite, data.table, methods
Description: A programmatic interface to the Web Service methods provided by
    Bold Systems (<http://www.boldsystems.org/>) for genetic 'barcode' data.
    Functions include methods for searching by sequences by taxonomic names,
    ids, collectors, and institutions; as well as a function for searching
    for specimens, and downloading trace files.
License: MIT + file LICENSE
URL: https://docs.ropensci.org/bold/ (documentation),
        https://github.com/ropensci/bold (source)
BugReports: https://github.com/ropensci/bold/issues
LazyData: yes
Encoding: UTF-8
RoxygenNote: 7.2.3
X-schema.org-applicationCategory: Data Access
X-schema.org-keywords: biodiversity, barcode, DNA, sequences, fasta
X-schema.org-isPartOf: https://ropensci.org
NeedsCompilation: no
Packaged: 2023-05-01 19:56:58 UTC; salix
Author: Salix Dubois [aut, cre],
  Scott Chamberlain [aut] (<https://orcid.org/0000-0003-1444-9135>)
Maintainer: Salix Dubois <salixdubois+bold@gmail.com>
Repository: CRAN
Date/Publication: 2023-05-02 17:40:02 UTC

bold
====


[![Project Status: Active – The project has reached a stable, usable state and is being actively developed.](https://www.repostatus.org/badges/latest/active.svg)](https://www.repostatus.org/#active)
[![cran version](https://www.r-pkg.org/badges/version/bold)](https://cran.r-project.org/package=bold)
[![cran checks](https://badges.cranchecks.info/worst/bold.svg)](https://badges.cranchecks.info)
[![R-check](https://github.com/ropensci/bold/workflows/R-check/badge.svg)](https://github.com/ropensci/bold/actions/)
[![codecov.io](https://codecov.io/github/ropensci/bold/coverage.svg?branch=master)](https://app.codecov.io/gh/ropensci/bold?branch=master)
[![rstudio mirror downloads](https://cranlogs.r-pkg.org/badges/bold)](https://github.com/r-hub/cranlogs.app)

`bold` accesses BOLD barcode data.

The Barcode of Life Data Systems (BOLD) is designed to support the generation and application of DNA barcode data. The platform consists of four main modules: a data portal, a database of barcode clusters, an educational portal, and a data collection workbench.

This package retrieves data from the BOLD database of barcode clusters, and allows for searching of over 1.7M public records using multiple search criteria including sequence data, specimen data, specimen *plus* sequence data, as well as trace files.

Documentation for the BOLD API: http://v4.boldsystems.org/index.php/api_home

See also the taxize book for more options for taxonomic workflows with BOLD: https://taxize.dev/

## Installation

__Installation instructions__

__Stable Version__


```r
install.packages("bold")
```

__Development Version__

Install `sangerseqR` first if you're planning on downloading and reading trace files.
(The package is only used in the function `bold::bold_read_trace()`)

For R < 3.5


```r
source("http://bioconductor.org/biocLite.R")
biocLite("sangerseqR")
```

For R >= 3.5


```r
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("sangerseqR")
```

Then install `bold`


```r
remotes::install_github("ropensci/bold")
```


## Usage

```r
library("bold")
```


### Search for sequence data only

Default is to get a list back


```r
bold_seq(taxon='Coelioxys')[[1]]
#> $id
#> [1] "ABEE117-17"
#> 
#> $name
#> [1] "Coelioxys elongata"
#> 
#> $gene
#> [1] "ABEE117-17"
#> 
#> $sequence
#> [1] " "
```

You can optionally get back the `crul` response object


```r
res <- bold_seq(taxon='Coelioxys', response=TRUE)
res$response_headers
#> $status
#> [1] "HTTP/2 200 "
#> 
#> $server
#> [1] "nginx"
#> 
#> $date
#> [1] "Mon, 20 Apr 2020 16:11:50 GMT"
#> 
#> $`content-type`
#> [1] "application/x-download"
#> 
#> $`x-powered-by`
#> [1] "PHP/5.3.15"
#> 
#> $`content-disposition`
#> [1] "attachment; filename=fasta.fas"
#> 
#> $`x-frame-options`
#> [1] "SAMEORIGIN"
#> 
#> $`x-content-type-options`
#> [1] "nosniff"
#> 
#> $`x-xss-protection`
#> [1] "1; mode=block"
```

### Search for specimen data only

By default you download `tsv` format data, which is given back to you as a `data.frame`.


```r
res <- bold_specimens(taxon='Osmia')
head(res[,1:8])
#>      processid   sampleid recordID catalognum   fieldnum
#> 1  BEECA373-06 05-NT-0373   514740            05-NT-0373
#> 2  BEECA607-06 05-NT-0607   516959            05-NT-0607
#> 3  BEECA963-07 01-OR-0790   554153            01-OR-0790
#> 4  BEECB358-07 04-WA-1076   596920 BBSL697174 04-WA-1076
#> 5  BEECB438-07 00-UT-1157   597000 BBSL432653 00-UT-1157
#> 6 BEECC1176-09 02-UT-2849  1060879 BBSL442586 02-UT-2849
#>                    institution_storing collection_code      bin_uri
#> 1   York University, Packer Collection              NA BOLD:AAI2013
#> 2   York University, Packer Collection              NA BOLD:AAC8510
#> 3   York University, Packer Collection              NA BOLD:ABZ3184
#> 4 Utah State University, Logan Bee Lab              NA BOLD:AAC5797
#> 5 Utah State University, Logan Bee Lab              NA BOLD:AAF2159
#> 6   York University, Packer Collection              NA BOLD:AAE5368
```

### Search for specimen plus sequence data

By default you download `tsv` format data, which is given back to you as a `data.frame`.
You can get the sequences in a separated list with `sepfasta=TRUE`.


```r
res <- bold_seqspec(taxon='Osmia', sepfasta=TRUE)
res$fasta[1:2]
#> $`BEECA373-06`
#> [1] " "
#> 
#> $`BEECA607-06`
#> [1] " "
```

Or you can index to a specific sequence like


```r
res$fasta['GBAH0293-06']
#> $`GBAH0293-06`
#> [1] " "
```

Note: you can get several sequences for one process id.
For example:
```{r}
res <- bold_seqspec(taxon='Salix', sepfasta=TRUE)
res$fasta[names(res$fasta) == "SALIX204-08"]
#> $SALIX204-08
#> CCGCCCCTAA------ATTTACAAATTACCAAGATTCGAATTTATAACATTTACTATTCAATTTAACC-------------------TTTTTTTATAAGTCTTA-------------------------TAAGAAAGAAATACAAAAGTAAAAAAAAAA-TTATTTAAGGAGCAATGCCAACCCTCTTGATAGAACAAGAAATTGGCGATTGCTCCTTTTTTTTTTTT--CAAAAGCTCGTACACACTAAGACAAAAGTCTTATCCATTTACAAAAGTCTTATCCATTTGT
#> $SALIX204-08
#> [1] ATTGGAACGCCAAGTTGCTCTTGATTCGGGGGTTCCTGCTATAGCCGAACACGAGGGAAAGATAATTTATACCGACATTGACAAGATTATTTTATCGGGGAATGGTTATACTGTAAGCATTCCATTAGTTATGTATCAACGTTCCAACAAAAATACCTGTATGCATCAAAAAACTCAGGTTCAGCGAGGAAAATGCATTAAAAGGGGACAAGTTTTGGCGGACGGTGCCGCTACAGTTGGTGGCGAACTCGCCTTGGGCAAAAACATATTAGTAGCTTATATGCCATGGGAAGGCTACAATTTTGAAGATGCGGTACTCATTAGCGAACGTCTGGTATATGAAGATGTTTATACTTCT
#> $SALIX204-08
#> [1]  
#> $SALIX204-08
#> [1]  
#> $SALIX204-08
#> [1] TGAGACTATGCTTGGCAAACGGGTTGATTATTCGGGGCGTTCCGTTATTGTCGTAGGCCCCTCACTTTCATTACATCGATGTGGATTGCCTCGCGAAATTGCAATAGAGCTTTTCCAGACATTTGTAATTCGTGGTCTAATTAGGCAACATCTTGCTTCAAACATAGGAGTTGCTAAGAGTAAAATTCGGGAAAAAGAGCCAATTGTATGGGGAATACTTCAGGAGGTTATGCGAGGACATCCTATATTGCTAAATAGAGCGCCTACTCTGCATAGATTAGGCATACAGGCATTCCAACCCATTTTAGTGGAAGGACGTGCTATTTGTTTACATCCATTAGTTCGTAAGGGATTCAATGCAGATTTTGATGGGGATCAAATGGCTGTTCATGTACCTTTATCGTTGGAGGCTCAAGCGGAGGCTCGTTTACTTATGTTTTCTCATATGAATCTCT
#> $SALIX204-08
#> [1]  
#> $SALIX204-08
#> [1]  
#> $SALIX204-08
#> [1] TGCAGAATCCCGTGAACCATCGAGTCTTTGAACGCAAGTTGCGCCCGAGGCCTCCTGGTCGAGGGCACGTCTGCCT---GGGTGTCACGCATCGTCGCCCCC-------ACTCCCCTCG-------------------------GCTCACGAGGGCGGGGGCGGATACTGGTCTCCCGCGCGCTCCCGCCCGTGGTTGGCCT-AAAATCGAGTCCT-CGGCGGCGGTTGCC----ACGACAAGCGGTGGTTG-----------------------AGAGACCCTCGGACACGGTCGTGCGCGTGCTTG---------------------TCGCCCCCGGGAC--------------CTCCCGGACCCCCGAGCATTGGCTTTC-----------AAG-------------GATGCTCTCGTTGCGACCCCAGGTCAGGCGGGACTACCCGCTGAGTTTAA
```
The reason being some process have different sequences for different markers.
```{r}
res$data[names(res$fasta) == "SALIX204-08", "markercode"]
#>[1] "trnH-psbA" "rpoB"      "atpF-atpH" "psbK-psbI" "rpoC1"     "rbcLa"     "matK"      "ITS2"
```

### Get trace files

This function downloads files to your machine - it does not load them into your R session - but prints out where the files are for your information.

```r
traces1 <- bold_trace(ids = 'ACRJP618-11', progress = FALSE)
traces1
#><bold trace files> 
#>
#>./bold_trace_files/ACRJP618-11[LepF1,LepR1]_F.ab1
traces2 <- bold::bold_trace(ids = 'SALIX204-08', progress = FALSE)
traces2
#> <bold trace files> 
#> 
#> ./bold_trace_files/ACRJP618-11[LepF1,LepR1]_F.ab1
#> ./bold_trace_files/SALIX204-08[MatK-1RKIM-f,MatK-3FKIM-r]_F.ab1
#> ./bold_trace_files/SALIX204-08[MatK-1RKIM-f,MatK-3FKIM-r]_R.ab1
#> ./bold_trace_files/SALIX204-08[rbcLa-F,rbcLa-R]_F.ab1
#> ./bold_trace_files/SALIX204-08[rbcLa-F,rbcLa-R]_R.ab1
```

Then to read the files, you can use `bold::bold_read_trace()` with either the boldtrace object or a subset of the paths.

```{r}
bold_read_trace(trace1)
#> $`ACRJP618-11[LepF1,LepR1]_F.ab1`
#> Number of datapoints: 8877
#> Number of basecalls: 685
#> 
#> Primary Basecalls:  
#> 
#> Secondary Basecalls:

bold_read_trace(trace2$ab1[1:2])
># $`ACRJP618-11[LepF1,LepR1]_F.ab1`
># Number of datapoints: 8877
># Number of basecalls: 685
># 
># Primary Basecalls:  
># 
># Secondary Basecalls: 
># 
># $`SALIX204-08[MatK-1RKIM-f,MatK-3FKIM-r]_F.ab1`
># Number of datapoints: 16299
># Number of basecalls: 877
># 
># Primary Basecalls:  
># 
># Secondary Basecalls: 
```

### Large data

Sometimes with `bold_seq()`, `bold_seqspec()` and `bold_specimen()` you request a lot of data, which can cause problems due 
to BOLD's servers. 

An example is the taxonomic name _Arthropoda_. When you send a request like 
`bold_seq(taxon = "Arthropoda")`, `bold_seqspec(taxon = "Arthropoda")` or `bold_specimen(taxon = "Arthropoda")` BOLD attempts to give you back sequences and/or specimen information for all records under _Arthropoda_. This, as you can imagine, is a lot of sequences. 

```r
library("taxize")
```

Using `taxize::downstream` get children of _Arthropoda_

```r
x <- downstream("Arthropoda", db = "ncbi", downto = "class")
#> ══  1 queries  ═══════════════
#> ✔  Found:  Arthropoda
#> ══  Results  ═════════════════
#> 
#> ● Total: 1 
#> ● Found: 1 
#> ● Not Found: 0
nms <- x$Arthropoda$childtaxa_name
```

Optionally, check that the name exists in BOLD's data. Any that are not in 
BOLD will give back a row of NAs

```r
checks <- bold_tax_name(nms)
# all is good
checks[,1:5]
#>     taxid         taxon tax_rank tax_division parentid
#> 1   26059   Pycnogonida    class     Animalia       20
#> 2      63     Arachnida    class     Animalia       20
#> 3      74   Merostomata    class     Animalia       20
#> 4  493944     Pauropoda    class     Animalia       20
#> 5   80390      Symphyla    class     Animalia       20
#> 6      85     Diplopoda    class     Animalia       20
#> 7      75     Chilopoda    class     Animalia       20
#> 8      82       Insecta    class     Animalia       20
#> 9     372    Collembola    class     Animalia       20
#> 10 734357       Protura    class     Animalia       20
#> 11     84     Remipedia    class     Animalia       20
#> 12     73 Cephalocarida    class     Animalia       20
#> 13     68  Branchiopoda    class     Animalia       20
#> 14 765970   Hexanauplia    class     Animalia       20
#> 15     69  Malacostraca    class     Animalia       20
#> 16 889450 Ichthyostraca    class     Animalia       20
#> 17     NA          <NA>     <NA>         <NA>       NA
#> 18     80     Ostracoda    class     Animalia       20
```

Then pass those names to `bold_seq()`. You could pass all names in at once,
but we're trying to avoid the large data request problem here, so run each 
one separately with `lapply` or a for loop like request. 


```r
out <- lapply(nms, bold_seq)
```

## Citation

Get citation information for `bold` in R by running: `citation(package = 'bold')`

## Meta

* Please [report any issues or bugs](https://github.com/ropensci/bold/issues)
* License: MIT
* Get citation information for `bold` in R doing `citation(package = 'bold')`
* Please note that this project is released with a [Contributor Code of Conduct](https://ropensci.org/code-of-conduct/). By participating in this project you agree to abide by its terms.

bold
====


[![Project Status: Active – The project has reached a stable, usable state and is being actively developed.](https://www.repostatus.org/badges/latest/active.svg)](https://www.repostatus.org/#active)
[![cran version](https://www.r-pkg.org/badges/version/bold)](https://cran.r-project.org/package=bold)
[![cran checks](https://cranchecks.info/badges/worst/bold)](https://cranchecks.info/pkgs/bold)
[![R-check](https://github.com/ropensci/bold/workflows/R-check/badge.svg)](https://github.com/ropensci/bold/actions/)
[![codecov.io](https://codecov.io/github/ropensci/bold/coverage.svg?branch=master)](https://codecov.io/github/ropensci/bold?branch=master)
[![rstudio mirror downloads](https://cranlogs.r-pkg.org/badges/bold)](https://github.com/metacran/cranlogs.app)

`bold` accesses BOLD barcode data.

The Barcode of Life Data Systems (BOLD) is designed to support the generation and application of DNA barcode data. The platform consists of four main modules: a data portal, a database of barcode clusters, an educational portal, and a data collection workbench.

This package retrieves data from the BOLD database of barcode clusters, and allows for searching of over 1.7M public records using multiple search criteria including sequence data, specimen data, specimen *plus* sequence data, as well as trace files.

Documentation for the BOLD API: http://v4.boldsystems.org/index.php/api_home

See also the taxize book for more options for taxonomic workflows with BOLD: https://taxize.dev/

## Installation

__Installation instructions__

__Stable Version__


```r
install.packages("bold")
```

__Development Version__

Install `sangerseqR` first (used in function `bold::bold_trace()` only)

For R < 3.5


```r
source("http://bioconductor.org/biocLite.R")
biocLite("sangerseqR")
```

For R >= 3.5


```r
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("sangerseqR")
```

Then install `bold`


```r
remotes::install_github("ropensci/bold")
```


## Usage

```r
library("bold")
```


### Search for sequence data only

Default is to get a list back


```r
bold_seq(taxon='Coelioxys')[[1]]
#> $id
#> [1] "ABEE117-17"
#> 
#> $name
#> [1] "Coelioxys elongata"
#> 
#> $gene
#> [1] "ABEE117-17"
#> 
#> $sequence
#> [1] " "
```

You can optionally get back the `crul` response object


```r
res <- bold_seq(taxon='Coelioxys', response=TRUE)
res$response_headers
#> $status
#> [1] "HTTP/2 200 "
#> 
#> $server
#> [1] "nginx"
#> 
#> $date
#> [1] "Mon, 20 Apr 2020 16:11:50 GMT"
#> 
#> $`content-type`
#> [1] "application/x-download"
#> 
#> $`x-powered-by`
#> [1] "PHP/5.3.15"
#> 
#> $`content-disposition`
#> [1] "attachment; filename=fasta.fas"
#> 
#> $`x-frame-options`
#> [1] "SAMEORIGIN"
#> 
#> $`x-content-type-options`
#> [1] "nosniff"
#> 
#> $`x-xss-protection`
#> [1] "1; mode=block"
```

### Search for specimen data only

By default you download `tsv` format data, which is given back to you as a `data.frame`


```r
res <- bold_specimens(taxon='Osmia')
head(res[,1:8])
#>      processid   sampleid recordID catalognum   fieldnum
#> 1  BEECA373-06 05-NT-0373   514740            05-NT-0373
#> 2  BEECA607-06 05-NT-0607   516959            05-NT-0607
#> 3  BEECA963-07 01-OR-0790   554153            01-OR-0790
#> 4  BEECB358-07 04-WA-1076   596920 BBSL697174 04-WA-1076
#> 5  BEECB438-07 00-UT-1157   597000 BBSL432653 00-UT-1157
#> 6 BEECC1176-09 02-UT-2849  1060879 BBSL442586 02-UT-2849
#>                    institution_storing collection_code      bin_uri
#> 1   York University, Packer Collection              NA BOLD:AAI2013
#> 2   York University, Packer Collection              NA BOLD:AAC8510
#> 3   York University, Packer Collection              NA BOLD:ABZ3184
#> 4 Utah State University, Logan Bee Lab              NA BOLD:AAC5797
#> 5 Utah State University, Logan Bee Lab              NA BOLD:AAF2159
#> 6   York University, Packer Collection              NA BOLD:AAE5368
```

### Search for specimen plus sequence data

By default you download `tsv` format data, which is given back to you as a `data.frame`


```r
res <- bold_seqspec(taxon='Osmia', sepfasta=TRUE)
res$fasta[1:2]
#> $`BEECA373-06`
#> [1] " "
#> 
#> $`BEECA607-06`
#> [1] " "
```

Or you can index to a specific sequence like


```r
res$fasta['GBAH0293-06']
#> $`GBAH0293-06`
#> [1] " "
```

### Get trace files

This function downloads files to your machine - it does not load them into your R session - but prints out where the files are for your information.


```r
x <- bold_trace(ids = 'ACRJP618-11', progress = FALSE)
read_trace(x$ab1)
#> Number of datapoints: 8877
#> Number of basecalls: 685
#> 
#> Primary Basecalls:  
#> 
#> Secondary Basecalls:
```

### Large data

Sometimes with `bold_seq()` you request a lot of data, which can cause problems due 
to BOLD's servers. 

An example is the taxonomic name _Arthropoda_. When you send a request like 
`bold_seq(taxon = "Arthropoda")` BOLD attempts to give you back sequences
for all records under _Arthropoda_. This, as you can imagine, is a lot of 
sequences. 



```r
library("taxize")
```

Using `taxize::downstream` get children of _Arthropoda_


```r
x <- downstream("Arthropoda", db = "ncbi", downto = "class")
#> ══  1 queries  ═══════════════
#> ✔  Found:  Arthropoda
#> ══  Results  ═════════════════
#> 
#> ● Total: 1 
#> ● Found: 1 
#> ● Not Found: 0
nms <- x$Arthropoda$childtaxa_name
```

Optionally, check that the name exists in BOLD's data. Any that are not in 
BOLD will give back a row of NAs


```r
checks <- bold_tax_name(nms)
# all is good
checks[,1:5]
#>     taxid         taxon tax_rank tax_division parentid
#> 1   26059   Pycnogonida    class     Animalia       20
#> 2      63     Arachnida    class     Animalia       20
#> 3      74   Merostomata    class     Animalia       20
#> 4  493944     Pauropoda    class     Animalia       20
#> 5   80390      Symphyla    class     Animalia       20
#> 6      85     Diplopoda    class     Animalia       20
#> 7      75     Chilopoda    class     Animalia       20
#> 8      82       Insecta    class     Animalia       20
#> 9     372    Collembola    class     Animalia       20
#> 10 734357       Protura    class     Animalia       20
#> 11     84     Remipedia    class     Animalia       20
#> 12     73 Cephalocarida    class     Animalia       20
#> 13     68  Branchiopoda    class     Animalia       20
#> 14 765970   Hexanauplia    class     Animalia       20
#> 15     69  Malacostraca    class     Animalia       20
#> 16 889450 Ichthyostraca    class     Animalia       20
#> 17     NA          <NA>     <NA>         <NA>       NA
#> 18     80     Ostracoda    class     Animalia       20
```

Then pass those names to `bold_seq()`. You could pass all names in at once,
but we're trying to avoid the large data request problem here, so run each 
one separately with `lapply` or a for loop like request. 


```r
out <- lapply(nms, bold_seq)
```

## Citation

Get citation information for `bold` in R by running: `citation(package = 'bold')`

## Meta

* Please [report any issues or bugs](https://github.com/ropensci/bold/issues)
* License: MIT
* Get citation information for `bold` in R doing `citation(package = 'bold')`
* Please note that this project is released with a [Contributor Code of Conduct][coc]. By participating in this project you agree to abide by its terms.

[![ropensci_footer](https://ropensci.org/public_images/github_footer.png)](https://ropensci.org)

[coc]: https://github.com/ropensci/bold/blob/master/CODE_OF_CONDUCT.md

bbase <- function() 'http://v4.boldsystems.org/index.php/'

bc <- function(x) Filter(Negate(is.null), x)

split_fasta <- function(x){
  temp <- paste(">", x, sep = "")
  seq <- str_replace_all(str_split(str_replace(temp[[1]], "\n", "<<<"), 
                                   "<<<")[[1]][[2]], "\n", "")
  seq <- gsub("\\\r|\\\n", "", seq)
  stuff <- str_split(x, "\\|")[[1]][c(1:3)]
  list(id = stuff[1], name = stuff[2], gene = stuff[1], sequence = seq)
}

pipeornull <- function(x){
  if (!is.null(x)) { 
    paste0(x, collapse = "|") 
  } else { 
    NULL
  }
}

check_args_given_nonempty <- function(arguments, x){
  paramnames <- x
  matchez <- any(paramnames %in% names(arguments))
  if (!matchez) {
    stop(sprintf("You must provide a non-empty value to at least one of\n  %s", 
                 paste0(paramnames, collapse = "\n  ")))
  } else {
    arguments_noformat <- arguments[ !names(arguments) %in% 'combined_download' ]
    argslengths <- vapply(arguments_noformat, nchar, numeric(1), 
                          USE.NAMES = FALSE)
    if (any(argslengths == 0)) {
      stop(sprintf("You must provide a non-empty value to at least one of\n  %s", 
                   paste0(paramnames, collapse = "\n  ")))
    }
  }   
}

process_response <- function(x, y, z, w){
  tt <- rawToChar(x$content)
  out <- if (x$status_code > 202) "stop" else jsonlite::fromJSON(tt)
  if ( length(out) == 0 || identical(out[[1]], list()) || any(out == "stop") ) {
    data.frame(input = y, stringsAsFactors = FALSE)
  } else {
    if (w %in% c("stats",'images','geo','sequencinglabs','depository')) out <- out[[1]]
    trynames <- tryCatch(as.numeric(names(out)), warning = function(w) w)
    if (!inherits(trynames, "simpleWarning")) names(out) <- NULL
    if (any(vapply(out, function(x) is.list(x) && length(x) > 0, logical(1)))) {
      out <- lapply(out, function(x) Filter(length, x))
    } else {
      out <- Filter(length, out)
    }
    if (!is.null(names(out))) {
      df <- data.frame(out, stringsAsFactors = FALSE)
    } else {
      df <- do.call(rbind.fill, lapply(out, data.frame, stringsAsFactors = FALSE))
    }
    row.names(df) <- NULL
    if ("parentid" %in% names(df)) df <- sort_df(df, "parentid")
    row.names(df) <- NULL
    data.frame(input = y, df, stringsAsFactors = FALSE)
  }
}

get_response <- function(args, url, ...){
  cli <- crul::HttpClient$new(url = url)
  out <- cli$get(query = args, ...)
  out$raise_for_status()
  stopifnot(out$headers$`content-type` == 'text/html; charset=utf-8')
  return(out)
}

b_GET <- function(url, args, ...){
  cli <- crul::HttpClient$new(url = url)
  out <- cli$get(query = args, ...)
  out$raise_for_status()
  if (grepl("html", out$response_headers$`content-type`)) {
    stop(out$parse("UTF-8"))
  }
  return(out)
}

strextract <- function(str, pattern) {
  regmatches(str, regexpr(pattern, str))
}

strdrop <- function(str, pattern) {
  regmatches(str, regexpr(pattern, str), invert = TRUE)
}

assert <- function(x, y) {
  if (!is.null(x)) {
    if (!inherits(x, y)) {
      stop(deparse(substitute(x)), " must be of class ",
           paste0(y, collapse = ", "), call. = FALSE)
    }
  }
}

assert_param <- function(x, param, y) {
  if (!is.null(x)) {
    if (!inherits(x, y)) {
      stop(param, " must be of class ",
           paste0(y, collapse = ", "), call. = FALSE)
    }
  }
}

setrbind <- function(x) {
  (xxx <- data.table::setDF(
    data.table::rbindlist(x, fill = TRUE, use.names = TRUE))
  )
}

#' Get the error messages and parameters used for a request from a bold output.
#'
#' @param x   Any object with the attributes "errors" and "params". Usually the output of \code{\link{bold_tax_name}} or \code{\link{bold_tax_id2}}.
#'
#' @return A list of the attributes 'errors' and 'params' of the object.
#' @examples \dontrun{
#' x <- bold_tax_name(name=c("Apis","Felis","Pinus"), tax_division = "Animalia")
#' bold_get_errors(x)
#' y <- bold_tax_id2(id = c(88899999, 125295, NA_integer_), dataTypes = c("basic", "stats"))
#' bold_get_errors(y)
#' }
#' @export
bold_get_attr <- function(x){
  if (missing(x)) stop("argument 'x' is missing, with no default")
  if (is.data.frame(x)) {
    attributes(x)[c("errors", "params")]
  } else {
    lapply(x, bold_get_attr)
  }
}
#' Get the error messages from a bold output.
#'
#' @param x   Any object with an attribute "errors". Usually the output of \code{\link{bold_tax_name}} or \code{\link{bold_tax_id2}}.
#'
#' @return The 'errors' attribute of the object.
#' @examples \dontrun{
#' x <- bold_tax_name(name=c("Apis","Felis","Pinus"), tax_division = "Animalia")
#' bold_get_errors(x)
#' y <- bold_tax_id2(id = c(88899999, 125295, NA_integer_), dataTypes = c("basic", "stats"))
#' bold_get_errors(y)
#' }
#' @rdname bold_get_attr
#' @export
bold_get_errors <- function(x){
  if (missing(x)) stop("argument 'x' is missing, with no default")
  if (is.data.frame(x)) {
    attr(x, which = "errors", exact = TRUE)
  } else {
    lapply(x, attr, which = "errors", exact = TRUE)
  }
}
#' Get the parameters used for a request from a bold output.
#'
#' @param x   Any object with an attribute "params". Usually the output of \code{\link{bold_tax_name}} or \code{\link{bold_tax_id2}}.
#'
#' @return The 'params' attribute of the object.
#' @examples \dontrun{
#' x <- bold_tax_name(name=c("Apis","Felis","Pinus"), tax_division = "Animalia")
#' bold_get_params(x)
#' y <- bold_tax_id2(id = c(88899999, 125295, NA_integer_), dataTypes = c("basic", "stats"))
#' bold_get_params(y)
#' }
#' @rdname bold_get_attr
#' @export
bold_get_params <- function(x){
  if (missing(x)) stop("argument 'x' is missing, with no default")
  if (is.data.frame(x)) {
    attr(x, which = "params", exact = TRUE)
  } else {
    lapply(x, attr, which = "params", exact = TRUE)
  }
}

test_that("bold_get_* return the correct objects", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_id2", {
    test_id <- bold_tax_id2(id = c(88899, NA))
  })
  test <- bold_get_attr(test_id)
  expect_is(test, "list")
  expect_length(test, 2L)
  expect_named(test, c("errors", "params"))
  expect_is(test$errors, "list")
  expect_is(test$params, "list")
  expect_is(test$errors[[1]], "character")
  expect_is(test$params$dataTypes, "character")
  expect_is(test$params$includeTree, "logical")
  test <- bold_get_errors(test_id)
  expect_is(test, "list")
  expect_length(test, 1L)
  expect_is(test[[1]], "character")
  test <- bold_get_params(test_id)
  expect_is(test, "list")
  expect_length(test, 2L)
  expect_is(test$dataTypes, "character")
  expect_is(test$includeTree, "logical")

  vcr::use_cassette("bold_tax_name", {
    test_name <- bold_tax_name(name = c("Apis", "Puma concolor", "Pinus concolor"),
                          tax_division = "Animalia")
  })
  test <- bold_get_attr(test_name)
  expect_is(test, "list")
  expect_length(test, 2L)
  expect_named(test, c("errors", "params"))
  expect_is(test$errors, "list")
  expect_is(test$params, "list")
  expect_is(test$errors$`Pinus concolor`, "character")
  expect_is(test$params$fuzzy, "logical")
  expect_is(test$params$tax_division, "character")
  expect_is(test$params$tax_rank, "NULL")
  test <- bold_get_errors(test_name)
  expect_is(test, "list")
  expect_length(test, 1L)
  expect_is(test[[1]], "character")
  test <- bold_get_params(test_name)
  expect_is(test, "list")
  expect_length(test, 3L)
  expect_is(test$fuzzy, "logical")
  expect_is(test$tax_division, "character")
  expect_is(test$tax_rank, "NULL")
})
test_that("bold_get_* fails well", {
  expect_error(bold_get_attr(), "argument 'x' is missing, with no default")
  expect_error(bold_get_errors(), "argument 'x' is missing, with no default")
  expect_error(bold_get_params(), "argument 'x' is missing, with no default")
})

#' Get BOLD trace files
#'
#' @export
#' @template args
#' @references
#' \url{http://v4.boldsystems.org/index.php/resources/api?type=webservices}
#'
#' @param marker (character) Returns all records containing matching
#' marker codes.
#' @param dest (character) A directory to write the files to
#' @param overwrite (logical) Overwrite existing directory and file?
#' @param progress (logical) Print progress or not. NOT AVAILABLE FOR NOW.
#' HOPEFULLY WILL RETURN SOON.
#' @param ... Further args passed on to \code{\link[crul]{HttpClient}}
#' @param x Object to print or read.
#'
#' @examples \dontrun{
#' # Use a specific destination directory
#' bold_trace(taxon='Bombus', geo='Alaska', dest="~/mytarfiles")
#'
#' # Another example
#' # bold_trace(ids='ACRJP618-11', dest="~/mytarfiles")
#' # bold_trace(ids=c('ACRJP618-11','ACRJP619-11'), dest="~/mytarfiles")
#'
#' # read file in
#' x <- bold_trace(ids=c('ACRJP618-11','ACRJP619-11'), dest="~/mytarfiles")
#' (res <- read_trace(x$ab1[2]))
#'
#' # The progress dialog is pretty verbose, so quiet=TRUE is a nice touch,
#' # but not by default
#' # Beware, this one take a while
#' # x <- bold_trace(taxon='Osmia', quiet=TRUE)
#'
#' if (requireNamespace("sangerseqR", quietly = TRUE)) {
#'  library("sangerseqR")
#'  primarySeq(res)
#'  secondarySeq(res)
#'  head(traceMatrix(res))
#' }
#' }

bold_trace <- function(taxon = NULL, ids = NULL, bin = NULL, container = NULL,
  institutions = NULL, researchers = NULL, geo = NULL, marker = NULL, dest=NULL,
  overwrite = TRUE, progress = TRUE, ...) {

  if (!requireNamespace("sangerseqR", quietly = TRUE)) {
    stop("Please install sangerseqR", call. = FALSE)
  }

  args <- bc(list(taxon=pipeornull(taxon), geo=pipeornull(geo),
      ids=pipeornull(ids), bin=pipeornull(bin), container=pipeornull(container),
      institutions=pipeornull(institutions), researchers=pipeornull(researchers),
      marker=pipeornull(marker)))
  url <- crul::url_build(paste0(bbase(), 'API_Public/trace'), query = args)
  if (is.null(dest)) {
    destfile <- paste0(getwd(), "/bold_trace_files.tar")
    destdir <- paste0(getwd(), "/bold_trace_files")
  } else {
    destdir <- path.expand(dest)
    destfile <- paste0(destdir, "/bold_trace_files.tar")
  }
  dir.create(destdir, showWarnings = FALSE, recursive = TRUE)
  if (!file.exists(destfile)) file.create(destfile, showWarnings = FALSE)
  cli <- crul::HttpClient$new(url = url)
  res <- cli$get(disk = destfile, ...)
  utils::untar(destfile, exdir = destdir)
  files <- list.files(destdir, full.names = TRUE)
  ab1 <- list.files(destdir, pattern = ".ab1", full.names = TRUE)
  structure(list(destfile = destfile, destdir = destdir, ab1 = ab1,
                 args = args), class = "boldtrace")
}

#' @export
print.boldtrace <- function(x, ...){
  cat("\n<bold trace files>", "\n\n")
  ff <- x$ab1[1:min(10, length(x$ab1))]
  if (length(ff) < length(x$ab1)) ff <- c(ff, "...")
  cat(ff, sep = "\n")
}

#' @export
#' @rdname bold_trace
read_trace <- function(x){
  if (inherits(x, "boldtrace")) {
    if (length(x$ab1) > 1) stop("Number of paths > 1, just pass one in",
                                call. = FALSE)
    sangerseqR::readsangerseq(x$ab1)
  } else {
    sangerseqR::readsangerseq(x)
  }
}

context("bold_trace")
# vcr::vcr_configure(write_disk_path = "D:\\02_rOpenSci\\bold\\tests\\bold_trace_files")
test_that("bold_trace returns the correct object", {
  skip_on_cran()
  dest.dir <- vcr::vcr_configuration()$write_disk_path
  vcr::use_cassette("bold_trace", {
    test <- bold_trace(taxon = "Bombus ignitus", geo = "Japan", dest = file.path(dest.dir, "taxon"))
  })
  expect_is(test, "boldtrace")
  expect_is(test$destfile, "character")
  expect_is(test$destdir, "character")
  expect_is(test$ab1, "character")
  expect_length(test$ab1, 6L)
  expect_is(test$args, "character")
})
test_that("bold_trace returns the correct object (with ids)", {
  skip_on_cran()
  dest.dir <- vcr::vcr_configuration()$write_disk_path
  vcr::use_cassette("bold_trace", {
    test <- bold_trace(ids = c('ACRJP618-11','ACRJP619-11'), dest = file.path(dest.dir, "ids"))
  })
  expect_is(test, "boldtrace")
  expect_is(test$destfile, "character")
  expect_is(test$destdir, "character")
  expect_is(test$ab1, "character")
  expect_length(test$ab1, 3L)
  expect_is(test$args, "character")
})
test_that("print.bold_trace prints properly", {
  skip_on_cran()
  dest.dir <- vcr::vcr_configuration()$write_disk_path
  vcr::use_cassette("bold_trace", {
    test <- bold_trace(taxon = "Bombus ignitus", geo = "Japan", dest = file.path(dest.dir, "taxon"))
  })
  test <- capture.output(test)
  expect_is(test, "character")
  expect_length(test, 9L)
  expect_true(sum(!nzchar(test)) == 2)
  expect_true(sum(grepl(".ab1$", test)) == 6)
})
test_that("bold_read_trace works properly", {
  skip_on_cran()
  dest.dir <- vcr::vcr_configuration()$write_disk_path
  vcr::use_cassette(
    "bold_trace",
    {
      test <- bold_trace(taxon = "Bombus ignitus",
                         geo = "Japan",
                         dest = file.path(dest.dir, "taxon"))
  })
  test_trace <- bold_read_trace(test)
  expect_is(test_trace, "list")
  expect_length(test_trace, 6)
  expect_is(test_trace[[1]], "sangerseq")
  test_trace <- bold_read_trace(test$ab1[1:2])
  expect_is(test_trace, "list")
  expect_length(test_trace, 2)
  expect_is(test_trace[[1]], "sangerseq")
  # error in path file
  expect_warning(bold_read_trace(gsub("_F","", test$ab1[1])), "Couldn't find the trace file:")
  test_trace <- bold_read_trace(gsub("_F","", test$ab1[1]))
  expect_is(test_trace, "list")
  expect_length(test_trace, 1)
  expect_length(test_trace[[1]], 0)
})
test_that("bold_trace fails well", {
  expect_error(bold_trace(), "You must provide a non-empty value to at least one of")
  expect_error(bold_trace(taxon = ''), "You must provide a non-empty value to at least one of")
  expect_error(bold_trace(taxon = 5, geo = 1), "'taxon' and 'geo' must be of class character")
  expect_error(bold_trace(taxon = 'Coelioxys', overwrite = 5), "'overwrite' should be one of TRUE or FALSE")
  expect_error(bold_trace(taxon = 'Coelioxys', dest = TRUE), "'dest' must be of class character")
})

b_dataTypes <- c(
  "basic",
  "stats",
  "geo",
  "images",
  "sequencinglabs",
  "depository",
  "thirdparty",
  "all"
)
b_tax_division <- c("Animalia", "Protista", "Fungi", "Plantae")
b_tax_rank <-
  c(
    "kingdom",
    "phylum",
    "class",
    "order",
    "family",
    "subfamily",
    "tribe",
    "genus",
    "species",
    "subspecies"
  )
b_db <- c('COX1', 'COX1_SPECIES', 'COX1_SPECIES_PUBLIC', 'COX1_L640bp')

#' Search BOLD for taxonomy data by taxonomic name
#'
#' @param name (character) One or more scientific names. required.
#' @param fuzzy (logical) Whether to use fuzzy search or not (default: `FALSE`)
#' @param tax_division (character) Taxonomic division to filter the results.
#' @param tax_rank (character) Taxonomic rank to filter the results.
#' @template otherargs
#' @note The column 'specimenrecords' in the returned object represents the number of species records in BOLD's *Taxonomy Browser*, not the number of records in the *Public Data Portal*. To know the amount of public records available, use \code{\link{bold_stats}}.
#' @references
#' Taxonomy API: http://v4.boldsystems.org/index.php/resources/api?type=taxonomy
#' Taxonomy Browser: https://www.boldsystems.org/index.php/TaxBrowser_Home
#' Public Data Portal: https://www.boldsystems.org/index.php/Public_BINSearch?searchtype=records
#' @details The `dataTypes` parameter is not supported in this function.
#' If you want to use that parameter, get an ID from this function and pass
#' it into `bold_tax_id`, and then use the `dataTypes` parameter.
#' @seealso \code{\link{bold_tax_id}}, \code{\link{bold_get_attr}}, \code{\link{bold_get_errors}}, \code{\link{bold_get_params}}
#' @examples \dontrun{
#' bold_tax_name(name='Diplura')
#' bold_tax_name(name='Osmia')
#' bold_tax_name(name=c('Diplura','Osmia'))
#' bold_tax_name(name=c("Apis","Puma concolor","Pinus concolor"))
#' bold_tax_name(name='Diplur', fuzzy=TRUE)
#' bold_tax_name(name='Osm', fuzzy=TRUE)
#'
#' ## get http response object only
#' bold_tax_name(name='Diplura', response=TRUE)
#' bold_tax_name(name=c('Diplura','Osmia'), response=TRUE)
#'
#' ## Names with no data in BOLD database
#' bold_tax_name("Nasiaeshna pentacantha")
#' bold_tax_name(name = "Cordulegaster erronea")
#' bold_tax_name(name = "Cordulegaster erronea", response=TRUE)
#'
#' ## curl debugging
#' bold_tax_name(name='Diplura', verbose = TRUE)
#' }

#' @export
bold_tax_name <- function(name, fuzzy = FALSE, response = FALSE,
                          tax_division = NULL, tax_rank = NULL, ...) {
  if (missing(name)) stop("argument 'name' is missing, with no default")
  b_assert(name, "character", check.length = 0L)
  # fix for #84:
  name <- b_replace(name, "(?<=[^\\\\])'", "\\\\'")
  if (!missing(response)) response <- b_assert_logical(response)
  if (!missing(fuzzy)) fuzzy <- b_assert_logical(fuzzy)
  if (!missing(tax_division)) tax_division <- b_assert_tax_division(tax_division)
  if (!missing(tax_rank)) tax_rank <- b_assert_tax_rank(tax_rank)
  res <- lapply(b_nameself(name), function(x)
    b_GET(
      query = c(taxName = x, fuzzy = tolower(fuzzy)),
      api = "API_Tax/TaxonSearch",
      check = TRUE,
      ...
    ))
  if (response) {
    res
  } else {
    out <- b_rbind(lapply(res, b_process_tax_name,
                          tax_division = tax_division,
                          tax_rank = tax_rank),
                   idcol = "input")
    w <- lapply(res, `[[`, "warning")
    # using %in% to avoid NAs
    noMatchDiv <- out$taxid %in% -1L
    noMatchRank <- out$taxid %in% -2L
    noMatch <- out$taxid %in% -3L
    out$taxid[noMatchDiv | noMatchRank | noMatch] <- NA_integer_
    w[noMatchDiv] <- "Request returned no match with supplied 'tax_division'"
    w[noMatchRank] <- "Request returned no match with supplied 'tax_rank'"
    w[noMatch] <- "Request returned no match"
    attr(out, "errors") <- b_rm_empty(w)
    attr(out, "params") <- list(fuzzy = fuzzy,
                                tax_division = tax_division,
                                tax_rank = tax_rank)
    out
  }
}

b_process_tax_name <- function(x, tax_division, tax_rank) {
  if (!nzchar(x$warning)) {
    out <- b_parse(x$response, format = "json")
    if (length(out) && length(out$top_matched_names)) {
      out <- data.frame(out$top_matched_names)
      out.nms <- names(out)
      # see issue #84
      if (any(out.nms == "taxon")) out$taxon <- b_fix_taxonName(out$taxon)
      if (any(out.nms == "parentname")) out$parentname <- b_fix_taxonName(out$parentname)
      if (any(out.nms == "taxonrep")) out$taxonrep <- b_fix_taxonName(out$taxonrep)
      if (length(tax_division) && any(out.nms == "tax_division")) {
        if (sum(out$tax_division %in% tax_division)) {
          out <- out[out$tax_division %in% tax_division,]
        } else {
          out <- data.frame(taxid = -1L) # request returned no match with supplied tax_division
        }
      }
      if (length(tax_rank)  && any(out.nms == "tax_rank")) {
        if (sum(out$tax_rank %in% tax_rank)) {
          out <- out[out$tax_rank %in% tax_rank,]
        } else {
          out <- data.frame(taxid = -2L) # request returned no match with supplied tax_rank
        }
      }
    } else {
      out <- data.frame(taxid = -3L) # request returned no match
    }
  } else {
    out <- data.frame(taxid = NA_integer_) # resquest had an error
  }
  out
}

context("bold_tax_name")

test_that("bold_tax_name returns the correct object", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_name", {
    test <- bold_tax_name(name = "Diplura")
  })
  expect_is(test, "data.frame")
  expect_is(test$input, "character")
  expect_is(test$taxid, "integer")
})
test_that("bold_tax_name returns the correct object (multiple names)", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_name", {
    test <- bold_tax_name(name = c("Apis", "Puma concolor", "Pinus concolor"))
  })
  expect_is(test, "data.frame")
  expect_is(test$input, "character")
  expect_is(test$taxid, "integer")
})
test_that("bold_tax_name returns the correct object (using filters)", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_name", {
    test <- bold_tax_name(name = "Actinocephalus", tax_rank = "genus")
  })
  expect_is(test, "data.frame")
  expect_is(test$input, "character")
  expect_is(test$taxid, "integer")
  expect_equal(NROW(test), 2)
  expect_equal(unique(test$tax_rank), "genus")

  vcr::use_cassette("bold_tax_name", {
    test <- bold_tax_name(name = "Actinocephalus", tax_division = "Protista")
  })
  expect_is(test, "data.frame")
  expect_is(test$input, "character")
  expect_is(test$taxid, "integer")
  expect_equal(NROW(test), 1)
  expect_equal(test$tax_division, "Protista")
})

test_that("bold_tax_name returns the correct object (when taxon not found)", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_name", {
    test <- bold_tax_name(name = "Actino")
  })
  expect_is(test, "data.frame")
  expect_is(test$input, "character")
  expect_is(test$taxid, "integer")
  expect_true(is.na(test$taxid))
})
test_that("bold_tax_name returns the correct object (response)", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_name", {
    test <- bold_tax_name(name = "Diplura", response = TRUE)
  })
  expect_is(test, "list")
  test <- test[["Diplura"]]
  expect_length(test, 2)
  expect_is(test$response, "HttpResponse")
  expect_equal(test$response$status_code, 200)
  expect_equal(test$response$response_headers$`content-type`, "text/html; charset=utf-8")
  expect_is(test$response$response_headers, "list")
  expect_is(test$warning, "character")
  expect_equal(test$warning, "")
})
test_that("bold_tax_name 'fuzzy' param works", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_name", {
    test <- bold_tax_name(name = "Diplur", fuzzy = TRUE)
    test_not <- bold_tax_name(name = "Diplur", fuzzy = FALSE)
  })
  expect_is(test, "data.frame")
  expect_is(test$input, "character")
  expect_gt(NROW(test), NROW(test_not))
})

test_that("bold_tax_name works when  'name' containts single quotes", {
  skip_on_cran()
  # see issue 84
  vcr::use_cassette("bold_tax_name", {
    test <-
      bold_tax_name(name = c(
        "Diplurodes sp.",
        "Chlamydomonas sp. 18 (FA)",
        "Chlamydomonas sp. 'Chile J'"
      ))
  })
  expect_is(test, "data.frame")
  expect_is(test$input, "character")
  expect_equal(test$input, test$taxon)
  expect_true(all(test$input == test$taxonrep, na.rm = TRUE))
})
test_that("bold_tax_name fails well", {
  # name required
  expect_error(bold_tax_name(), "argument 'name' is missing, with no default")
  # catch wrong type param inputs
  expect_error(bold_tax_name(name = "Diplur", response = 5),
               "'response' should be one of TRUE or FALSE")
  expect_error(bold_tax_name(name = "Diplur", fuzzy = 5),
               "'fuzzy' should be one of TRUE or FALSE")
  expect_error(
    bold_tax_name(name = "Diplur", tax_division = 5),
    "'tax_division' must be of class character"
  )
  expect_error(
    bold_tax_name(name = "Diplur", tax_division = "Mushrooms"),
    "is not a valid tax_division"
  )
  expect_error(bold_tax_name(name = "Diplur", tax_rank = 5),
               "'tax_rank' must be of class character")
  expect_error(bold_tax_name(name = "Diplur",
                             tax_rank = c("genus", "notArank")),
               "is not a valid tax_rank")
})

b_extract <- function(str, pattern, mode = "all",
                      fixed = FALSE, simplify = TRUE, ...) {
  switch(mode,
         first = {
           if (!fixed)
             stringi::stri_extract_first_regex(str = str, pattern = pattern, ...)
           else
             stringi::stri_extract_first_fixed(str = str, pattern = pattern, ...)
         },
         last = {
           if (!fixed)
             stringi::stri_extract_last_regex(str = str, pattern = pattern, ...)
           else
             stringi::stri_extract_last_fixed(str = str, pattern = pattern, ...)
         },
         all = {
           if (!fixed)
             stringi::stri_extract_all_regex(str = str,
                                             pattern = pattern,
                                             simplify = simplify,
                                             ...)
           else
             stringi::stri_extract_all_fixed(str = str,
                                             pattern = pattern,
                                             simplify = simplify,
                                             ...)
         },
         str)
}
b_words <- function(str, mode = "first", ...) {
  switch(mode,
         first = stringi::stri_extract_first_words(str = str, ...),
         last = stringi::stri_extract_last_words(str = str, ...),
         all = stringi::stri_extract_all_words(str = str, ...),
         str
  )
}
b_replace <- function(str, pattern, replacement, fixed = FALSE, ...) {
  if (!fixed)
    stringi::stri_replace_all_regex(str = str, pattern = pattern,
                                    replacement = replacement, ...)
  else
    stringi::stri_replace_all_fixed(str = str, pattern = pattern,
                                    replacement = replacement, ...)
}
b_detect <- function(str, pattern, fixed = FALSE, ...) {
  if (!fixed)
    stringi::stri_detect_regex(str = str, pattern = pattern, ...)
  else
    stringi::stri_detect_fixed(str = str, pattern = pattern, ...)
}
b_split <- function(str, pattern, fixed = FALSE, ...) {
  if (!fixed)
    stringi::stri_split_regex(str = str, pattern = pattern, ...)
  else
    stringi::stri_split_fixed(str = str, pattern = pattern, ...)
}
b_count <- function(str, pattern, fixed = FALSE, ...) {
  if (!fixed)
    stringi::stri_count_regex(str = str, pattern = pattern, ...)
  else
    stringi::stri_count_fixed(str = str, pattern = pattern, ...)
}
b_drop <- function(str, pattern) {
  to <- stringi::stri_locate_first_fixed(str = str, pattern = pattern)[[1]] - 1L
  stringi::stri_sub(str = str, to = to)
}
b_lines <- function(str) {
  stringi::stri_split_lines1(str = str)
}

#' Get BOLD specimen + sequence data.
#'
#' @template args
#' @template otherargs
#' @param marker (character) Returns all records containing matching marker
#' codes. See Details.
#' @param format (character) One of xml or tsv (default). tsv format gives
#' back a data.frame object. xml gives back parsed xml as a list.
#' @param sepfasta (logical) If `TRUE`, the fasta data is separated into
#' a list with names matching the processid's for each records. Works with both 'tsv' and 'xml' format.
#' Note: This means multiple sequences can have the same name if a process id has multiple sequences.
#' Default: `FALSE`
#' @param cleanData (logical) If `TRUE`, the cell values containing only duplicated values (ex : "COI-5P|COI-5P|COI-5P") will be reduce to one value ("COI-5P") and empty string will be change to NA. Default: `FALSE`
#'
#' @template large-requests
#' @template marker
#' @template missing-taxon
#' @references
#' http://v4.boldsystems.org/index.php/resources/api?type=webservices
#'
#' @return Either a data.frame, parsed xml, a http response object, or a list
#' of length two (data: a data.frame w/o nucleotide column, and fasta: a list
#' of nucleotides with the processid as name)
#'
#' @examples \dontrun{
#' bold_seqspec(taxon='Osmia')
#' bold_seqspec(taxon='Osmia', format='xml')
#' bold_seqspec(taxon='Osmia', response=TRUE)
#' res <- bold_seqspec(taxon='Osmia', sepfasta=TRUE)
#' res$fasta[1:2]
#' res$fasta['GBAH0293-06']
#'
#' # records that match a marker name
#' res <- bold_seqspec(taxon="Melanogrammus aeglefinus", marker="COI-5P")
#'
#' # records that match a geographic locality
#' res <- bold_seqspec(taxon="Melanogrammus aeglefinus", geo="Canada")
#'
#' ## curl debugging
#' ### You can do many things, including get verbose output on the curl call,
#' ### and set a timeout
#' head(bold_seqspec(taxon='Osmia', verbose = TRUE))
#' head(bold_seqspec(taxon='Osmia', timeout_ms = 1))
#' }
#'
#' @export
bold_seqspec <- function(taxon = NULL, ids = NULL, bin = NULL, container = NULL,
                         institutions = NULL, researchers = NULL, geo = NULL,
                         marker = NULL, response = FALSE, format = 'tsv',
                         sepfasta = FALSE, cleanData = FALSE, ...) {
  format <- b_assert_format(format)
  response <- b_assert_logical(response)
  sepfasta <- b_assert_logical(sepfasta)
  cleanData <- b_assert_logical(cleanData)
  params <- b_pipe_params(
      taxon = taxon,
      geo = geo,
      ids = ids,
      bin = bin,
      container = container,
      institutions = institutions,
      researchers = researchers,
      marker = marker
    )
  res <- b_GET(query = c(params, format = format),
               api = 'API_Public/combined', ...)
  if (response) {
    res
  } else {
    out <- b_parse(res, format, cleanData, raise = TRUE)
    if (!sepfasta)
      out
    else
      b_sepFasta(out, format = format)
  }
}
#' Seperate sequences (fasta) from `bold_seqspec` output.
#'
#' @param x      (object) The output of a `bold_seqspec` call.
#' @param format (character) The format used in the `bold_seqspec` call. One of 'tsv' (default) or 'xml'.
#'
#' @return A list of length two : the specimen data and the sequences list.
#'
#' @examples \dontrun{
#' res <- bold_seqspec(taxon='Osmia')
#' res <- b_sepFasta(res)
#' # (same as bold_seqspec(taxon='Osmia', sepFasta = TRUE))
#' }
#' @export
b_sepFasta <- function(x, format = "tsv"){
  switch(format,
         tsv = {
           list(data = x[, !names(x) %in% "nucleotides"],
                fasta = `names<-`(as.list(x$nucleotides),
                                  x$processid))
         },
         xml = {
           recs <- xml2::xml_find_all(x, "//processid")
           fasta <- list()
           # must be for loop so record without sequences are also included (so the behavior is the same as when format is 'tsv')
           for (rec in recs) {
             seq <-  xml2::xml_text(xml2::xml_find_all(rec, "..//nucleotides"))
             n <- length(seq)
             len <- length(fasta) + 1
             if (n) {
              fasta[len:(len + n - 1)] <- as.list(seq)
              names(fasta)[len:(len + n - 1)] <- xml2::xml_text(rec)
             } else {
               fasta[[len]] <- list(NULL)
               names(fasta[[len]]) <- xml2::xml_text(rec)
             }

           }
           # not removing nucleotides since xml2::xml_remove advise against it
           list(data = x, fasta = fasta)
         }
  )
}

context("bold_filter")

test_that("bold_filter works as expected", {
  vcr::use_cassette("bold_seqspec", {
    test_data <- bold_seqspec(taxon = "Coelioxys")
  })

  # max
  test <- bold_filter(test_data, by = "species_name")

  expect_is(test, "data.frame")
  expect_gt(NROW(test), 10)
  expect_gt(NCOL(test), 10)
  expect_equal(length(unique(test$species_name)), NROW(test))

  # actually got max
  taxon <- "Coelioxys elongata"
  o_lens <- nchar(test_data[test_data$species_name == taxon, "nucleotides", drop = TRUE])
  new_lens <- nchar(test[test$species_name == taxon, "nucleotides", drop = TRUE])
  expect_equal(new_lens, max(o_lens))


  # min
  test <- bold_filter(as.matrix(test_data), by = "species_name", how = "min")

  expect_is(test, "data.frame")
  expect_gt(NROW(test), 10)
  expect_gt(NCOL(test), 10)
  expect_equal(length(unique(test$species_name)), NROW(test))

  # actually got max
  new_lens <- nchar(test[test$species_name == taxon, "nucleotides", drop = TRUE])
  expect_equal(new_lens, min(o_lens))
})

test_that("bold_filter returns fails well", {
  expect_error(bold_filter(), "argument 'x' is missing")
  expect_error(bold_filter(x = 5, by = 1), "'x' must be of class data.frame or matrix")
  expect_error(bold_filter(x = mtcars, by = "foobar"),
               "'foobar' is not a valid column in 'x'")
  expect_error(bold_filter(x = mtcars, "mpg", "adf"),
               "'how' must be one of 'min' or 'max'")
})

context("bold_seqspec")

test_that("bold_seqspec returns the correct object", {
  skip_on_cran()
  vcr::use_cassette("bold_seqspec", {
    test <- bold_seqspec(taxon = 'Coelioxys')
  })
  expect_is(test, "data.frame")
  expect_is(test$recordID, "integer")
  expect_is(test$directions, "character")
})

test_that("bold_seqspec returns the correct object (response)", {
  skip_on_cran()
  vcr::use_cassette("bold_seqspec", {
    test <- bold_seqspec(taxon = 'Coelioxys', response = TRUE)
  })
  expect_equal(test$status_code, 200)
  expect_equal(test$response_headers$`content-type`, "application/x-download")
  expect_is(test, "HttpResponse")
  expect_is(test$response_headers, "list")
})

test_that("bold_seqspec returns the correct object (cleanData)", {
  skip_on_cran()
  vcr::use_cassette("bold_seqspec", {
    test <- bold_seqspec(taxon = 'Coelioxys', cleanData = TRUE)
  })
  expect_is(test, "data.frame")
  expect_is(test$recordID, "integer")
  expect_is(test$directions, "character")
  expect_false(any(test == "", na.rm = TRUE))
})

test_that("bold_seqspec returns the correct object (sepFasta)", {
  skip_on_cran()
  vcr::use_cassette("bold_seqspec", {
    test <- bold_seqspec(taxon = 'Coelioxys', sepfasta = TRUE)
  })
  expect_is(test, "list")
  expect_is(test$data, "data.frame")
  expect_is(test$fasta, "list")
  expect_is(test$fasta[[1]], "character")
  expect_equal(nrow(test$data), length(test$fasta))
})
test_that("bold_seqspec returns the correct object (sepFasta, xml)", {
  skip_on_cran()
  vcr::use_cassette("bold_seqspec", {
    test <- bold_seqspec(taxon = 'Coelioxys', sepfasta = TRUE, format = "xml")
  })
  expect_is(test, "list")
  expect_is(test$data, "xml_document")
  expect_is(test$fasta, "list")
  expect_is(test$fasta[[1]], "character")
  expect_equal(length(xml2::xml_children(test$data)), length(test$fasta))
})

test_that("bold_seq fails well", {
  expect_error(bold_seqspec(taxon = ''), "You must provide a non-empty value to at least one of")
  expect_error(bold_seqspec(), "You must provide a non-empty value to at least one of")
})

#' @title bold
#' @description bold: A programmatic interface to the Barcode of Life data
#' @section About:
#'
#' This package gives you access to data from BOLD System
#' http://www.boldsystems.org/ via their API
#' (http://v4.boldsystems.org/index.php/api_home)
#'
#' @section Functions:
#'
#' - [bold_specimens()] - Search for specimen data
#' - [bold_seq()] - Search for and retrieve sequences
#' - [bold_seqspec()] - Get sequence and specimen data together
#' - [bold_trace()] - Get trace files - saves to disk
#' - [read_trace()] - Read trace files into R
#' - [bold_tax_name()] - Get taxonomic names via input names
#' - [bold_tax_id()] - Get taxonomic names via BOLD identifiers
#' - [bold_identify()] - Search for match given a COI sequence
#'
#' Interestingly, they provide xml and tsv format data for the specimen data,
#' while  they provide fasta data format for the sequence data. So for the
#' specimen data  you can get back raw XML, or a data frame parsed from the
#' tsv data, while for sequence data you get back a list (b/c sequences are
#' quite long and would make a data frame unwieldy).
#'
#' @importFrom crul HttpClient url_build
#' @importFrom xml2 read_xml xml_find_all xml_find_first xml_text
#' xml_name as_list
#' @importFrom jsonlite fromJSON
#' @importFrom reshape sort_df
#' @importFrom plyr rbind.fill
#' @docType package
#' @name bold-package
#' @aliases bold
NULL

#' List of 3 nucleotide sequences to use in examples for the
#' [bold_identify()] function
#'
#' @details Each sequence is a character string, of lengths 410, 600, and 696.
#' @name sequences
#' @docType data
#' @keywords data
NULL

#' Search BOLD for taxonomy data by BOLD ID.
#'
#' @param id (integer) One or more BOLD taxonomic identifiers. required.
#' @param dataTypes (character) Specifies the datatypes that will be
#' returned. 'all' returns all data. 'basic' returns basic taxon information.
#' 'images' returns specimen images.
#' @param includeTree (logical) If `TRUE` (default: `FALSE`), returns a list
#' containing information for parent taxa as well as the specified taxon.
#' @template otherargs
#'
#' @name bold_tax_id-deprecated
#' @seealso \code{\link{bold-deprecated}}
#' @keywords internal
NULL

#' @rdname bold-deprecated
#' @section \code{bold_tax_id}:
#' For \code{bold_tax_id}, use \code{\link{bold_tax_id2}}.
#'
#' @references
#' http://v4.boldsystems.org/index.php/resources/api?type=taxonomy
#' @seealso [bold_tax_name()]
#' @examples \dontrun{
#' bold_tax_id(id = 88899)
#' bold_tax_id(id = 88899, includeTree = TRUE)
#' bold_tax_id(id = 88899, includeTree = TRUE, dataTypes = "stats")
#' bold_tax_id(id = c(88899,125295))
#'
#' ## dataTypes parameters
#' bold_tax_id(id = 88899, dataTypes = "basic")
#' bold_tax_id(id = 88899, dataTypes = "stats")
#' bold_tax_id(id = 88899, dataTypes = "images")
#' bold_tax_id(id = 88899, dataTypes = "geo")
#' bold_tax_id(id = 88899, dataTypes = "sequencinglabs")
#' bold_tax_id(id = 88899, dataTypes = "depository")
#' bold_tax_id(id = c(88899, 125295), dataTypes = "geo")
#' bold_tax_id(id = c(88899, 125295), dataTypes = "images")
#'
#' ## Passing in NA
#' bold_tax_id(id = NA)
#' bold_tax_id(id = c(88899, 125295, NA))
#'
#' ## get http response object only
#' bold_tax_id(id = 88899, response=TRUE)
#' bold_tax_id(id = c(88899, 125295), response=TRUE)
#'
#' ## curl debugging
#' bold_tax_id(id = 88899, verbose = TRUE)
#' }
#'
#' @export
bold_tax_id <- function(id, dataTypes = "basic", includeTree = FALSE,
                        response = FALSE, ...) {
  .Deprecated("bold_tax_id2")
  #-- arguments check
  if (missing(id)) stop("argument 'id' is missing, with no default")
  if (!grepl("true|false", includeTree, ignore.case = TRUE))
    warning("'includeTree' should be either TRUE or FALSE.")
  if (!inherits(id, c("character", "numeric", "integer")))
    warning("'id' should be of class character, numeric or integer.")
  #-- make sure user have correct data types
  dataTypes <- .check_dataTypes_dep(dataTypes)
  if (!nzchar(dataTypes)) {
    out <- data.frame(input = id, noresults = NA)
  } else {
    #-- prep query parameters
    params <- list(dataTypes = dataTypes, includeTree = tolower(includeTree))
    #-- make URL
    URL <- b_url("API_Tax/TaxonData")
    #-- fetch data from the api
    res <- lapply(`names<-`(id, id), function(x) {
      # no need to do the call if id is NA
      if (is.na(x))
        data.frame(input = NA, noresults = NA)
      else
        .get_response_dep(args = c(taxId = x, params), url = URL, ...)
    })
    if (response) {
      out <- res
    } else {
      out <- b_rbind(mapply(FUN = .process_response_dep, x = res, y = id,
                             MoreArgs = list(z = includeTree, w = dataTypes),
                             SIMPLIFY = FALSE))
      if (NCOL(out) == 1) {
        out$noresults <- NA
      }
    }
  }
  out
}
.process_response_dep <- function(x, y, z, w){
  if (is.data.frame(x)) return(x)
  tt <- rawToChar(x$content)
  out <- if (x$status_code > 202) "stop" else jsonlite::fromJSON(tt)
  if ( length(out) == 0 || identical(out[[1]], list()) || any(out == "stop") ) {
    data.frame(input = y, stringsAsFactors = FALSE)
  } else {
    if (w %in% c("stats",'images','geo','sequencinglabs','depository')) out <- out[[1]]
    trynames <- tryCatch(as.numeric(names(out)), warning = function(w) w)
    if (!inherits(trynames, "simpleWarning")) names(out) <- NULL
    if (any(vapply(out, function(x) is.list(x) && length(x) > 0, logical(1)))) {
      out <- lapply(out, function(x) Filter(length, x))
    } else {
      out <- Filter(length, out)
    }
    if (!is.null(names(out))) {
      df <- data.frame(out, stringsAsFactors = FALSE)
    } else {
      df <- b_rbind(lapply(out, data.frame, stringsAsFactors = FALSE))
    }
    row.names(df) <- NULL
    if ("parentid" %in% names(df)) df <- df[order(df[,"parentid"]),]
    row.names(df) <- NULL
    data.frame(input = y, df, stringsAsFactors = FALSE)
  }
}
.get_response_dep <- function(args, url, ...){
  cli <- crul::HttpClient$new(url = url)
  out <- cli$get(query = args, ...)
  out$raise_for_status()
  stopifnot(out$headers$`content-type` == 'text/html; charset=utf-8')
  return(out)
}
.check_dataTypes_dep <- function(x){
  x <- b_split(x, ",", fixed = TRUE, simplify = TRUE)
  # corrects for the json typo in case the option is taken from a previous query
  x[x == "depositories"] <- "depository"
  if (length(x) > 1 && any(x == "all")) {
    x <- "all"
  } else {
    wrongType <- !x %in% b_dataTypes
    if (any(wrongType)) {
      warning(b_ennum(x[wrongType], quote = TRUE),
              if (sum(wrongType) > 1) " are not valid data types"
              else " is not a valid data type",
              if (!all(wrongType)) " and will be skipped." else ".",
              "\nChoices are:",
              b_ennum(b_dataTypes, "or", TRUE))
      x <- x[!wrongType]
    }
    x <- paste(x, collapse = ",")
  }
  x
}

context("bold_tax_id")

test_that("bold_tax_id returns the correct object (one ID)", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_id2", {
    test <- bold_tax_id(id = 88899)
  })
  expect_is(test, "data.frame")
  expect_is(test$input, "numeric")
  expect_is(test$taxid, "integer")
  expect_is(test$tax_rank, "character")
  expect_equal(test$taxid, test$input)
  expect_equal(NROW(test), 1)
})
test_that("bold_tax_id returns the correct object (multiple IDs)", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_id2", {
    test <- bold_tax_id(id = c(88899, 125295))
  })
  expect_is(test, "data.frame")
  expect_equal(NROW(test), 2)
  expect_equal(test$taxid, test$input)
})
test_that("bold_tax_id returns the correct object (multiple IDs, but one NA)", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_id2", {
    test <- bold_tax_id(id = c(88899, 125295, NA))
  })
  expect_is(test, "data.frame")
  expect_equal(NROW(test), 3)
  expect_equal(test$taxid, test$input)
})

test_that("bold_tax_id returns the correct object (one ID, but NA)", {
  skip_on_cran()
  test <- bold_tax_id(id = NA)
  expect_is(test, "data.frame")
  expect_equal(NROW(test), 1)
  expect_length(test, 2)
  expect_named(test, c("input", "noresults"))
})

test_that("bold_tax_id returns the correct object (response)", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_id2", {
    test <- bold_tax_id(id = 88899, response = TRUE)
  })
  expect_is(test, "list")
  test <- test[["88899"]]
  expect_is(test, "HttpResponse")
  expect_equal(test$status_code, 200)
  expect_equal(test$response_headers$`content-type`, "text/html; charset=utf-8")
  expect_is(test$response_headers, "list")
})

test_that("bold_tax_id 'dataTypes' param works as expected (stats)", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_id2", {
    test <- bold_tax_id(id = 88899, dataTypes = "stats")
  })
  expect_is(test, "data.frame")
  expect_equal(NROW(test), 1)
})
test_that("bold_tax_id 'dataTypes' param works as expected (stats without public marker seqs)", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_id2", {
    test <- bold_tax_id(id = 660837, dataTypes = "stats")
  })
  expect_is(test, "data.frame")
  expect_equal(NROW(test), 1)
})
test_that("bold_tax_id 'dataTypes' param works as expected (geo)", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_id2", {
    test <- bold_tax_id(id = 88899, dataTypes = "geo")
  })
  expect_is(test, "data.frame")
  expect_equal(NROW(test), 1)
  expect_equal(ncol(test), 9)
})
test_that("bold_tax_id 'dataTypes' param works as expected (sequencinglabs)", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_id2", {
    test <- bold_tax_id(id = 88899, dataTypes = "sequencinglabs")
  })
  expect_is(test, "data.frame")
  expect_equal(NROW(test), 1)
})
test_that("bold_tax_id 'dataTypes' param works as expected (all)", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_id2", {
    test <- bold_tax_id(id = 88899, dataTypes = "all")
  })
  expect_is(test, "data.frame")
  expect_equal(NROW(test), 1)
})
test_that("bold_tax_id 'dataTypes' param works as expected (basic & stats)", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_id2", {
    test <- bold_tax_id(id = 660837, dataTypes = c("basic,stats"))
  })
  expect_is(test, "data.frame")
  expect_equal(NROW(test), 1)
})
test_that("bold_tax_id 'includeTree' param works as expected", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_id2", {
    test <- bold_tax_id(id = 88899, includeTree = TRUE)
  })
  expect_is(test, "data.frame")
  expect_equal(NROW(test), 5)
})
test_that("bold_tax_id 'includeTree' param works as expected (with 2 dataTypes)", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_id2", {
    test <- bold_tax_id(id = 88899, dataTypes = "basic,geo", includeTree = TRUE)
  })
  expect_is(test, "data.frame")
  expect_equal(NROW(test), 5)
})
test_that("bold_tax_id fails well", {
  expect_error(bold_tax_id(), "argument 'id' is missing, with no default")
  expect_warning(bold_tax_id(id = 88899, dataTypes = 5), "'5' is not a valid data type")
  expect_warning(bold_tax_id(id = 88899, dataTypes = "basics"), "'basics' is not a valid data type")
  expect_warning(bold_tax_id(id = 88899, includeTree = 5), "'includeTree' should be either TRUE or FALSE")
  expect_warning(bold_tax_id(id = ""), "'bold_tax_id' is deprecated")
})

#' Add taxonomic parent names to a data.frame
#'
#' @export
#' @param x (data.frame/list) list of data.frames - the output from a call to
#' \code{\link{bold_identify}}. or a single data.frame from the output from
#' same. required.
#' @param wide (logical) output in long or wide format. See Details.
#' Default: \code{FALSE}
#' @param taxid  (character) A taxid name. Optional. See `Filtering` below.
#' @param taxon (character) A taxon name. Optional. See `Filtering` below.
#' @param tax_rank (character) A tax_rank name. Optional. See `Filtering` 
#' below.
#' @param tax_division (character) A tax_division name. Optional. See 
#' `Filtering` below.
#' @param parentid (character) A parentid name. Optional. See `Filtering` 
#' below.
#' @param parentname (character) A parentname name. Optional. See `Filtering` 
#' below.
#' @param taxonrep (character) A taxonrep name. Optional. See `Filtering` 
#' below.
#' @param specimenrecords (character) A specimenrecords name. Optional. 
#' See `Filtering` below.
#' @param ... Further args passed on to \code{\link[crul]{verb-GET}}, main 
#' purpose being curl debugging
#' 
#' @details This function gets unique set of taxonomic names from the input
#' data.frame, then queries \code{\link{bold_tax_name}} to get the
#' taxonomic ID, passing it to \code{\link{bold_tax_id}} to get the parent
#' names, then attaches those to the input data.
#'
#' Records in the input data that do not have matches for parent names
#' simply get NA values in the added columns.
#'
#' @section Filtering:
#' The parameters `taxid`, `taxon`, `tax_rank`, `tax_division`, 
#' `parentid`, `parentname`,`taxonrep`, and `specimenrecords` are not used 
#' in the search sent to BOLD, but are used in filtering the data down 
#' to a subset that is closer to the target you want. For all these 
#' parameters, you can use regex strings since we use [grep()] internally 
#' to match. Filtering narrows down to the set that matches your query, 
#' and removes the rest. The data.frame that we filter on with these 
#' parameters internally is the result of a call to the [bold_tax_name()]
#' function. 
#' 
#' @section wide vs long format:
#' When \code{wide = FALSE} you get many rows for each record. Essentially,
#' we \code{cbind} the taxonomic classification onto the one row from the
#' result of \code{\link{bold_identify}}, giving as many rows as there are
#' taxa in the taxonomic classification.
#'
#' When \code{wide = TRUE} you get one row for each record - thus the
#' dimensions of the input data stay the same. For this option, we take just
#' the rows for taxonomic ID and name for each taxon in the taxonomic
#' classification, and name the columns by the taxon rank, so you get
#' \code{phylum} and \code{phylum_id}, and so on.
#'
#' @return a list of the same length as the input
#'
#' @examples \dontrun{
#' df <- bold_identify(sequences = sequences$seq2)
#'
#' # long format
#' out <- bold_identify_parents(df)
#' str(out)
#' head(out[[1]])
#'
#' # wide format
#' out <- bold_identify_parents(df, wide = TRUE)
#' str(out)
#' head(out[[1]])
#' 
#' x <- bold_seq(taxon = "Satyrium")
#' out <- bold_identify(c(x[[1]]$sequence, x[[13]]$sequence))
#' res <- bold_identify_parents(out)
#' res
#' 
#' x <- bold_seq(taxon = 'Diplura')
#' out <- bold_identify(vapply(x, "[[", "", "sequence")[1:20])
#' res <- bold_identify_parents(out)
#' }
bold_identify_parents <- function(x, wide = FALSE, taxid = NULL, 
  taxon = NULL, tax_rank = NULL, tax_division = NULL, parentid = NULL, 
  parentname = NULL, taxonrep = NULL, specimenrecords = NULL, ...) {
  UseMethod("bold_identify_parents")
}

#' @export
bold_identify_parents.default <- function(x, wide = FALSE, taxid = NULL, 
  taxon = NULL, tax_rank = NULL, tax_division = NULL, parentid = NULL, 
  parentname = NULL, taxonrep = NULL, specimenrecords = NULL, ...) {
  stop("no 'bold_identify_parents' method for ", class(x)[1L], call. = FALSE)
}

#' @export
bold_identify_parents.data.frame <- function(x, wide = FALSE, taxid = NULL, 
  taxon = NULL, tax_rank = NULL, tax_division = NULL, parentid = NULL, 
  parentname = NULL, taxonrep = NULL, specimenrecords = NULL, ...) {
  bold_identify_parents(list(x), wide, taxid, taxon, tax_rank, 
    tax_division, parentid, parentname, taxonrep, specimenrecords)
}

#' @export
bold_identify_parents.list <- function(x, wide = FALSE, taxid = NULL, 
  taxon = NULL, tax_rank = NULL, tax_division = NULL, parentid = NULL, 
  parentname = NULL, taxonrep = NULL, specimenrecords = NULL, ...) {

  assert(wide, "logical")

  # get unique set of names
  uniqnms <-
    unique(unname(unlist(lapply(x, function(z) z$taxonomicidentification))))
  if (is.null(uniqnms)) {
    stop("no fields 'taxonomicidentification' found in input", call. = FALSE)
  }

  # get parent names via bold_tax_name and bold_tax_id
  out <- stats::setNames(lapply(uniqnms, function(w) {
    tmp <- bold_tax_name(w, ...)
    # if length(tmp) > 1, user decides which one
    if (NROW(tmp) > 1) {
      tmp <- filt(tmp, "taxid", taxid)
      tmp <- filt(tmp, "taxon", taxon)
      tmp <- filt(tmp, "tax_rank", tax_rank)
      tmp <- filt(tmp, "tax_division", tax_division)
      tmp <- filt(tmp, "parentid", parentid)
      tmp <- filt(tmp, "parentname", parentname)
      tmp <- filt(tmp, "taxonrep", taxonrep)
      tmp <- filt(tmp, "specimenrecords", specimenrecords)
    }
    if (!is.null(tmp$taxid)) {
      tmp2 <- bold_tax_id(tmp$taxid, includeTree = TRUE, ...)
      tmp2$input <- NULL
      return(tmp2)
    } else {
      NULL
    }
  }), uniqnms)
  # remove length zero elements
  out <- bc(out)

  # appply parent names to input data
  lapply(x, function(z) {
    if (is.null(z)) return(NULL)
    if (wide) {
      # replace each data.frame with a wide version with just
      # taxid and taxon name (with col names with rank name)
      out <- lapply(out, function(h) do.call("cbind", (apply(h, 1, function(x) {
        tmp <- as.list(x[c("taxid", "taxon")])
        tmp$taxid <- as.numeric(tmp$taxid)
        data.frame(stats::setNames(tmp, paste0(x["tax_rank"], c("_id", ""))),
                   stringsAsFactors = FALSE)
      }))))
    }
    zsplit <- split(z, z$ID)
    setrbind(
      bc(lapply(zsplit, function(w) {
        tmp <- out[names(out) %in% w$taxonomicidentification]
        if (!length(tmp)) return(w)
        suppressWarnings(cbind(w, tmp[[1]]))
      }))
    )
  })
}

# function to help filter get_*() functions for a rank name or rank itself ---
filt <- function(df, col, z) {
  assert_param(z, deparse(substitute(z)), "character")
  if (NROW(df) == 0) {
    df
  } else {
    if (is.null(z)) return(df)
    mtch <- grep(sprintf("%s", tolower(z)), tolower(df[, col]))
    if (length(mtch) != 0) {
      df[mtch, ]
    } else {
      data.frame(NULL)
    }
  }
}

context("bold_identify_parents")

# bold_identify_list <- bold_identify(sequences = sequences$seq2)
# save(bold_identify_list, file = "tests/testthat/bold_identify_list.rda")
# load("tests/testthat/bold_identify_list.rda")
load("bold_identify_list.rda")

test_that("bold_identify_parents works as expected", {
  vcr::use_cassette("bold_identify_parents", {
    test <- bold_identify_parents(bold_identify_list)
  })
  expect_is(test, "list")
  expect_equal(length(test), 1)
  expect_is(test[[1]], "data.frame")
  expect_gt(NROW(test[[1]]), 100)
  expect_is(test[[1]]$ID, "character")
  expect_is(test[[1]]$sequencedescription, "character")
  expect_lt(length(unique(test[[1]]$ID)), length(test[[1]]$ID))
})

test_that("bold_identify_parents return response", {
  vcr::use_cassette("bold_identify_parents", {
    test <- bold_identify_parents(bold_identify_list, wide = TRUE)
  })
  expect_is(test, "list")
  expect_equal(length(test), 1)
  expect_is(test[[1]], "data.frame")
  expect_gt(NROW(test[[1]]), 10)
  expect_equal(length(unique(test[[1]]$ID)), length(test[[1]]$ID))
})

test_that("bold_identify_parents fails well", {
  # x required
  expect_error(bold_identify_parents(), "argument \"x\" is missing")
  # only supported types
  expect_error(bold_identify_parents(matrix()), "method for matrix")
  # required column taxonomicidentification
  expect_error(
    expect_warning(bold_identify_parents(mtcars),
                   "'bold_identify_parents' is deprecated"),
    "no fields 'taxonomicidentification' found in input")
  # catch wrong type param inputs
  expect_warning(bold_identify_parents(bold_identify_list[[1]][1,], tax_rank = 5),
    "'tax_rank' should be of class character")
})

#' Get BOLD stats
#'
#' @inheritParams bold_specimens
#' @param dataType (character) one of "drill_down"(default) or "overview".
#' "drill_down": a detailed summary of information which provides record counts
#' by BINs, Countries, Storing Institutions, Orders, Families, Genus, Species.
#' "overview": the total record counts of BINs, Countries, Storing Institutions,
#' Orders, Families, Genus, Species. The record counts include all gene markers, not only COI. To see the drill down of markers use \code{\link{bold_tax_id2}} with "stats" as `dataTypes`.
#' @param simplify (logical) whether the returned list should be simplified to a data.frame. See Details.
#'
#' @return By default, returns a nested list with the number of total records, the number of records with a species name, then for each of bins, countries, depositories, order, family, genus and species, the total count and the drill down of the records by up to 10 entities of that category. If `simplify` is set to TRUE, returns a list of length 2 : the overview data (number of total records, the number of records with a species name, and the total counts) simplified as a data.frame of 1 row and 9 columns and the drill_down data simplified to a one level list of data.frame. When `dataType` is set to "overview", returns a nested list with the number of total records, the number of records with a species name, and the total count for each of bins, countries, depositories, order, family, genus and species. If `simplify` is set to TRUE, returns a data.frame of 1 row and 9 columns.
#'
#' @references
#' http://v4.boldsystems.org/index.php/resources/api?type=webservices
#'
#' @examples \dontrun{
#' x <- bold_stats(taxon='Osmia')
#' x$total_records
#' x$records_with_species_name
#' x$bins
#' x$countries
#' x$depositories
#' x$order
#' x$family
#' x$genus
#' x$species
#'
#' # just get all counts
#' lapply(Filter(is.list, x), `[[`, "count")
#'
#' bold_stats(taxon='Osmia', dataType = "overview", simplified = TRUE)
#'
#' x <- bold_stats(taxon='Osmia', simplified = TRUE)
#' x$overview
#' x$drill_down
#'
#' res <- bold_stats(taxon='Osmia', response=TRUE)
#' res$url
#' res$status_code
#' res$response_headers
#'
#' # More than 1 can be given for all search parameters
# bold_stats(taxon=c('Coelioxys','Osmia'))
#'
#' ## curl debugging
#' ### These examples below take a long time, so you can set a timeout so that
#' ### it stops by X sec
#' bold_stats(taxon='Osmia', verbose = TRUE)
#' # bold_stats(geo='Costa Rica', timeout_ms = 6)
#' }
#'
#' @export
bold_stats <- function(taxon = NULL, ids = NULL, bin = NULL,
  container = NULL, institutions = NULL, researchers = NULL, geo = NULL,
  dataType = "drill_down", response = FALSE, simplify = FALSE, ...) {
  b_assert(dataType, "character", check.length = 1L)
  response <- b_assert_logical(response)
  dataType <- tolower(dataType)
  b_validate(dataType, c("overview", "drill_down"), "dataType")
  params <- b_pipe_params(taxon = taxon, geo = geo,
                          ids = ids, bin = bin,
                          container = container,
                          institutions = institutions,
                          researchers = researchers)
  res <- b_GET(query = c(params, dataType = dataType, format = 'json'),
               api = 'API_Public/stats', ...)
  if (response) {
    res
  } else {
    out <- b_parse(res, format = "json")
    if (simplify) {
      b_simplify_stats(out, dataType = dataType)
    } else {
      out
    }
  }
}
b_simplify_stats <- function(x, dataType) {
  if (dataType == "drill_down") {
    n <- which(vapply(x, inherits, NA, "integer"))
    ov <- vapply(x[-n], `[[`, 0L, "count")
    ov <- as.data.frame(c(x[n],ov))
    dd <- lapply(x[-n], \(x) {
      y <- x$drill_down
      i <- 0
      while (!is.data.frame(y) && i < 5) {
        y <- y[[1]]
        i <- i + 1
      }
      y
    })
    list(overview = ov, drill_down = dd)
  } else {
    structure(as.list(vapply(x, as.integer, 0L)), class = "data.frame", row.names = 1L)
  }
}

context("bold_stats")

test_that("bold_stats returns the correct object", {
  skip_on_cran()
  vcr::use_cassette("bold_stats", {
    test <- bold_stats(taxon = "Coelioxys")
  })
  expect_is(test, "list")
  expect_type(test$total_records, "integer")
  expect_type(test$records_with_species_name, "integer")
  expect_is(test$bins, "list")
  expect_is(test$countries, "list")
  expect_is(test$order, "list")
})
test_that("bold_stats returns the correct object (simplify & drill_down)", {
  skip_on_cran()
  vcr::use_cassette("bold_stats", {
    test <- bold_stats(taxon = "Coelioxys", simplify = TRUE)
  })
  expect_is(test, "list")
  expect_length(test, 2L)
  expect_type(test$overview, "list")
  expect_type(test$overview$records_with_species_name, "integer")
  expect_type(test$drill_down, "list")
  expect_is(test$drill_down$bins, "data.frame")
  expect_is(test$drill_down$countries, "data.frame")
  expect_is(test$drill_down$order, "data.frame")
})
test_that("bold_stats returns the correct object (simplify & overview)", {
  skip_on_cran()
  vcr::use_cassette("bold_stats", {
    test <- bold_stats(taxon = "Coelioxys", simplify = TRUE, dataType = "overview")
  })
  expect_is(test, "data.frame")
  expect_type(test, "list")
  expect_equal(nrow(test), 1L)
  expect_type(test$records_with_species_name, "integer")
})
test_that("bold_stats return response", {
  skip_on_cran()
  vcr::use_cassette("bold_stats", {
    test <-  bold_stats(taxon = "Coelioxys", response = TRUE)
  })
  expect_is(test, "HttpResponse")
  expect_equal(test$status_code, 200)
  expect_is(test$parse("UTF-8"), "character")
  expect_match(test$parse("UTF-8"), "countries")
})
test_that("bold_stats many taxa passed to taxon param", {
  skip_on_cran()
  vcr::use_cassette("bold_stats", {
    test <- bold_stats(taxon = c("Coelioxys", "Osmia"))
  })
  expect_is(test, "list")
})
test_that("bold_stats fails well", {
  expect_error(bold_stats(),
    "You must provide a non-empty value to at least one of")
  expect_error(bold_stats(taxon = 5), "'taxon' must be of class character")
  expect_error(bold_stats(taxon = 5, bin = 1), "'taxon' and 'bin' must be of class character")
  expect_error(bold_stats(taxon = 5, bin = 1, dataType = "all"), "'all' is not a valid dataType")
  expect_error(bold_stats(taxon = "Osmia", response = 5), "'response' should be one of TRUE or FALSE")
})

# -- API requests helpers
b_url <- function(api) paste0('https://v4.boldsystems.org/index.php/', api)
b_pipe_params <- function(..., paramnames = ...names(), params = list(...)) {
  params <- b_rm_empty(params)
  if (!length(params))
    stop("You must provide a non-empty value to at least one of:\n\t",
         b_ennum(paramnames, join_word = "or", quote = TRUE), call. = FALSE)
  wt <- !vapply(params, is.character, logical(1))
  if (any(wt))
    stop(b_ennum(names(wt)[wt], quote = TRUE), " must be of class character", call. = FALSE)
  if (length(params$taxon)) {
    # in case it comes from `bold_tax_name()` (#84)
    params$taxon <- b_fix_taxonName(params$taxon)
  }
  vapply(params, paste, collapse = "|", character(1))
}
b_GET <- function(query, api, check = FALSE,
                  contentType = 'text/html; charset=utf-8', ...) {
  cli <- crul::HttpClient$new(url = b_url(api))
  res <- cli$get(query = query, ...)
  if (check) b_CHECK(res = res, contentType = contentType)
  else res
}
b_CHECK <- function(res, contentType) {
  w <- ""
  # get HTTP error if any
  if (res$status_code > 202) {
    x <- res$status_http()
    w <- paste0("HTTP ", x$status_code, ": ", x$message, "\n ", x$explanation)
  }
  # check if the content returned is of the right type
  if (res$response_headers$`content-type` != contentType) {
    w <- paste0(
      "Content was type '", res$headers$`content-type`,
      "' when it should've been type '", contentType, "'")
  }
  # if warning call it now
  if (nzchar(w)) warning(w, call. = FALSE, immediate. = TRUE)
  list(response = res, warning = w)
}
b_parse <- function(res, format, raise = TRUE, cleanData = FALSE, multiple = FALSE){
  if (raise) res$raise_for_status()
  res <- {
    if (!multiple)
      rawToChar(res$content)
    else
      paste0(rawToChar(res$content, multiple = TRUE), collapse = "")
  }
  res <- enc2utf8(res)
  if (res == "") {
    NA
  } else {
    if (b_detect(res, "Fatal error")) {
      # if returning partial output for bold_seq, might as well do that here too
      warning("the request timed out, see 'If a request times out'\n",
              "returning partial output")
      res <- b_drop(str = res, pattern = "Fatal error")
      # if missing, adding closing tag so it can be read properly
      if (format == "xml" && !b_detect(res, "</bold_records")) {
        res <- paste0(res, "</bold_records>")
      }
    }
    switch(
      format,
      xml = b_read_xml(res),
      json = b_read_json(res),
      tsv = b_read_tsv(res, cleanData = cleanData),
      fasta = b_read_fasta(res)
    )
  }
}
b_cleanData <- function(x, emptyValue = NA){
  col2clean <- vapply(x, \(x) {
    any(b_detect(x, "|", max_count = 1, fixed = TRUE), na.rm = TRUE)
  }, NA)
  col2clean <- which(col2clean, useNames = FALSE)
  for (.col in col2clean) {
    x[[.col]] <- b_replace(
      x[[.col]],
      # if the same text is repeated
      # or if only "||||"
      "^([^\\|]+)(\\|\\1)+$|^\\|+$",
      # keep first text/replace with nothing
      "$1")
  }
  x[x == ""] <- emptyValue
  x
}
b_read_json <- function(x){
  jsonlite::parse_json(x, simplifyVector = TRUE, flatten = TRUE)
}
b_read_xml <- function(x) {
  # DON'T REMOVE OPTIONS
  # necessary for large request!
  xml2::read_xml(x, options = c("NOBLANKS", "HUGE"))
}
b_read_tsv <- function(x, header = TRUE, sep = "\t",
                       cleanData = FALSE, ...) {
  x <- data.table::setDF(
    data.table::fread(
      text = x,
      header = header,
      sep = sep,
      ...
    )
  )
  if (cleanData) {
    b_cleanData(x)
  } else {
    x
  }
}
b_nameself <- function(x){
  `names<-`(x, x)
}
b_rm_empty <- function(x) {
  if (!length(x)) {
    NULL
  } else {
    x[lengths(x) > 0 & nzchar(x)]
  }
}
b_rbind <- function(x, fill = TRUE, use.names = TRUE, idcol = NULL) {
  (x <- data.table::setDF(
    data.table::rbindlist(l = x, fill = fill, use.names = use.names, idcol = idcol))
  )
}
b_ennum <- function(x, join_word = "and", quote = FALSE) {
  if (!is.character(x)) x <- as.character(x)
  x <- x[nzchar(x)]
  if (quote) {
    x <- paste0("'", x, "'")
  }
  n <- length(x)
  if (n > 1)
    paste(paste(x[-n], collapse = ", "), join_word, x[n])
  else
    x
}
b_fix_taxonName <- function(x){
  # see issue #84
  # check if supposed to:
  x <- b_replace(x,
      # be quoted; keep quoted text
      " ('[^']*)$",
      # add closing quote
      " \\\\$1\\\\'")
  x <- b_replace(x,
      # be in parenthesis; keep parenthesis text
      " (\\([^\\(]*)$",
      # add closing parenthesis
      " $1)")
  x <- b_replace(x,
      # end with a dot (there might be more cases, but haven't seen them yet)
      "( sp(\\. nov)?$)",
      # add end dot
      "$1.")
  x
}

#' Add taxonomic parent names to a data set containing the process IDs of identified sequences.
#'
#' @param x   A single data.frame or matrix, or a list of. Usually the output from a call to \code{\link{bold_identify}}. Required.
#' @param taxOnly   (logical) If TRUE (Default), only the taxonomic names and ids are added (equivalent format to the results of \code{\link{bold_identify_parents}} when `wide`is set to TRUE. If FALSE, also joins the rest of the data returned by \code{\link{bold_specimens}}.
#'
#' @details This function gets the process ids from the
#' input data.frame(s) (ID column), then queries \code{\link{bold_specimens}}
#' to get the sample information and adds it to the input data.frame(s).
#'
#' Records in the input data that do not have matches for parent names
#' simply get NA values in the added columns.
#'
#' @return a data.frame or a list of data.frames with added taxonomic
#' classification.
#'
#' @examples \dontrun{
#' seqs <- bold_identify(sequences = bold::sequences$seq2)
#'
#' seqs_tax <- bold_identify_taxonomy(seqs)
#' head(seqs_tax[[1]])
#'
#' x <- bold_seq(taxon = "Satyrium")
#' seqs <- bold_identify(x$sequence[1:2])
#' seqs_tax <- bold_identify_taxonomy(seqs)
#' seqs_tax
#' }
#'

#' @export
methods::setGeneric(name = "bold_identify_taxonomy",
                    def = function(x, taxOnly = TRUE){
                      standardGeneric("bold_identify_taxonomy")
                    },
                    signature = "x"
)
#' @rdname bold_identify_taxonomy
methods::setMethod(
  f = "bold_identify_taxonomy",
  signature = signature("list"),
  definition = function(x, taxOnly = TRUE) {
    b_assert_length(x, len = 0L, name = "x")
    taxOnly <- b_assert_logical(taxOnly, name = "taxOnly")
    hasID <- vapply(x, \(x) "ID" %in% colnames(x), NA)
    if (all(!hasID)) {
      stop("no column 'ID' found in x")
    } else {
      lapply(x, b_identify_taxonomy, taxOnly = taxOnly)
    }
  }
)
#' @rdname bold_identify_taxonomy
methods::setMethod(
  f = "bold_identify_taxonomy",
  signature = signature("matrix"),
  definition = function(x, taxOnly = TRUE) {
    b_assert_length(x, len = 0L, name = "x")
    b_identify_taxonomy(x, taxOnly = b_assert_logical(taxOnly, name = "taxOnly"))
  }
)
#' @rdname bold_identify_taxonomy
methods::setMethod(
  f = "bold_identify_taxonomy",
  signature = signature("data.frame"),
  definition = function(x, taxOnly = TRUE) {
    b_assert_length(x, len = 0L, name = "x")
    b_identify_taxonomy(x, taxOnly = b_assert_logical(taxOnly, name = "taxOnly"))
  }
)
#' @rdname bold_identify_taxonomy
methods::setMethod(
  f = "bold_identify_taxonomy",
  signature = signature("missing"),
  definition = function(x, taxOnly = TRUE) {
      stop("argument 'x' is missing, with no default")
  }
)
b_identify_taxonomy <- function(x, taxOnly){
  if (!any(colnames(x) == "ID")) {
    warning("No column 'ID' found, skipped", call. = FALSE, immediate. = TRUE)
    data.frame(x)
  } else {
    # get the process ids
    IDs <- x[,"ID", drop = TRUE]
    # get the taxonomic data
    tax <- bold_specimens(ids = unique(IDs))
    if (taxOnly) {
      # only returns the taxonomic data
      tax <- tax[, c("processid", names(tax)[b_detect(names(tax), "_taxID|_name")])]
    }
    tax[tax == ""] <- NA
    # remove empty columns
    tax <- tax[,colSums(is.na(tax)) != nrow(tax)]
    # sort output by input IDs
    rownames(tax) <- tax[,"processid"]
    data.frame(x, tax[IDs, -1], row.names =  NULL)
  }
}

#' Search BOLD for sequences.
#'
#' Get sequences for a taxonomic name, id, bin, container, institution,
#' researcher, geographic, place, or gene.
#'
#' @template args
#' @template otherargs
#' @param marker (character) Returns all records containing matching
#' marker codes.
#' @template large-requests
#' @template marker
#' @template missing-taxon
#' @references
#' http://v4.boldsystems.org/index.php/resources/api?type=webservices
#'
#' @return A data frame with each element as row and 5 columns for processid, identification,
#' marker, accession, and sequence.
#'
#' @examples \dontrun{
#' bold_seq(taxon='Coelioxys')
#' bold_seq(taxon='Aglae')
#' bold_seq(taxon=c('Coelioxys','Osmia'))
#' bold_seq(ids='ACRJP618-11')
#' bold_seq(ids=c('ACRJP618-11','ACRJP619-11'))
#' bold_seq(bin='BOLD:AAA5125')
#' bold_seq(container='ACRJP')
#' bold_seq(researchers='Thibaud Decaens')
#' bold_seq(geo='Ireland')
#' bold_seq(geo=c('Ireland','Denmark'))
#'
#' # Return the http response object for detailed Curl call response details
#' res <- bold_seq(taxon='Coelioxys', response=TRUE)
#' res$url
#' res$status_code
#' res$response_headers
#'
#' ## curl debugging
#' ### You can do many things, including get verbose output on the curl
#' ### call, and set a timeout
#' bold_seq(taxon='Coelioxys', verbose = TRUE)[1:2]
#' }
#'
#' @export
bold_seq <- function(taxon = NULL, ids = NULL, bin = NULL, container = NULL,
                     institutions = NULL, researchers = NULL, geo = NULL,
                     marker = NULL, response = FALSE, ...) {
  response <- b_assert_logical(response, name = "response")
  params <- b_pipe_params(
    taxon = taxon,
    ids = ids,
    bin = bin,
    container = container,
    institutions = institutions,
    researchers = researchers,
    geo = geo,
    marker = marker
  )
  res <- b_GET(query = params,
               api = 'API_Public/sequence', ...)
  if (response) {
    res
  } else {
    b_parse(res, format = "fasta", raise = TRUE)
  }
}
b_read_fasta <- function(x){
  x <- b_lines(str = x)
  if (length(x) %% 2 && # if length(x) %% 2 not 0, it's TRUE
      b_detect(x[length(x)], "^\\s*$")) {
      x <- x[-length(x)]
  }
  id_line <- b_detect(x,"^>")
  n <- which(id_line)
  id <- b_split(str = x[id_line], pattern = ">|\\|", omit_empty = TRUE, simplify = NA, n = 4)
  id <- `names<-`(as.data.frame(id), c("processid", "identification", "marker", "accession"))
  if (all(diff(c(n, length(x) + 1L)) == 2)) {
    sequence <- x[n + 1L]
    data.frame(id, sequence)
  } else if (sum(id_line) == sum(!id_line)) {
    # shouldn't happen but who knows
    warning("The file had an even number of ids and sequences, but they weren't in the proper order.",
            "\n  This shouldn't happen. Output may contain errors.",
            "\n  Please open an issue so we can see when this happens.")
    sequence <- x[!id_line]
    data.frame(id, sequence)
  } else {
    warning("The file had an uneven number of ids and sequenceuences.",
            "\n  This shouldn't happen. Returning data as a list of lines.",
            "\n  Please open an issue so we can see when this happens.")
    x
  }
}

context("bold_seq")


test_that("bold_seq returns the correct object", {
  skip_on_cran()
  vcr::use_cassette("bold_seq", {
    test <- bold_seq(taxon = 'Coelioxys')
  })
  expect_is(test, "data.frame")
  expect_is(test$processid, "character")
  expect_is(test$identification, "character")
  expect_is(test$marker, "character")
  expect_is(test$accession, "character")
  expect_is(test$sequence, "character")
})

test_that("bold_seq returns the correct object (using bin)", {
  skip_on_cran()
  vcr::use_cassette("bold_seq", {
    test <- bold_seq(bin = 'BOLD:AAA5125')
  })
  expect_is(test, "data.frame")
  expect_is(test$processid, "character")
  expect_is(test$identification, "character")
  expect_is(test$marker, "character")
  expect_is(test$accession, "character")
  expect_is(test$sequence, "character")
})
test_that("bold_seq returns the correct object (response)", {
  skip_on_cran()
  vcr::use_cassette("bold_seq", {
    test <- bold_seq(taxon = 'Coelioxys', response = TRUE)
  })
  expect_equal(test$status_code, 200)
  expect_is(test, "HttpResponse")
  expect_equal(test$response_headers$`content-type`, "application/x-download")
  expect_is(test$response_headers, "list")
})


test_that("bold_seq fails well", {
  expect_error(bold_seq(), "You must provide a non-empty value to at least one of")
  expect_error(bold_seq(taxon = ''), "You must provide a non-empty value to at least one of")
  expect_error(bold_seq(taxon = 5, geo = 1), "'taxon' and 'geo' must be of class character")
  expect_error(bold_seq(taxon = 'Coelioxys', response = 5), "'response' should be one of TRUE or FALSE")
})

#' Search BOLD for specimens.
#'
#' @template args
#' @template otherargs
#' @param format (character) One of xml, json, tsv (default). tsv format gives
#' back a data.frame object. xml gives back parsed XML as `xml_document`
#' object. 'json' (JavaScript Object Notation) and 'dwc' (Darwin Core Archive)
#' are supported in theory, but the JSON can be malformed, so we don't support
#' that here, and the DWC option actually returns TSV.
#' @param cleanData (logical) If `TRUE`, the cell values containing only duplicated values (ex : "COI-5P|COI-5P|COI-5P") will be reduce to one value ("COI-5P") and empty string will be change to NA. Default: `FALSE`
#'
#' @template missing-taxon
#' @references
#' http://v4.boldsystems.org/index.php/resources/api?type=webservices
#'
#' @examples \dontrun{
#' bold_specimens(taxon='Osmia')
#' bold_specimens(taxon='Osmia', format='xml')
#' bold_specimens(taxon='Osmia', response=TRUE)
#' res <- bold_specimens(taxon='Osmia', format='xml', response=TRUE)
#' res$url
#' res$status_code
#' res$response_headers
#'
#' # More than 1 can be given for all search parameters
#' bold_specimens(taxon=c('Coelioxys','Osmia'))
#'
#' ## curl debugging
#' ### These examples below take a long time, so you can set a timeout so that
#' ### it stops by X sec
#' head(bold_specimens(taxon='Osmia', verbose = TRUE))
#' # head(bold_specimens(geo='Costa Rica', timeout_ms = 6))
#' }
#'
#' @export
bold_specimens <- function(taxon = NULL, ids = NULL, bin = NULL,
                           container = NULL, institutions = NULL,
                           researchers = NULL, geo = NULL, response = FALSE,
                           format = 'tsv', cleanData = FALSE, ...) {

  format <- b_assert_format(format)
  response <- b_assert_logical(response)
  cleanData <- b_assert_logical(cleanData)
  if (!format %in% c('xml', 'tsv')) stop("'format' should be of of 'xml' or 'tsv'.")
  params <- b_pipe_params(
      taxon = taxon,
      geo = geo,
      ids = ids,
      bin = bin,
      container = container,
      institutions = institutions,
      researchers = researchers
    )
  res <- b_GET(query = c(params, format = format),
               api = 'API_Public/specimen', ...)
  if (response) {
    res
  } else {
    b_parse(res, format, cleanData, raise = TRUE)
  }
}

context("bold_specimens")

test_that("bold_specimens returns the correct object", {
  skip_on_cran()
  vcr::use_cassette("bold_specimens", {
    test <- bold_specimens(taxon = 'Coelioxys')
  })
  test <- bold_specimens(taxon = 'Coelioxys')
  expect_is(test, "data.frame")
  expect_is(test$recordID, "integer")
  expect_is(test$processid, "character")
})
test_that("bold_specimens returns the correct object (cleanData)", {
  skip_on_cran()
  vcr::use_cassette("bold_specimens", {
    test <- bold_specimens(taxon = 'Coelioxys', cleanData = TRUE)
  })
  expect_is(test, "data.frame")
  expect_is(test$recordID, "integer")
  expect_is(test$processid, "character")
  expect_false(any(test == "", na.rm = TRUE))
})
test_that("bold_specimens returns the correct object (response)", {
  skip_on_cran()
  vcr::use_cassette("bold_specimens", {
    test <- bold_specimens(taxon = 'Coelioxys', response = TRUE)
  })
  expect_equal(test$status_code, 200)
  expect_is(test, "HttpResponse")
  expect_equal(test$response_headers$`content-type`, "application/x-download")
  expect_is(test$response_headers, "list")
})
test_that("bold_specimens returns the correct object (xml)", {
  skip_on_cran()
  vcr::use_cassette("bold_specimens", {
    test <- bold_specimens(taxon = 'Coelioxys', format = 'xml')
  })
  expect_is(test, "xml_document")
})
test_that("bold_seq fails well", {
  expect_error(bold_specimens(), "You must provide a non-empty value to at least one of")
  expect_error(bold_specimens(taxon = ''), "You must provide a non-empty value to at least one of")
  expect_error(bold_specimens(geo = 'Costa Rica', timeout_ms = 2), "Timeout was reached")
})

# FIXME: The test wasn't doing that, removed it. Afaik, this function doesn't throw a warning for this.
# test_that("Throws warning on call that takes forever including timeout in callopts", {})

#' Search for matches to sequences against the BOLD COI database.
#'
#' @param sequences (character) A vector or list of sequences to identify.
#' Required. See Details.
#' @param db (character) The database to match against, one of COX1 (default),
#' COX1_SPECIES, COX1_SPECIES_PUBLIC, OR COX1_L640bp. See Details for
#' more information.
#' @param response (logical) Note that response is the object that returns
#' from the Curl call, useful for debugging, and getting detailed info on
#' the API call.
#' @param keepSeq (logical) If TRUE (default), returns each data.frame
#' with an attribute 'sequence' containing sequence used to get those results.
#' @param ... Further args passed on to \code{\link[crul]{verb-GET}}, main
#' purpose being curl debugging
#'
#' @details BOLD only allows one sequences per query. We internally
#' \code{\link[base]{lapply}} over the input values given to the sequences`
#' parameter to search with one sequences per query. Remember this if you have a
#'  lot of sequences - you are doing a separate query for each one, so it can
#' take a long time - if you run into errors let us know.
#'
#' @section db parmeter options:
#'
#' - COX1 Every COI barcode record on BOLD with a minimum sequences
#'  length of 500bp (warning: unvalidated library and includes records without
#'  species level identification). This includes many species represented by
#'  only one or two specimens as well as all species with interim taxonomy. This
#'  search only returns a list of the nearest matches and does not provide a
#'  probability of placement to a taxon.
#' - COX1_SPECIES Every COI barcode record with a species level
#'  identification and a minimum sequences length of 500bp. This includes
#'  many species represented by only one or two specimens as well as  all
#'  species with interim taxonomy.
#'  Note : Sometimes it does return matches that don't have a species level
#'  identification. Will be checking with BOLD.
#' - COX1_SPECIES_PUBLIC All published COI records from BOLD and GenBank
#'  with a minimum sequences length of 500bp. This library is a collection of
#'  records from the published projects section of BOLD.
#' - OR COX1_L640bp Subset of the Species library with a minimum sequences
#'  length of 640bp and containing both public and private records. This library
#'  is intended for short sequences identification as it provides maximum overlap
#'  with short reads from the barcode region of COI.
#'
#' @section Named outputs:
#' For a named output list, make sure to pass in a named list or vector to the
#' `sequences` parameter. You can use \code{\link[base]{names<-}} or
#' \code{\link[stats]{setNames}} to set names on a list or vector of sequences.
#'
#' @return A data.frame or  list of (one per sequences) with the top specimen
#' matches (up to 100) and their details. If the query fails, returns `NULL`.
#' Each data.frame has the attributes `sequence` with the provided
#' sequence to match (unless keepSeq is set to FALSE) and `errors` with the
#' error message given from a failed request.
#'
#' @references
#' http://v4.boldsystems.org/index.php/resources/api?type=idengine
#' @seealso \code{\link{bold_identify_parents}}
#' @examples \dontrun{
#' seq <- sequences$seq1
#' res <- bold_identify(sequences=seq)
#' head(res[[1]])
#' head(bold_identify(sequences=seq, db='COX1_SPECIES')[[1]])
#' }
#'
#' @export
bold_identify <- function(
    sequences,
    db = c("COX1", "COX1_SPECIES", "COX1_SPECIES_PUBLIC", "COX1_L640bp"),
    response = FALSE, keepSeq = TRUE, ...){
  if (missing(sequences)) stop("argument 'sequences' is missing, with no default")
  # make sure sequences are character before the queries
  if (is.list(sequences) && all(lengths(sequences) == 1)) {
    sequences <- c(sequences, recursive = TRUE)
  }
  b_assert(sequences, "character", check.length = 0L)
  if (!missing(db)) {
    db <- b_assert_db(db)
  } else {
    db <- "COX1"
  }
  response <- b_assert_logical(response)
  keepSeq <- b_assert_logical(keepSeq)
  # loop over sequences since the API only accepts one at a time
  lapply(sequences, function(seq){
    if (nchar(seq) < 80) {
      # API return NA but on website you would get that error
      res <- list(response = NULL, warning = "Sequence must be at least 80 bp")
    } else if (!grepl("^[A-z|*|-|+|.]*$", seq)) {
      # API return NA but on website you would get that error
      res <- list(response = NULL, warning = "Sequence contains invalid characters")
    } else {
      res <- b_GET(query = b_rm_empty(list(sequence = seq, db = db)),
                   api = 'Ids_xml', check = TRUE, contentType = 'text/xml')
    }
    if (response) {
      res
    } else {
      out <- if (length(res$response)) b_parse_identify(res) else NA
      # add input sequence as attribute to prevent mix up if 'sequences' wasn't named
      if (keepSeq) {
        attr(out, "sequence") <- seq
      }
      attr(out, "errors") <- res$warning
      out
    }
  })
}

b_parse_identify <- function(res){
  cNames <- c('ID','sequencedescription','database','citation',
              'taxonomicidentification','similarity','specimen_url',
              'specimen_country', 'specimen_lat','specimen_lon')
  fNames <- c('ID','sequencedescription','database','citation',
              'taxonomicidentification','similarity','url','country',
              'lat', 'lon')
  cont <- rawToChar(res$response$content)
  # DON'T REMOVE next line, it's there for a reason, see tests
  cont <- stringi::stri_replace_all_fixed(str = cont, pattern = "&", replacement = "&amp;")
  if (res$warning == "") {
    xml <- xml2::read_xml(cont)
  } else {
    xml <- tryCatch(xml2::read_xml(cont), error = function(e) NULL)
    if (is.null(xml)) {
      return(NULL)
    }
  }
  # path to find all tips (fields)
  toget <- "//ID|//sequencedescription|//database|//citation|
    //taxonomicidentification|//similarity|//url|//country|//lat|//lon"

  #-- find nodes
  nodes <- xml2::xml_find_all(xml, toget)

  nodes.len <- length(nodes)
  nodes.data <- xml2::xml_text(nodes)
  nodes.name <- xml2::xml_name(nodes)
  names(nodes.data) <- nodes.name

  #-- making a data.frame from the tips :
  # each match (node) has these 10 fields (in toget);
  # empty ones *should* return ""
  # but in case there are missing fields in their files...
  #--- first we check that each node has indeed 10 fields
  # and that they are the right 10 fields
  nodes.lens <- diff(c(which(nodes.name == "ID"), nodes.len + 1))
  if (all(nodes.lens == 10) &&
     all(unique(nodes.name) %in% fNames)) {
    #--- if so they can be put in a 10 columns matrix by row
    out <- matrix(nodes.data, ncol = 10, byrow = TRUE,
                  dimnames = list(NULL, cNames))
  } else {
    #--- if not, we can place them in the matrix row by row
    #--- prep output matrix using names of the fields
    nRow <- ceiling(nodes.len/10)
    out <- matrix(NA_character_, nrow = nRow, ncol = 10,
                  dimnames = list(NULL, fNames))
    # set start range of first node
    b <- 1L
    for (i in seq_len(nRow)) {
      # how many field in that node
      n <- nodes.lens[[i]]
      # set (new) end range of node
      e <- b + n - 1
      # match tip's names with fields (column's names)
      out[i, nodes.name[b:e]] <- nodes.data[b:e]
      # set new start range of node
      b <- b + n
    }
    # rename the last 4 columns to match their default column's names
    colnames(out)[7:10] <- c('specimen_url',
                             'specimen_country',
                             'specimen_lat',
                             'specimen_lon')
  }
  out <- data.frame(out)
  # change class of number columns
  out[["similarity"]] <- as.numeric(out[["similarity"]])
  out[["specimen_lat"]] <- as.numeric(out[["specimen_lat"]])
  out[["specimen_lon"]] <- as.numeric(out[["specimen_lon"]])
  out
}

context("bold_identify")

test_that("bold_identify returns the correct object", {
  skip_on_cran()
  vcr::use_cassette("bold_identify", {
    test <- bold_identify(sequences = sequences$seq1)
  })
  expect_is(test, 'list')
  expect_is(test[[1]], 'data.frame')
  expect_is(test[[1]]$ID, 'character')
})

test_that("bold_identify returns the correct object (db)", {
  skip_on_cran()

  vcr::use_cassette("bold_identify", {
    test <- bold_identify(sequences = sequences$seq1, db = 'COX1_SPECIES')
  })
  expect_is(test, 'list')
  expect_is(test[[1]], 'data.frame')
  expect_is(test[[1]]$ID, 'character')
})

test_that("bold_identify returns the correct object (response)", {
  skip_on_cran()
  vcr::use_cassette("bold_identify", {
    test <- bold_identify(sequences = sequences$seq1, response = TRUE)
  })
  expect_is(test, "list")
  test <- test[[1]]
  expect_is(test$response, "HttpResponse")
  expect_equal(test$response$status_code, 200)
  expect_equal(test$response$response_headers$`content-type`, "text/xml")
  expect_is(test$warning, "character")
  expect_equal(test$warning, "")
})

test_that("bold_identify works for XML that contains &", {
  skip_on_cran()
  test_seq <- "AACCCTATACTTTTTATTTGGAATTTGAGCGGGTATAGTAGGTACTAGCTTAAGTATATTAATTCGTCTAGAGCTAGGACAACCCGGTGTATTTTTAGAAGATGACCAAACCTATAACGTTATTGTAACAGCCCACGCTTTTATTATAATTTTCTTCATAATTATACCAATCATAATTGGA"
  vcr::use_cassette("bold_identify", {
    test <- bold_identify(test_seq)
    expect_is(test, 'list')
    expect_is(test[[1]], 'data.frame')
    expect_is(test[[1]]$ID, 'character')
  })
})

test_that("bold_identify skips the identification when the sequences has invalid characters or when the sequence is too short", {
    test <- bold_identify(sequences = c(substr(sequences$seq1, 1, 50), gsub("N", "0", sequences$seq3)))
  expect_is(test, 'list')
  expect_true(all(is.na(test)))
  expect_length(attributes(test[[1]]), 2L)
  expect_equal(attr(test[[1]], "error"), "Sequence must be at least 80 bp")
  expect_equal(attr(test[[2]], "error"), "Sequence contains invalid characters")
})

test_that("bold_identify fails well", {
  expect_error(bold_identify(),
    "argument 'sequences' is missing, with no default")
  expect_error(bold_identify(sequences = 1),
    "'sequences' must be of class character")
  expect_error(bold_identify(sequences = "", db = "test"),
               "'test' is not a valid db")
  expect_error(bold_identify(sequences = "", db = c("COX1", "COX1_SPECIES")),
    "'db' must be length 1")
})

context("bold_identify_taxonomy")

# bold_identify_list <- bold_identify(sequences = sequences$seq2)
# save(bold_identify_list, file = "tests/testthat/bold_identify_list.rda")
# load("tests/testthat/bold_identify_list.rda")
load("bold_identify_list.rda")

test_that("bold_identify_taxonomy works as expected", {
  vcr::use_cassette("bold_identify_taxonomy", {
    test <- bold_identify_taxonomy(bold_identify_list)
  })
  expect_is(test, "list")
  expect_equal(length(test), 1)
  expect_is(test[[1]], "data.frame")
  expect_equal(NROW(test[[1]]), 100)
  expect_is(test[[1]]$ID, "character")
  expect_is(test[[1]]$sequencedescription, "character")
  expect_equal(length(unique(test[[1]]$ID)), length(test[[1]]$ID))
})

test_that("bold_identify_taxonomy works as expected (taxOnly TRUE)", {
  vcr::use_cassette("bold_identify_taxonomy", {
    test <<- bold_identify_taxonomy(bold_identify_list)
  })
  expect_is(test, "list")
  expect_equal(length(test), 1)
  expect_is(test[[1]], "data.frame")
  expect_equal(NROW(test[[1]]), 100)
  expect_equal(NCOL(test[[1]]), 24)
  expect_is(test[[1]]$ID, "character")
  expect_is(test[[1]]$sequencedescription, "character")
  expect_equal(length(unique(test[[1]]$ID)), length(test[[1]]$ID))
})
test_that("bold_identify_taxonomy works as expected (taxOnly FALSE)", {
  vcr::use_cassette("bold_identify_taxonomy", {
    test <- bold_identify_taxonomy(bold_identify_list, taxOnly = FALSE)
  })
  expect_is(test, "list")
  expect_equal(length(test), 1)
  expect_is(test[[1]], "data.frame")
  expect_equal(NROW(test[[1]]), 100)
  expect_gt(NCOL(test[[1]]), 24)
  expect_is(test[[1]]$ID, "character")
  expect_is(test[[1]]$sequencedescription, "character")
  expect_equal(length(unique(test[[1]]$ID)), length(test[[1]]$ID))
})

test_that("bold_identify_taxonomy fails well", {
  # x required
  expect_error(bold_identify_taxonomy(), "argument 'x' is missing")
  expect_error(bold_identify_taxonomy(list()), "'x' can't be empty")
  expect_error(bold_identify_taxonomy(data.frame()), "'x' can't be empty")
  expect_error(bold_identify_taxonomy(matrix(logical(0L))), "'x' can't be empty")
  # only supported types
  expect_error(bold_identify_taxonomy(numeric()), "unable to find an inherited method for function")
  expect_error(bold_identify_taxonomy(x = bold_identify_list, taxOnly = 5), "'taxOnly' should be one of TRUE or FALSE")
  # required column ID
  expect_error(bold_identify_taxonomy(list(mtcars, mtcars)),
               "no column 'ID' found in x")
  expect_warning(bold_identify_taxonomy(mtcars),
               "No column 'ID' found, skipped")
  expect_warning(bold_identify_taxonomy(as.matrix(mtcars)),
               "No column 'ID' found, skipped")
})

b_assert <- function(x,
                     what,
                     name = NULL,
                     check.length = NULL) {
  if (!length(name)) {
    name <- substitute(x)
  }
  msgLen <- if (length(check.length) && !isFALSE(check.length)) {
      b_assert_length(x = x, len = check.length, name = name,
                      stopOnFail = length(x) > 0)
  } else {
    NULL
  }
  msgClass <- if (length(x)) {
    b_assert_class(x = x, what = what, name = name,
                   is2nd = length(msgLen), stopOnFail = FALSE)
  } else {
    NULL
  }
  msg <- c(msgLen, msgClass)
  if (length(msg)) {
    stop(msg, call. = FALSE)
  }
}
b_assert_class <- function(x, what, name, is2nd = FALSE, stopOnFail = TRUE) {
  .fun <- if (stopOnFail) stop else paste0
  if (!inherits(x = x, what = what)) {
    if (!is2nd)
      .fun("'", name, "' must be of class ", b_ennum(what, "or"))
    else
      .fun(" and of class ", b_ennum(what, "or"))
  } else {
    NULL
  }
}
b_assert_length <- function(x, len, name, stopOnFail = TRUE) {
  len <- as.integer(len)
  if (!is.na(len) && len >= 0) {
    .fun <- if (stopOnFail) stop else paste0
    if (len == 0 && !length(x)) {
      .fun("'", name, "' can't be empty")
    } else if (len > 0 && length(x) != len) {
      .fun("'", name, "' must be length ", len)
    }
  }
}
b_assert_logical <- function(x, name = NULL) {
  b_assert_length(x, len = 1L, name = name)
  if (!length(name)) name <- substitute(x)
  x <- tolower(x)
  if (x == "true" || x == "1")
    TRUE
  else if (x == "false" || x == "0" || x == "na")
    FALSE
  else
    stop("'", name, "' should be one of TRUE or FALSE")
}
b_validate <- function(x, choices, name){
  wrong <- !x %in% choices
  if (any(wrong)) {
    stop(
      b_ennum(x[wrong], quote = TRUE),
      if (sum(wrong) > 1)
        " are not valid "
      else
        " is not a valid ",
      name,
      "\nChoices are ",
      b_ennum(choices, join_word = "or", quote = TRUE),
      call. = FALSE
    )
  }
}
b_get_db <- function(x){
  x <- tolower(x)
  if (b_detect(x, '^pub(lic)?$|_public$'))
    "COX1_SPECIES_PUBLIC"
  else if (b_detect(x, '^spe(cies)?$|_species$'))
    "COX1_SPECIES"
  else if (b_detect(x, '^(cox1_)?(l640)?bp$'))
    "COX1_L640bp"
  else
    x
}
b_assert_db <- function(x){
  b_assert(x, "character", name = "db", check.length = 1L)
  x <- b_get_db(x)
  b_validate(x, choices = b_db, name = "db")
  x
}
b_get_tax_division <- function(x){
  x <- tolower(x)
  x[b_detect(x, '^animal')] <- "Animalia"
  x[b_detect(x, '^prot')] <- "Protista"
  x[b_detect(x, '^fun')] <- "Fungi"
  x[b_detect(x, '^plant')] <- "Plantae"
  x
}
b_assert_tax_division <- function(x){
  if (length(x)) {
    b_assert(x, what = "character", name = "tax_division")
    x <- b_get_tax_division(x)
    b_validate(x, choices = b_tax_division, name = "tax_division")
  }
  x
}
b_get_tax_rank <- function(x){
  x <- tolower(x)
  x[b_detect(x, '^king')] <- "kingdom"
  x[b_detect(x, '^phy')] <- "phylum"
  x[b_detect(x, '^cla')] <- "class"
  x[b_detect(x, '^ord')] <- "order"
  x[b_detect(x, '^fam')] <- "family"
  x[b_detect(x, '^subfam')] <- "subfamily"
  x[b_detect(x, '^tribe')] <- "tribe"
  x[b_detect(x, '^gen')] <- "genus"
  x[b_detect(x, '^spe')] <- "species"
  x[b_detect(x, '^subspe')] <- "subspecies"
  x
}
b_assert_tax_rank <- function(x){
  if (length(x)) {
    b_assert(x, what = "character", name = "tax_rank")
    x <- b_get_tax_rank(x)
    b_validate(x, choices = b_tax_rank, name = "tax_rank")
  }
  x
}
b_assert_format <- function(x){
  b_assert(x, what = "character", check.length = 1L, name = "format")
  x <- tolower(x)
  if (x != "xml" && x != "tsv")
    stop("'format' should be one of 'xml' or 'tsv'")
  else
    x
}
b_get_dataTypes <- function(x){
  x <- tolower(x)
  if (any(x == "all")) {
    x <- "all"
  } else {
    # corrects for the json typo in case the option is taken from a previous query
    # and for short versions/typos
    x[x == "basics"] <- "basic"
    x[x == "depo" | x == "depositories"] <- "depository"
    x[x == "labs" | x == "sequencinglab"] <- "sequencinglabs"
    x[x == "stat"] <- "stats"
    x[x == "img"] <- "images"
    x[x == "wiki"] <- "thirdparty"
  }
  x
}
b_assert_dataTypes <- function(x){
  b_assert(x, what = "character", name = "dataTypes", check.length = 0L)
  x <- b_get_dataTypes(x)
  b_validate(x, choices = b_dataTypes, name = "dataTypes")
  x
}

#' Search BOLD for taxonomy data by BOLD ID.
#'
#' @param id (integer|numeric|character) One or more BOLD taxonomic identifiers. required.
#' @param dataTypes (character) One or more BOLD data types: 'basic', 'stats', 'geo', 'images'/'img', 'sequencinglabs'/'labs', 'depository'/'depo', 'thirdparty'/'wiki' or 'all' (default: 'basic'). Specifies the information that will be returned, see details.
#' @param includeTree (logical) If `TRUE` (default: `FALSE`), returns the information for parent taxa as well as the specified taxon, see details.
#' @param response (logical) If `TRUE` (default: `FALSE`), returns the curl response object.
#' @section dataTypes:
#' "basic" returns basic taxonomy info: includes taxid, taxon name, tax rank, tax division, parent taxid, parent taxon name.
#' "stats" returns specimen and sequence statistics: includes public species count, public BIN count, public marker counts, public record count, specimen count, sequenced specimen count, barcode specimen count, species count, barcode species count.
#' "geo" returns collection site information: includes country, collection site map.
#' "images" returns specimen images: includes copyright information, image URL, image metadata.
#' "sequencinglabs" returns sequencing labs: includes lab name, record count.
#' "depository" returns specimen depositories: includes depository name, record count.
#' "thirdparty" returns information from third parties: includes wikipedia_summary summary, wikipedia_summary URL.
#' "all" returns all information: identical to specifying all data types at once.
#' @section includeTree:
#' When `includeTree` is set to true, for the `dataTypes` other than 'basic' the information of the parent taxa are identified by their taxonomic id only. To get their ranks and names too, make sure 'basic' is in `dataTypes`.
#' @template otherargs
#' @references
#' http://v4.boldsystems.org/index.php/resources/api?type=taxonomy
#' @seealso \code{\link{bold_tax_name}}, \code{\link{bold_get_attr}}, \code{\link{bold_get_errors}}, \code{\link{bold_get_params}}
#' @examples \dontrun{
#' bold_tax_id2(id = 88899)
#' bold_tax_id2(id = 88899, includeTree = TRUE)
#' bold_tax_id2(id = 88899, includeTree = TRUE, dataTypes = "stats")
#' bold_tax_id2(id = c(88899, 125295))
#'
#' ## dataTypes parameter
#' bold_tax_id2(id = 88899, dataTypes = "basic")
#' bold_tax_id2(id = 88899, dataTypes = "stats")
#' bold_tax_id2(id = 88899, dataTypes = "images")
#' bold_tax_id2(id = 88899, dataTypes = "geo")
#' bold_tax_id2(id = 88899, dataTypes = "sequencinglabs")
#' bold_tax_id2(id = 88899, dataTypes = "depository")
#' bold_tax_id2(id = 88899, dataTypes = "thirdparty")
#' bold_tax_id2(id = 88899, dataTypes = "all")
#' bold_tax_id2(id = c(88899, 125295), dataTypes = c("basic", "geo"))
#' bold_tax_id2(id = c(88899, 125295), dataTypes = c("basic", "stats", "images"))
#'
#' ## Passing in NA
#' bold_tax_id2(id = NA)
#' bold_tax_id2(id = c(88899, 125295, NA))
#'
#' ## get http response object only
#' bold_tax_id2(id = 88899, response = TRUE)
#' bold_tax_id2(id = c(88899, 125295), response = TRUE)
#'
#' ## curl debugging
#' bold_tax_id2(id = 88899, verbose = TRUE)
#' }
#'
#' @export
bold_tax_id2 <- function(id, dataTypes = 'basic', includeTree = FALSE,
                         response = FALSE, ...) {
    #-- arguments check
    if (missing(id)) stop("argument 'id' is missing, with no default")
    # no need to do the call if id is NA
    if (length(id) == 1 && is.na(id))
      return(data.frame(input = NA, taxid = NA))
    b_assert_logical(includeTree)
    b_assert(dataTypes, "character")
    if (is.list(id)) {
      lapply(id, b_assert, what = c("character", "numeric", "integer"), name = "id")
    } else {
      b_assert(id, c("character", "numeric", "integer"))
    }
    # for compatibility with bold_tax_id
    if (length(dataTypes) == 1 && grepl(",", dataTypes)) {
      dataTypes <- c(b_split(dataTypes, ",", fixed = TRUE, simplify = TRUE))
    }
    dataTypes <- b_assert_dataTypes(dataTypes)
    #-- prep query params
    params <- list(
      dataTypes = paste(dataTypes, collapse = ","),
      includeTree = tolower(includeTree)
    )
    #-- fetch data from the api
    res <- lapply(b_nameself(id), function(x) {
      if (!length(x) || !nzchar(x)) {
        list(response = NULL, warning = "id was empty")
      } else if (is.na(x) || grepl("^NA?$", x)) {
        list(response = NULL, warning = "id was NA")
      } else {
        r <- b_GET(query = c(taxId = x, params), api = "API_Tax/TaxonData",
                   check = TRUE, ...)
        if (nzchar(r$warning) || r$response$status_code > 202) {
          w <- xml2::read_html(r$response$content)
          w <- b_lines(xml2::xml_text(w))
          w <- w[b_detect(w, "Fatal")]
          if (b_detect(w, "non-object")) w <- c(w, "Request returned no match.")
          r$warning <- c(r$warning, w)
          r$response <- NULL
        }
        r
      }
    })
    if (response) {
      res
    } else {
      #-- make data.frame with the response(s)
      #-- fixing dataTypes to match bold response
      if (length(dataTypes) == 1 && dataTypes == "all") {
        dataTypes <- b_dataTypes[1:7]
      }
      dataTypes[dataTypes == "geo"] <- "country"
      #-- parsing bold response by id
      out <- mapply(
        b_process_tax_id,
        res,
        ids = id,
        MoreArgs = list(types = dataTypes, tree = includeTree),
        SIMPLIFY = FALSE
      )
      out <- b_format_tax_id_output(out, types = dataTypes, tree = includeTree)
      # -- add attributes to output
      w <- lapply(res, `[[`, "warning")
      attr(out, "errors") <- b_rm_empty(w)
      attr(out, "params") <- list(dataTypes = dataTypes,
                                  includeTree = includeTree)
      out
    }
  }
b_process_tax_id <- function(x, ids, types, tree) {
  if (length(x$response)) {
    out <- b_parse(x$response, format = "json", raise = FALSE)
    if (!length(out) || identical(out[[1]], list())) {
      data.frame(taxid = NA)
    } else {
      if (!tree) {
        out <- b_format_tax_id(out, ids = ids)
      } else {
        tmp <-
          lapply(b_nameself(names(out)), \(id) b_format_tax_id(out[[id]], id))
        out <-
          lapply(b_nameself(types), b_grp_dataTypes_tree, x = tmp)
        if ("basic" %in% names(out) &&
            "parentid" %in% names(out[["basic"]])) {
          out[["basic"]] <-
            out[["basic"]][order(out[["basic"]][["parentid"]]), ]
        }
      }
      out
    }
  }
}
b_format_tax_id <- function(x, ids) {
  # 'geo' isn't group like the others for some reason
  # it's split between country and site map, default
  # was to return only 'country' (although I'm not sure why),
  # so removing the sitemap
  x$sitemap <- NULL
  # some dataTypes returns data.frames or long lists
  # simplifying all of those would make the data frame very large.
  # so adjusting for the different types :
  basic.nms <- which(names(x) %in% c("taxid", "taxon", "tax_rank", "tax_division",
                                     "parentid", "parentname", "taxonrep"))
  wiki.nms <- which(names(x) %in% c("wikipedia_summary", "wikipedia_link"))
  if (length(x$stats)) {
    x$stats <- b_format_tax_id_stats(x$stats)
  }
  if (!all(is.na(basic.nms))) {
    x$basic <- data.frame(x[basic.nms])
    x <- x[-basic.nms]
  }
  if (!all(is.na(wiki.nms))) {
    x$thirdparty <- data.frame(x[wiki.nms])
    x <- x[-wiki.nms]
  }
  for (i in which(vapply(x[!names(x) %in% c("stats", "basic", "thirdparty")], class, character(1L)) == "list")) {
    x[i] <- b_format_tax_id_list(x[i], ids = ids)
  }
  x
}
b_format_tax_id_stats <- function(x) {
  if ("publicmarkersequences" %in% names(x)) {
    markers <- which(names(x) == "publicmarkersequences")
    data.frame(as.list(c(x[-markers], x[markers], recursive = TRUE)))
  } else {
    data.frame(as.list(c(x, recursive = TRUE)))
  }
}
b_format_tax_id_list <- function(x, ids) {
  lapply(
    b_nameself(names(x)),
    function(nm) {
      out <- c(x[[nm]], recursive = TRUE, use.names = TRUE)
      out <- data.table::data.table(taxid = ids, names(out), count = out)
      data.table::setnames(out, 2, nm)
      out
    }
  )
}
b_fill_empty <- function(x, types){
  len0 <- lengths(x) == 0
  if (any(len0)) {
    filler <- list(data.frame(col2rm = NA_character_))
    filler <- list(`names<-`(rep(filler, length(types)), types))
    x[which(len0)] <- filler
  }
  x
}
b_format_tax_id_output <- function(x, types, tree) {
  types <- b_nameself(types)
  #-- to match previous behavior of passing NAs
  x <- b_fill_empty(x, types)
  if (tree && length(types) == 1 &&
        !types %in% c("basic", "thirdparty", "images", "stats")) {
      x <- b_rbind(unlist(x, recursive = FALSE, use.names = T), idcol = "input")
      x$input <- as.integer(b_extract(x$input, "^[0-9]+(?=\\.)"))
  }  else {
    x <- lapply(types, b_grp_dataTypes, x = x, idcol = "input")
  }
  if (length(x) == 1) {
    x[[1]]
  } else {
    x
  }
}
b_grp_dataTypes_tree <- function(nm, x) {
  idcol <- if (nm == "stats" || nm == "thirdparty" || nm == "images") "taxid" else NULL
  out <- b_rbind(lapply(x, `[[`, nm), idcol = idcol)
  out$taxid <- as.integer(out$taxid)
  out
}
b_grp_dataTypes <- function(nm, x, idcol = FALSE) {
  out <- b_rbind(lapply(x, `[[`, nm), idcol = idcol)
  out[["input"]] <- as.integer(out[["input"]])
  out[names(out) == "col2rm"] <- NULL
  out
}

context("bold_tax_id2")

test_that("bold_tax_id2 returns the correct object (one ID)", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_id2", {
    test <- bold_tax_id2(id = 88899)
  })
  expect_is(test, "data.frame")
  expect_is(test$input, "integer")
  expect_is(test$taxid, "integer")
  expect_is(test$tax_rank, "character")
  expect_equal(test$taxid, test$input)
  expect_equal(NROW(test), 1)
})
test_that("bold_tax_id2 returns the correct object (multiple IDs)", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_id2", {
    test <- bold_tax_id2(id = c(88899, 125295))
  })
  expect_is(test, "data.frame")
  expect_equal(NROW(test), 2)
  expect_equal(test$taxid, test$input)
})
test_that("bold_tax_id2 returns the correct object (multiple IDs, but one NA)", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_id2", {
    test <- bold_tax_id2(id = c(88899, 125295, NA))
  })
  expect_is(test, "data.frame")
  expect_equal(NROW(test), 3)
  expect_equal(test$taxid, test$input)
})
test_that("bold_tax_id2 returns the correct object (one ID, but NA)", {
  test <- bold_tax_id2(id = NA)
  expect_is(test, "data.frame")
  expect_equal(NROW(test), 1)
  expect_length(test, 2)
  expect_equal(test$taxid, test$input)
})
test_that("bold_tax_id2 returns the correct object (response)", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_id2", {
    test <- bold_tax_id2(id = 88899, response = TRUE)
  })
  expect_is(test, "list")
  test <- test[["88899"]]
  expect_length(test, 2)
  expect_is(test$response, "HttpResponse")
  expect_equal(test$response$status_code, 200)
  expect_equal(test$response$response_headers$`content-type`, "text/html; charset=utf-8")
  expect_is(test$response$response_headers, "list")
  expect_is(test$warning, "character")
  expect_equal(test$warning, "")
})
test_that("bold_tax_id2 'dataTypes' param works as expected (stats)", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_id2", {
    test <- bold_tax_id2(id = 88899, dataTypes = "stats")
  })
  expect_is(test, "data.frame")
  expect_equal(NROW(test), 1)
})
test_that("bold_tax_id2 'dataTypes' param works as expected (stats without public marker seqs)", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_id2", {
    test <- bold_tax_id2(id = 660837, dataTypes = "stats")
  })
  expect_is(test, "data.frame")
  expect_equal(NROW(test), 1)
})
test_that("bold_tax_id2 'dataTypes' param works as expected (geo)", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_id2", {
    test <- bold_tax_id2(id = 88899, dataTypes = "geo")
  })
  expect_is(test, "data.frame")
  expect_equal(NROW(test), 8)
  expect_named(test, c("input", "taxid", "country", "count"))
})
test_that("bold_tax_id2 'dataTypes' param works as expected (sequencinglabs)", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_id2", {
    test <- bold_tax_id2(id = 88899, dataTypes = "sequencinglabs")
  })
  expect_is(test, "data.frame")
  expect_gt(NROW(test), 1)
  expect_named(test, c("input", "taxid", "sequencinglabs", "count"))
})
test_that("bold_tax_id2 'dataTypes' param works as expected (all)", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_id2", {
    test <- bold_tax_id2(id = 88899, dataTypes = "all")
  })
  expect_is(test, "list")
  expect_length(test, 7)
  expect_is(test$basic, "data.frame")
  expect_is(test$stats, "data.frame")
  expect_equal(NROW(test$basic), 1)
  expect_named(test, c("basic", "stats", "country", "images", "sequencinglabs", "depository", "thirdparty"))
})
test_that("bold_tax_id2 'dataTypes' param works as expected (basic & stats)", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_id2", {
    test <- bold_tax_id2(id = 660837, dataTypes = c("basic", "stats"))
  })
  expect_is(test, "list")
  expect_is(test[[1]], "data.frame")
  expect_is(test[[2]], "data.frame")
  expect_equal(NROW(test[[1]]), 1)
  expect_is(attr(test, "param"), "list")
  expect_length(attr(test, "param"), 2)
})
test_that("bold_tax_id2 'dataTypes' param works as expected (basic & stats; as written for bold_tax_id)", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_id2", {
    test <- bold_tax_id2(id = 660837, dataTypes = "basic,stats")
  })
  expect_is(test, "list")
  expect_is(test[[1]], "data.frame")
  expect_is(test[[2]], "data.frame")
  expect_equal(NROW(test[[1]]), 1)
  expect_is(attr(test, "param"), "list")
  expect_length(attr(test, "param"), 2)
})
test_that("bold_tax_id2 'includeTree' param works as expected", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_id2", {
    test <- bold_tax_id2(id = 88899, includeTree = TRUE)
  })
  expect_is(test, "data.frame")
  expect_equal(NROW(test), 5)
})
test_that("bold_tax_id2 'includeTree' param works as expected (with 2 dataTypes)", {
  skip_on_cran()
  vcr::use_cassette("bold_tax_id2", {
    test <- bold_tax_id2(id = 88899, dataTypes = c("basic", "geo"), includeTree = TRUE)
  })
  expect_is(test, "list")
  expect_is(test[[1]], "data.frame")
  expect_is(test[[2]], "data.frame")
  expect_equal(NROW(test[[1]]), 5)
  expect_true(all(test[[1]][,"taxid"] %in% unique(test[[2]][,"taxid"])))
})
test_that("bold_tax_id2 fails well", {
  expect_error(bold_tax_id2(), "argument 'id' is missing, with no default")
  expect_error(bold_tax_id2(id = 88899, dataTypes = 5), "'dataTypes' must be of class character")
  expect_error(bold_tax_id2(id = 88899, dataTypes = "base"), "'base' is not a valid dataTypes")
  expect_error(bold_tax_id2(id = 88899, dataTypes = c("base", "pic")), "'base' and 'pic' are not valid dataTypes")
  expect_error(bold_tax_id2(id = 88899, includeTree = 5), "'includeTree' should be one of TRUE or FALSE")
})

# uncomment to set all cassettes at once
# vcr::vcr_configure(dir = normalizePath("./tests/fixtures/"))
# vcr::vcr_configuration()
# vcr::use_cassette("bold_specimens", {
#   bold_specimens(taxon = 'Coelioxys')
#   bold_specimens(taxon = 'Coelioxys', format = 'xml')
# })
# vcr::use_cassette("bold_seqspec", {
#   bold_seqspec(taxon = 'Coelioxys')
# })
# vcr::use_cassette("bold_seq", {
#   bold_seq(taxon = 'Coelioxys')
#   bold_seq(bin = 'BOLD:AAA5125')
# })
# vcr::use_cassette("bold_stats", {
#   bold_stats(taxon = "Coelioxys")
#   bold_stats(taxon = "Coelioxys", simplify = TRUE)
#   bold_stats(taxon = "Coelioxys", simplify = TRUE, dataType = "overview")
#   bold_stats(taxon = c("Coelioxys", "Osmia"))
# })
# vcr::use_cassette("bold_trace", {
#   dest.dir <- vcr::vcr_configuration()$write_disk_path
#   bold_trace(taxon = "Bombus ignitus", geo = "Japan", dest = file.path(dest.dir, "taxon"))
#   bold_trace(ids = c('ACRJP618-11','ACRJP619-11'), dest = file.path(dest.dir, "ids"))
# })
# vcr::use_cassette("bold_tax_id2", {
#   bold_tax_id2(id = 88899)
#   bold_tax_id2(id = c(88899, 125295))
#   bold_tax_id2(id = 88899, includeTree = TRUE)
#   bold_tax_id2(id = 88899, dataTypes = "all")
#   bold_tax_id2(id = 88899, dataTypes = "stats")
#   bold_tax_id2(id = 88899, dataTypes = "geo")
#   bold_tax_id2(id = 88899, dataTypes = "sequencinglabs")
#   bold_tax_id2(id = 88899, dataTypes = c("basic", "geo"), includeTree = TRUE)
#   bold_tax_id2(id = 660837, dataTypes = "stats") # no public marker sequences
#   bold_tax_id2(id = 660837, dataTypes = c("basic","stats")) # no public marker sequences
# })
# vcr::use_cassette("bold_tax_name", {
#   bold_tax_name(name = "Diplura")
#   bold_tax_name(name = c("Apis", "Puma concolor", "Pinus concolor"))
#   bold_tax_name(name = "Diplur", fuzzy = TRUE)
#   bold_tax_name(name = "Diplur", fuzzy = FALSE)
#   bold_tax_name(name = c(
#     "Diplurodes sp.",
#     "Chlamydomonas sp. 18 (FA)",
#     "Chlamydomonas sp. 'Chile J'"
#   ))
# })
# vcr::use_cassette("bold_identify_parents", {
#   load("tests/testthat/bold_identify_list.rda")
#   bold_identify_parents(bold_identify_list)
# })
# vcr::use_cassette("bold_identify_taxonomy", {
#   load("tests/testthat/bold_identify_list.rda")
#   bold_identify_taxonomy(x = bold_identify_list)
# })
# vcr::use_cassette("bold_identify", {
#   bold_identify(sequences$seq1)
#   bold_identify(sequences$seq1, db = 'COX1_SPECIES')
#   bold_identify("AACCCTATACTTTTTATTTGGAATTTGAGCGGGTATAGTAGGTACTAGCTTAAGTATATTAATTCGTCTAGAGCTAGGACAACCCGGTGTATTTTTAGAAGATGACCAAACCTATAACGTTATTGTAACAGCCCACGCTTTTATTATAATTTTCTTCATAATTATACCAATCATAATTGGA")
# })

if (getRversion() >= "2.15.1") {
  utils::globalVariables(c("nucleotides", ".I"))
}
#' Filter BOLD specimen + sequence data (output of bold_seqspec)
#'
#' Picks either shortest or longest sequences, for a given grouping variable
#' (e.g., species name)
#'
#' @param x (data.frame) a data.frame, as returned from
#' \code{\link{bold_seqspec}}. Note that some combinations of parameters
#' in \code{\link{bold_seqspec}} don't return a data.frame. Stops with
#' error message if this is not a data.frame. Required.
#' @param by (character) the column by which to group. For example,
#' if you want the longest sequence for each unique species name, then
#' pass **species_name**. If the column doesn't exist, error
#' with message saying so. Required.
#' @param how (character) one of "max" or "min", which get used as
#' `which.max` or `which.min` to get the longest or shortest
#' sequence, respectively. Note that we remove gap/alignment characters
#' (`-`)
#' @param returnTibble Whether the output should be a tibble or
#' a data.frame. Default is TRUE, but verifies that the `tibble` package is
#' installed, if it's not, it will be returned as data.frame.
#' Since this package is only used in this function, doing this so it can be
#' moved to suggested instead of dependency without breaking old scripts.
#'
#' @return a data.frame
#' @examples \dontrun{
#' res <- bold_seqspec(taxon = 'Osmia')
#' maxx <- bold_filter(res, by = "species_name")
#' minn <- bold_filter(res, by = "species_name", how = "min")
#'
#' vapply(maxx$nucleotides, nchar, 1, USE.NAMES = FALSE)
#' vapply(minn$nucleotides, nchar, 1, USE.NAMES = FALSE)
#' }
#' @export
bold_filter <- function(x, by, how = "max", returnTibble = TRUE){
  #-- arg check
  if (missing(x)) stop("argument 'x' is missing, with no default")
  if (missing(by)) stop("argument 'by' is missing, with no default")
  b_assert(x, c("data.frame", "matrix"))
  b_assert(by, "character", check.length = 1L)
  if (!by %in% colnames(x)) stop("'", by, "' is not a valid column in 'x'")
  if (!missing(how)) b_assert(how, "character", check.length = 1L)
  if (!missing(returnTibble)) returnTibble <- b_assert_logical(returnTibble)
  how <- switch(tolower(how),
                min = which.min,
                max = which.max,
                stop("'how' must be one of 'min' or 'max'"))
  #-- faster to use data.table by to filter
  xdt <- data.table::as.data.table(x)
  .rows <- xdt[,{
    lgts <- b_count(nucleotides,"[^-N]")
    .I[how(lgts)]
  }, by = by]$V1
  out <- x[.rows,]
  # so the output is ordered in the same way as before
  out <- out[order(out[,by]),]
  rownames(out) <- NULL
  # this make tibble a suggest instead of dependency.
  # Only function still using it.
  if (returnTibble && requireNamespace("tibble", quietly = TRUE)) {
    tibble::as_tibble(out)
  } else {
    out
  }
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bold_identify.R
\name{bold_identify}
\alias{bold_identify}
\title{Search for matches to sequences against the BOLD COI database.}
\usage{
bold_identify(
  sequences,
  db = c("COX1", "COX1_SPECIES", "COX1_SPECIES_PUBLIC", "COX1_L640bp"),
  response = FALSE,
  keepSeq = TRUE,
  ...
)
}
\arguments{
\item{sequences}{(character) A vector or list of sequences to identify.
Required. See Details.}

\item{db}{(character) The database to match against, one of COX1 (default),
COX1_SPECIES, COX1_SPECIES_PUBLIC, OR COX1_L640bp. See Details for
more information.}

\item{response}{(logical) Note that response is the object that returns
from the Curl call, useful for debugging, and getting detailed info on
the API call.}

\item{keepSeq}{(logical) If TRUE (default), returns each data.frame
with an attribute 'sequence' containing sequence used to get those results.}

\item{...}{Further args passed on to \code{\link[crul]{verb-GET}}, main
purpose being curl debugging}
}
\value{
A data.frame or  list of (one per sequences) with the top specimen
matches (up to 100) and their details. If the query fails, returns \code{NULL}.
Each data.frame has the attributes \code{sequence} with the provided
sequence to match (unless keepSeq is set to FALSE) and \code{errors} with the
error message given from a failed request.
}
\description{
Search for matches to sequences against the BOLD COI database.
}
\details{
BOLD only allows one sequences per query. We internally
\code{\link[base]{lapply}} over the input values given to the sequences`
parameter to search with one sequences per query. Remember this if you have a
lot of sequences - you are doing a separate query for each one, so it can
take a long time - if you run into errors let us know.
}
\section{db parmeter options}{

\itemize{
\item COX1 Every COI barcode record on BOLD with a minimum sequences
length of 500bp (warning: unvalidated library and includes records without
species level identification). This includes many species represented by
only one or two specimens as well as all species with interim taxonomy. This
search only returns a list of the nearest matches and does not provide a
probability of placement to a taxon.
\item COX1_SPECIES Every COI barcode record with a species level
identification and a minimum sequences length of 500bp. This includes
many species represented by only one or two specimens as well as  all
species with interim taxonomy.
Note : Sometimes it does return matches that don't have a species level
identification. Will be checking with BOLD.
\item COX1_SPECIES_PUBLIC All published COI records from BOLD and GenBank
with a minimum sequences length of 500bp. This library is a collection of
records from the published projects section of BOLD.
\item OR COX1_L640bp Subset of the Species library with a minimum sequences
length of 640bp and containing both public and private records. This library
is intended for short sequences identification as it provides maximum overlap
with short reads from the barcode region of COI.
}
}

\section{Named outputs}{

For a named output list, make sure to pass in a named list or vector to the
\code{sequences} parameter. You can use \code{\link[base]{names<-}} or
\code{\link[stats]{setNames}} to set names on a list or vector of sequences.
}

\examples{
\dontrun{
seq <- sequences$seq1
res <- bold_identify(sequences=seq)
head(res[[1]])
head(bold_identify(sequences=seq, db='COX1_SPECIES')[[1]])
}

}
\references{
http://v4.boldsystems.org/index.php/resources/api?type=idengine
}
\seealso{
\code{\link{bold_identify_parents}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bold_identify_parents.R
\name{bold_identify_parents}
\alias{bold_identify_parents}
\title{Add taxonomic parent names to a data.frame}
\usage{
bold_identify_parents(x, wide = FALSE, taxid = NULL, taxon = NULL,
  tax_rank = NULL, tax_division = NULL, parentid = NULL,
  parentname = NULL, taxonrep = NULL, specimenrecords = NULL, ...)
}
\arguments{
\item{x}{(data.frame/list) list of data.frames - the output from a call to
\code{\link{bold_identify}}. or a single data.frame from the output from
same. required.}

\item{wide}{(logical) output in long or wide format. See Details.
Default: \code{FALSE}}

\item{taxid}{(character) A taxid name. Optional. See `Filtering` below.}

\item{taxon}{(character) A taxon name. Optional. See `Filtering` below.}

\item{tax_rank}{(character) A tax_rank name. Optional. See `Filtering` 
below.}

\item{tax_division}{(character) A tax_division name. Optional. See 
`Filtering` below.}

\item{parentid}{(character) A parentid name. Optional. See `Filtering` 
below.}

\item{parentname}{(character) A parentname name. Optional. See `Filtering` 
below.}

\item{taxonrep}{(character) A taxonrep name. Optional. See `Filtering` 
below.}

\item{specimenrecords}{(character) A specimenrecords name. Optional. 
See `Filtering` below.}

\item{...}{Further args passed on to \code{\link[crul]{verb-GET}}, main 
purpose being curl debugging}
}
\value{
a list of the same length as the input
}
\description{
Add taxonomic parent names to a data.frame
}
\details{
This function gets unique set of taxonomic names from the input
data.frame, then queries \code{\link{bold_tax_name}} to get the
taxonomic ID, passing it to \code{\link{bold_tax_id}} to get the parent
names, then attaches those to the input data.

Records in the input data that do not have matches for parent names
simply get NA values in the added columns.
}
\section{Filtering}{

The parameters `taxid`, `taxon`, `tax_rank`, `tax_division`, 
`parentid`, `parentname`,`taxonrep`, and `specimenrecords` are not used 
in the search sent to BOLD, but are used in filtering the data down 
to a subset that is closer to the target you want. For all these 
parameters, you can use regex strings since we use [grep()] internally 
to match. Filtering narrows down to the set that matches your query, 
and removes the rest. The data.frame that we filter on with these 
parameters internally is the result of a call to the [bold_tax_name()]
function.
}

\section{wide vs long format}{

When \code{wide = FALSE} you get many rows for each record. Essentially,
we \code{cbind} the taxonomic classification onto the one row from the
result of \code{\link{bold_identify}}, giving as many rows as there are
taxa in the taxonomic classification.

When \code{wide = TRUE} you get one row for each record - thus the
dimensions of the input data stay the same. For this option, we take just
the rows for taxonomic ID and name for each taxon in the taxonomic
classification, and name the columns by the taxon rank, so you get
\code{phylum} and \code{phylum_id}, and so on.
}

\examples{
\dontrun{
df <- bold_identify(sequences = sequences$seq2)

# long format
out <- bold_identify_parents(df)
str(out)
head(out[[1]])

# wide format
out <- bold_identify_parents(df, wide = TRUE)
str(out)
head(out[[1]])

x <- bold_seq(taxon = "Satyrium")
out <- bold_identify(c(x[[1]]$sequence, x[[13]]$sequence))
res <- bold_identify_parents(out)
res

x <- bold_seq(taxon = 'Diplura')
out <- bold_identify(vapply(x, "[[", "", "sequence")[1:20])
res <- bold_identify_parents(out)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bold_seq.R
\name{bold_seq}
\alias{bold_seq}
\title{Search BOLD for sequences.}
\usage{
bold_seq(
  taxon = NULL,
  ids = NULL,
  bin = NULL,
  container = NULL,
  institutions = NULL,
  researchers = NULL,
  geo = NULL,
  marker = NULL,
  response = FALSE,
  ...
)
}
\arguments{
\item{taxon}{(character) One or more taxonomic name. Optional.}

\item{ids}{(character|integer|numeric) One or more IDs. Optional. IDs
include Sample IDs, Process IDs, Museum IDs and Field IDs.}

\item{bin}{(character) One or more Barcode Index Number URI. Optional.}

\item{container}{(character) One or more project codes or dataset codes.
Optional.}

\item{institutions}{(character) One or more institution's name. Optional.
Institutions are the Specimen Storing Site.}

\item{researchers}{(character) One or more researcher names. Optional.
Include collectors and specimen identifiers.}

\item{geo}{(character) One or more geographic sites.
Includes countries and province/states.}

\item{marker}{(character) Returns all records containing matching
marker codes.}

\item{response}{(logical) Default : FALSE. If TRUE, returns the object from
the Curl call. Useful for debugging and getting more detailed info on the
API call.}

\item{...}{Further args passed on to
\code{\link[crul:verb-GET]{crul::verb-GET}}, main purpose being curl
debugging}
}
\value{
A data frame with each element as row and 5 columns for processid, identification,
marker, accession, and sequence.
}
\description{
Get sequences for a taxonomic name, id, bin, container, institution,
researcher, geographic, place, or gene.
}
\note{
If using the \code{taxon} parameter with another parameter, if the \code{taxon} isn't found in the public database, it will act as if no \code{taxon} was specified and try to return all the data for the other specified parameter. You can make sure that the \code{taxon} you're looking up has public records with \code{\link{bold_stats}}.
}
\section{Large requests}{

Some requests can lead to errors. These often have to do with requesting
data for a rank that is quite high in the tree, such as an Order,
for example, Coleoptera. If your request is taking a long time,
it's likely that something will go wrong on the BOLD server side,
or we'll not be able to parse the result here in R because
R can only process strings of a certain length. \code{bold}
users have reported errors in which the resulting response from
BOLD is so large that we could not parse it.

A good strategy for when you want data for a high rank is to
do many separate requests for lower ranks within your target
rank. You can do this manually, or use the function
\code{taxize::downstream} to get all the names of a lower
rank within a target rank. There's an example in the README
(https://docs.ropensci.org/bold/#large-data)
}

\section{If a request times out}{

This is likely because you're request was for a large number of
sequences and the BOLD service timed out. You still should get
some output, those sequences that were retrieved before the time
out happened. As above, see the README
(https://docs.ropensci.org/bold/#large-data) for an example of
dealing with large data problems with this function.
}

\section{Marker}{

Notes from BOLD on the \code{marker} param:
"All markers for a specimen matching the search string will be returned.
ie. A record with COI-5P and ITS will return sequence data for both
markers even if only COI-5P was specified."

You will likely end up with data with markers that you did not request -
just be sure to filter those out as needed.
}

\examples{
\dontrun{
bold_seq(taxon='Coelioxys')
bold_seq(taxon='Aglae')
bold_seq(taxon=c('Coelioxys','Osmia'))
bold_seq(ids='ACRJP618-11')
bold_seq(ids=c('ACRJP618-11','ACRJP619-11'))
bold_seq(bin='BOLD:AAA5125')
bold_seq(container='ACRJP')
bold_seq(researchers='Thibaud Decaens')
bold_seq(geo='Ireland')
bold_seq(geo=c('Ireland','Denmark'))

# Return the http response object for detailed Curl call response details
res <- bold_seq(taxon='Coelioxys', response=TRUE)
res$url
res$status_code
res$response_headers

## curl debugging
### You can do many things, including get verbose output on the curl
### call, and set a timeout
bold_seq(taxon='Coelioxys', verbose = TRUE)[1:2]
}

}
\references{
http://v4.boldsystems.org/index.php/resources/api?type=webservices
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bold_identify.R
\name{bold_identify}
\alias{bold_identify}
\title{Search for matches to sequences against the BOLD COI database.}
\usage{
bold_identify(sequences, db = "COX1", response = FALSE, ...)
}
\arguments{
\item{sequences}{(character) Returns all records containing matching marker
codes. Required. One or more. See Details.}

\item{db}{(character) The database to match against, one of COX1,
COX1_SPECIES, COX1_SPECIES_PUBLIC, OR COX1_L604bp. See Details for
more information.}

\item{response}{(logical) Note that response is the object that returns
from the Curl call, useful for debugging, and getting detailed info on
the API call.}

\item{...}{Further args passed on to \code{\link[crul]{HttpClient}}, main
purpose being curl debugging

BOLD only allows one sequence per query. We internally \code{lapply}
over the input values given to the \code{sequences} parameter to search
with one sequence per query. Remember this if you have a lot of sequences -
you are doing a separate query for each one, so it can take a long time -
if you run into errors let us know.}
}
\value{
A data.frame with details for each specimen matched. if a
failed request, returns \code{NULL}
}
\description{
Search for matches to sequences against the BOLD COI database.
}
\section{db parmeter options}{

\itemize{
 \item COX1 Every COI barcode record on BOLD with a minimum sequence
 length of 500bp (warning: unvalidated library and includes records without
 species level identification). This includes many species represented by
 only one or two specimens as well as all species with interim taxonomy. This
 search only returns a list of the nearest matches and does not provide a
 probability of placement to a taxon.
 \item COX1_SPECIES Every COI barcode record with a species level
 identification and a minimum sequence length of 500bp. This includes
 many species represented by only one or two specimens as well as  all
 species with interim taxonomy.
 \item COX1_SPECIES_PUBLIC All published COI records from BOLD and GenBank
 with a minimum sequence length of 500bp. This library is a collection of
 records from the published projects section of BOLD.
 \item OR COX1_L604bp Subset of the Species library with a minimum sequence
 length of 640bp and containing both public and private records. This library
 is intended for short sequence identification as it provides maximum overlap
 with short reads from the barcode region of COI.
}
}

\section{Named outputs}{

To maintain names on the output list of data make sure to pass in a
named list to the \code{sequences} parameter. You can for example,
take a list of sequences, and use \code{\link{setNames}} to set names.
}

\examples{
\dontrun{
seq <- sequences$seq1
res <- bold_identify(sequences=seq)
head(res[[1]])
head(bold_identify(sequences=seq, db='COX1_SPECIES')[[1]])
}
}
\references{
\url{http://v4.boldsystems.org/index.php/resources/api?type=idengine}
}
\seealso{
\code{\link{bold_identify_parents}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bold_tax_id.R
\name{bold_tax_id-deprecated}
\alias{bold_tax_id-deprecated}
\title{Search BOLD for taxonomy data by BOLD ID.}
\arguments{
\item{id}{(integer) One or more BOLD taxonomic identifiers. required.}

\item{dataTypes}{(character) Specifies the datatypes that will be
returned. 'all' returns all data. 'basic' returns basic taxon information.
'images' returns specimen images.}

\item{includeTree}{(logical) If \code{TRUE} (default: \code{FALSE}), returns a list
containing information for parent taxa as well as the specified taxon.}

\item{response}{(logical) Default : FALSE. If TRUE, returns the object from
the Curl call. Useful for debugging and getting more detailed info on the
API call.}

\item{...}{Further args passed on to
\code{\link[crul:verb-GET]{crul::verb-GET}}, main purpose being curl
debugging}
}
\description{
Search BOLD for taxonomy data by BOLD ID.
}
\seealso{
\code{\link{bold-deprecated}}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bold_seq.R
\name{bold_seq}
\alias{bold_seq}
\title{Search BOLD for sequences.}
\usage{
bold_seq(taxon = NULL, ids = NULL, bin = NULL, container = NULL,
  institutions = NULL, researchers = NULL, geo = NULL,
  marker = NULL, response = FALSE, ...)
}
\arguments{
\item{taxon}{(character) Returns all records containing matching taxa. Taxa 
includes the ranks of  phylum, class, order, family, subfamily, genus, 
and species.}

\item{ids}{(character) Returns all records containing matching IDs. IDs 
include Sample IDs, Process IDs, Museum IDs and Field IDs.}

\item{bin}{(character) Returns all records contained in matching BINs. A 
BIN is defined by a Barcode Index Number URI.}

\item{container}{(character) Returns all records contained in matching 
projects or datasets. Containers include project codes and dataset codes}

\item{institutions}{(character) Returns all records stored in matching 
institutions. Institutions are the Specimen Storing Site.}

\item{researchers}{(character) Returns all records containing matching 
researcher names. Researchers include collectors and specimen identifiers.}

\item{geo}{(character) Returns all records collected in matching geographic 
sites. Geographic sites includes countries and province/states.}

\item{marker}{(character) Returns all records containing matching 
marker codes.}

\item{response}{(logical) Note that response is the object that returns 
from the Curl call, useful for debugging, and getting detailed info on 
the API call.}

\item{...}{Further args passed on to \code{\link[crul]{HttpClient}}, main 
purpose being curl debugging}
}
\value{
A list with each element of length 4 with slots for id, name, 
gene, and sequence.
}
\description{
Get sequences for a taxonomic name, id, bin, container, institution, 
researcher, geographic, place, or gene.
}
\section{If a request times out}{

This is likely because you're request was for a large number of 
sequences and the BOLD service timed out. You still should get 
some output, those sequences that were retrieved before the time 
out happened. See the README (https://github.com/ropensci/bold/#bold)
for an example of dealing with large data problems with this function.
}

\examples{
\dontrun{
res <- bold_seq(taxon='Coelioxys')
bold_seq(taxon='Aglae')
bold_seq(taxon=c('Coelioxys','Osmia'))
bold_seq(ids='ACRJP618-11')
bold_seq(ids=c('ACRJP618-11','ACRJP619-11'))
bold_seq(bin='BOLD:AAA5125')
bold_seq(container='ACRJP')
bold_seq(researchers='Thibaud Decaens')
bold_seq(geo='Ireland')
bold_seq(geo=c('Ireland','Denmark'))

# Return the http response object for detailed Curl call response details
res <- bold_seq(taxon='Coelioxys', response=TRUE)
res$url
res$status_code
res$response_headers

## curl debugging
### You can do many things, including get verbose output on the curl 
### call, and set a timeout
bold_seq(taxon='Coelioxys', verbose = TRUE)[1:2]
# bold_seqspec(taxon='Coelioxys', timeout_ms = 10)
}
}
\references{
\url{http://v4.boldsystems.org/index.php/resources/api?type=webservices}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bold_trace.R
\name{bold_trace}
\alias{bold_trace}
\alias{print.boldtrace}
\alias{read_trace}
\alias{bold_read_trace}
\title{Get BOLD trace files}
\usage{
bold_trace(
  taxon = NULL,
  ids = NULL,
  bin = NULL,
  container = NULL,
  institutions = NULL,
  researchers = NULL,
  geo = NULL,
  marker = NULL,
  dest = NULL,
  overwrite = TRUE,
  progress = TRUE,
  ...
)

\method{print}{boldtrace}(x, ...)

read_trace(x)

bold_read_trace(x)
}
\arguments{
\item{taxon}{(character) One or more taxonomic name. Optional.}

\item{ids}{(character|integer|numeric) One or more IDs. Optional. IDs
include Sample IDs, Process IDs, Museum IDs and Field IDs.}

\item{bin}{(character) One or more Barcode Index Number URI. Optional.}

\item{container}{(character) One or more project codes or dataset codes.
Optional.}

\item{institutions}{(character) One or more institution's name. Optional.
Institutions are the Specimen Storing Site.}

\item{researchers}{(character) One or more researcher names. Optional.
Include collectors and specimen identifiers.}

\item{geo}{(character) One or more geographic sites.
Includes countries and province/states.}

\item{marker}{(character) Returns all records containing matching
marker codes.}

\item{dest}{(character) A directory to write the files to}

\item{overwrite}{(logical) Overwrite existing directory and file?}

\item{progress}{(logical) Print progress or not. NOT AVAILABLE FOR NOW.
HOPEFULLY WILL RETURN SOON.}

\item{...}{Further args passed on to \code{\link[crul]{verb-GET}}}

\item{x}{(list or character) Either the boldtrace object returned from
\code{\link[bold]{bold_trace}} or the path(s) of bold trace file(s).}
}
\description{
Get BOLD trace files
}
\examples{
\dontrun{
# Use a specific destination directory
bold_trace(taxon = "Bombus ignitus", geo = "Japan", dest = "~/mytarfiles")

# Another example
# bold_trace(ids='ACRJP618-11', dest="~/mytarfiles")
# bold_trace(ids=c('ACRJP618-11','ACRJP619-11'), dest="~/mytarfiles")

# read file in
x <- bold_trace(ids=c('ACRJP618-11','ACRJP619-11'), dest="~/mytarfiles")
(res <- read_trace(x$ab1[2]))
# read all files in
(res <- read_trace(x))

# The progress dialog is pretty verbose, so quiet=TRUE is a nice touch,
# but not by default
# Beware, this one take a while
# x <- bold_trace(taxon='Osmia', quiet=TRUE)

if (requireNamespace("sangerseqR", quietly = TRUE)) {
 library("sangerseqR")
 primarySeq(res)
 secondarySeq(res)
 head(traceMatrix(res))
}
}
}
\references{
http://v4.boldsystems.org/index.php/resources/api?type=webservices
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bold_trace.R
\name{bold_trace}
\alias{bold_trace}
\alias{read_trace}
\title{Get BOLD trace files}
\usage{
bold_trace(taxon = NULL, ids = NULL, bin = NULL, container = NULL,
  institutions = NULL, researchers = NULL, geo = NULL,
  marker = NULL, dest = NULL, overwrite = TRUE, progress = TRUE,
  ...)

read_trace(x)
}
\arguments{
\item{taxon}{(character) Returns all records containing matching taxa. Taxa 
includes the ranks of  phylum, class, order, family, subfamily, genus, 
and species.}

\item{ids}{(character) Returns all records containing matching IDs. IDs 
include Sample IDs, Process IDs, Museum IDs and Field IDs.}

\item{bin}{(character) Returns all records contained in matching BINs. A 
BIN is defined by a Barcode Index Number URI.}

\item{container}{(character) Returns all records contained in matching 
projects or datasets. Containers include project codes and dataset codes}

\item{institutions}{(character) Returns all records stored in matching 
institutions. Institutions are the Specimen Storing Site.}

\item{researchers}{(character) Returns all records containing matching 
researcher names. Researchers include collectors and specimen identifiers.}

\item{geo}{(character) Returns all records collected in matching geographic 
sites. Geographic sites includes countries and province/states.}

\item{marker}{(character) Returns all records containing matching
marker codes.}

\item{dest}{(character) A directory to write the files to}

\item{overwrite}{(logical) Overwrite existing directory and file?}

\item{progress}{(logical) Print progress or not. NOT AVAILABLE FOR NOW.
HOPEFULLY WILL RETURN SOON.}

\item{...}{Further args passed on to \code{\link[crul]{HttpClient}}}

\item{x}{Object to print or read.}
}
\description{
Get BOLD trace files
}
\examples{
\dontrun{
# Use a specific destination directory
bold_trace(taxon='Bombus', geo='Alaska', dest="~/mytarfiles")

# Another example
# bold_trace(ids='ACRJP618-11', dest="~/mytarfiles")
# bold_trace(ids=c('ACRJP618-11','ACRJP619-11'), dest="~/mytarfiles")

# read file in
x <- bold_trace(ids=c('ACRJP618-11','ACRJP619-11'), dest="~/mytarfiles")
(res <- read_trace(x$ab1[2]))

# The progress dialog is pretty verbose, so quiet=TRUE is a nice touch,
# but not by default
# Beware, this one take a while
# x <- bold_trace(taxon='Osmia', quiet=TRUE)

if (requireNamespace("sangerseqR", quietly = TRUE)) {
 library("sangerseqR")
 primarySeq(res)
 secondarySeq(res)
 head(traceMatrix(res))
}
}
}
\references{
\url{http://v4.boldsystems.org/index.php/resources/api?type=webservices}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bold_stats.R
\name{bold_stats}
\alias{bold_stats}
\title{Get BOLD stats}
\usage{
bold_stats(
  taxon = NULL,
  ids = NULL,
  bin = NULL,
  container = NULL,
  institutions = NULL,
  researchers = NULL,
  geo = NULL,
  dataType = "drill_down",
  response = FALSE,
  simplify = FALSE,
  ...
)
}
\arguments{
\item{taxon}{(character) One or more taxonomic name. Optional.}

\item{ids}{(character|integer|numeric) One or more IDs. Optional. IDs
include Sample IDs, Process IDs, Museum IDs and Field IDs.}

\item{bin}{(character) One or more Barcode Index Number URI. Optional.}

\item{container}{(character) One or more project codes or dataset codes.
Optional.}

\item{institutions}{(character) One or more institution's name. Optional.
Institutions are the Specimen Storing Site.}

\item{researchers}{(character) One or more researcher names. Optional.
Include collectors and specimen identifiers.}

\item{geo}{(character) One or more geographic sites.
Includes countries and province/states.}

\item{dataType}{(character) one of "drill_down"(default) or "overview".
"drill_down": a detailed summary of information which provides record counts
by BINs, Countries, Storing Institutions, Orders, Families, Genus, Species.
"overview": the total record counts of BINs, Countries, Storing Institutions,
Orders, Families, Genus, Species. The record counts include all gene markers, not only COI. To see the drill down of markers use \code{\link{bold_tax_id2}} with "stats" as \code{dataTypes}.}

\item{response}{(logical) Default : FALSE. If TRUE, returns the object from
the Curl call. Useful for debugging and getting more detailed info on the
API call.}

\item{simplify}{(logical) whether the returned list should be simplified to a data.frame. See Details.}

\item{...}{Further args passed on to
\code{\link[crul:verb-GET]{crul::verb-GET}}, main purpose being curl
debugging}
}
\value{
By default, returns a nested list with the number of total records, the number of records with a species name, then for each of bins, countries, depositories, order, family, genus and species, the total count and the drill down of the records by up to 10 entities of that category. If \code{simplify} is set to TRUE, returns a list of length 2 : the overview data (number of total records, the number of records with a species name, and the total counts) simplified as a data.frame of 1 row and 9 columns and the drill_down data simplified to a one level list of data.frame. When \code{dataType} is set to "overview", returns a nested list with the number of total records, the number of records with a species name, and the total count for each of bins, countries, depositories, order, family, genus and species. If \code{simplify} is set to TRUE, returns a data.frame of 1 row and 9 columns.
}
\description{
Get BOLD stats
}
\examples{
\dontrun{
x <- bold_stats(taxon='Osmia')
x$total_records
x$records_with_species_name
x$bins
x$countries
x$depositories
x$order
x$family
x$genus
x$species

# just get all counts
lapply(Filter(is.list, x), `[[`, "count")

bold_stats(taxon='Osmia', dataType = "overview", simplified = TRUE)

x <- bold_stats(taxon='Osmia', simplified = TRUE)
x$overview
x$drill_down

res <- bold_stats(taxon='Osmia', response=TRUE)
res$url
res$status_code
res$response_headers

# More than 1 can be given for all search parameters

## curl debugging
### These examples below take a long time, so you can set a timeout so that
### it stops by X sec
bold_stats(taxon='Osmia', verbose = TRUE)
# bold_stats(geo='Costa Rica', timeout_ms = 6)
}

}
\references{
http://v4.boldsystems.org/index.php/resources/api?type=webservices
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bold_identify_parents.R
\name{bold_identify_parents-deprecated}
\alias{bold_identify_parents-deprecated}
\title{Add taxonomic parent names to a data.frame}
\arguments{
\item{x}{(data.frame/list) list of data.frames - the output from a call to
\code{\link{bold_identify}}. or a single data.frame from the output from same.
required.}

\item{wide}{(logical) output in long or wide format. See Details.
Default: \code{FALSE}}

\item{taxid}{(character) A taxid name. Optional. See \code{Filtering} below.}

\item{taxon}{(character) A taxon name. Optional. See \code{Filtering} below.}

\item{tax_rank}{(character) A tax_rank name. Optional. See \code{Filtering}
below.}

\item{tax_division}{(character) A tax_division name. Optional. See
\code{Filtering} below.}

\item{parentid}{(character) A parentid name. Optional. See \code{Filtering}
below.}

\item{parentname}{(character) A parentname name. Optional. See \code{Filtering}
below.}

\item{taxonrep}{(character) A taxonrep name. Optional. See \code{Filtering}
below.}

\item{specimenrecords}{(character) A specimenrecords name. Optional.
See \code{Filtering} below.}

\item{...}{Further args passed on to \code{\link[crul]{verb-GET}}, main
purpose being curl debugging}
}
\description{
Add taxonomic parent names to a data.frame
}
\seealso{
\code{\link{bold-deprecated}}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bold_stats.R
\name{bold_stats}
\alias{bold_stats}
\title{Get BOLD stats}
\usage{
bold_stats(taxon = NULL, ids = NULL, bin = NULL, container = NULL,
  institutions = NULL, researchers = NULL, geo = NULL,
  dataType = "drill_down", response = FALSE, ...)
}
\arguments{
\item{taxon}{(character) Returns all records containing matching taxa. Taxa 
includes the ranks of  phylum, class, order, family, subfamily, genus, 
and species.}

\item{ids}{(character) Returns all records containing matching IDs. IDs 
include Sample IDs, Process IDs, Museum IDs and Field IDs.}

\item{bin}{(character) Returns all records contained in matching BINs. A 
BIN is defined by a Barcode Index Number URI.}

\item{container}{(character) Returns all records contained in matching 
projects or datasets. Containers include project codes and dataset codes}

\item{institutions}{(character) Returns all records stored in matching 
institutions. Institutions are the Specimen Storing Site.}

\item{researchers}{(character) Returns all records containing matching 
researcher names. Researchers include collectors and specimen identifiers.}

\item{geo}{(character) Returns all records collected in matching geographic 
sites. Geographic sites includes countries and province/states.}

\item{dataType}{(character) one of "overview" or "drill_down" (default).
"drill_down": a detailed summary of information which provides record 
counts by [BINs, Country, Storing Institution, Species]. "overview": 
the total counts of [BINs, Countries, Storing Institutions, Orders, 
Families, Genus, Species]}

\item{response}{(logical) Note that response is the object that returns 
from the Curl call, useful for debugging, and getting detailed info on 
the API call.}

\item{...}{Further args passed on to \code{\link[crul]{HttpClient}}, main 
purpose being curl debugging}
}
\description{
Get BOLD stats
}
\examples{
\dontrun{
x <- bold_stats(taxon='Osmia')
x$total_records
x$records_with_species_name
x$bins
x$countries
x$depositories
x$order
x$family
x$genus
x$species

# just get all counts
lapply(Filter(is.list, x), "[[", "count")

res <- bold_stats(taxon='Osmia', response=TRUE)
res$url
res$status_code
res$response_headers

# More than 1 can be given for all search parameters
bold_stats(taxon=c('Coelioxys','Osmia'))

## curl debugging
### These examples below take a long time, so you can set a timeout so that
### it stops by X sec
bold_stats(taxon='Osmia', verbose = TRUE)
# bold_stats(geo='Costa Rica', timeout_ms = 6)
}
}
\references{
\url{http://v4.boldsystems.org/index.php/resources/api?type=webservices}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bold_specimens.R
\name{bold_specimens}
\alias{bold_specimens}
\title{Search BOLD for specimens.}
\usage{
bold_specimens(taxon = NULL, ids = NULL, bin = NULL,
  container = NULL, institutions = NULL, researchers = NULL,
  geo = NULL, response = FALSE, format = "tsv", ...)
}
\arguments{
\item{taxon}{(character) Returns all records containing matching taxa. Taxa 
includes the ranks of  phylum, class, order, family, subfamily, genus, 
and species.}

\item{ids}{(character) Returns all records containing matching IDs. IDs 
include Sample IDs, Process IDs, Museum IDs and Field IDs.}

\item{bin}{(character) Returns all records contained in matching BINs. A 
BIN is defined by a Barcode Index Number URI.}

\item{container}{(character) Returns all records contained in matching 
projects or datasets. Containers include project codes and dataset codes}

\item{institutions}{(character) Returns all records stored in matching 
institutions. Institutions are the Specimen Storing Site.}

\item{researchers}{(character) Returns all records containing matching 
researcher names. Researchers include collectors and specimen identifiers.}

\item{geo}{(character) Returns all records collected in matching geographic 
sites. Geographic sites includes countries and province/states.}

\item{response}{(logical) Note that response is the object that returns 
from the Curl call, useful for debugging, and getting detailed info on 
the API call.}

\item{format}{(character) One of xml, json, tsv (default). tsv format gives 
back a data.frame object. xml gives back parsed XML as \code{xml_document}
object. 'json' (JavaScript Object Notation) and 'dwc' (Darwin Core Archive)
are supported in theory, but the JSON can be malformed, so we don't support
that here, and the DWC option actually returns TSV.}

\item{...}{Further args passed on to \code{\link[crul]{HttpClient}}, main 
purpose being curl debugging}
}
\description{
Search BOLD for specimens.
}
\examples{
\dontrun{
bold_specimens(taxon='Osmia')
bold_specimens(taxon='Osmia', format='xml')
bold_specimens(taxon='Osmia', response=TRUE)
res <- bold_specimens(taxon='Osmia', format='xml', response=TRUE)
res$url
res$status_code
res$response_headers

# More than 1 can be given for all search parameters
bold_specimens(taxon=c('Coelioxys','Osmia'))

## curl debugging
### These examples below take a long time, so you can set a timeout so that 
### it stops by X sec
head(bold_specimens(taxon='Osmia', verbose = TRUE))
# head(bold_specimens(geo='Costa Rica', timeout_ms = 6))
}
}
\references{
\url{http://v4.boldsystems.org/index.php/resources/api?type=webservices}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bold_specimens.R
\name{bold_specimens}
\alias{bold_specimens}
\title{Search BOLD for specimens.}
\usage{
bold_specimens(
  taxon = NULL,
  ids = NULL,
  bin = NULL,
  container = NULL,
  institutions = NULL,
  researchers = NULL,
  geo = NULL,
  response = FALSE,
  format = "tsv",
  cleanData = FALSE,
  ...
)
}
\arguments{
\item{taxon}{(character) One or more taxonomic name. Optional.}

\item{ids}{(character|integer|numeric) One or more IDs. Optional. IDs
include Sample IDs, Process IDs, Museum IDs and Field IDs.}

\item{bin}{(character) One or more Barcode Index Number URI. Optional.}

\item{container}{(character) One or more project codes or dataset codes.
Optional.}

\item{institutions}{(character) One or more institution's name. Optional.
Institutions are the Specimen Storing Site.}

\item{researchers}{(character) One or more researcher names. Optional.
Include collectors and specimen identifiers.}

\item{geo}{(character) One or more geographic sites.
Includes countries and province/states.}

\item{response}{(logical) Default : FALSE. If TRUE, returns the object from
the Curl call. Useful for debugging and getting more detailed info on the
API call.}

\item{format}{(character) One of xml, json, tsv (default). tsv format gives
back a data.frame object. xml gives back parsed XML as \code{xml_document}
object. 'json' (JavaScript Object Notation) and 'dwc' (Darwin Core Archive)
are supported in theory, but the JSON can be malformed, so we don't support
that here, and the DWC option actually returns TSV.}

\item{cleanData}{(logical) If \code{TRUE}, the cell values containing only duplicated values (ex : "COI-5P|COI-5P|COI-5P") will be reduce to one value ("COI-5P") and empty string will be change to NA. Default: \code{FALSE}}

\item{...}{Further args passed on to
\code{\link[crul:verb-GET]{crul::verb-GET}}, main purpose being curl
debugging}
}
\description{
Search BOLD for specimens.
}
\note{
If using the \code{taxon} parameter with another parameter, if the \code{taxon} isn't found in the public database, it will act as if no \code{taxon} was specified and try to return all the data for the other specified parameter. You can make sure that the \code{taxon} you're looking up has public records with \code{\link{bold_stats}}.
}
\examples{
\dontrun{
bold_specimens(taxon='Osmia')
bold_specimens(taxon='Osmia', format='xml')
bold_specimens(taxon='Osmia', response=TRUE)
res <- bold_specimens(taxon='Osmia', format='xml', response=TRUE)
res$url
res$status_code
res$response_headers

# More than 1 can be given for all search parameters
bold_specimens(taxon=c('Coelioxys','Osmia'))

## curl debugging
### These examples below take a long time, so you can set a timeout so that
### it stops by X sec
head(bold_specimens(taxon='Osmia', verbose = TRUE))
# head(bold_specimens(geo='Costa Rica', timeout_ms = 6))
}

}
\references{
http://v4.boldsystems.org/index.php/resources/api?type=webservices
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bold_filter.R
\name{bold_filter}
\alias{bold_filter}
\title{Filter BOLD specimen + sequence data (output of bold_seqspec)}
\usage{
bold_filter(x, by, how = "max")
}
\arguments{
\item{x}{(data.frame) a data.frame, as returned from
\code{\link{bold_seqspec}}. Note that some combinations of parameters
in \code{\link{bold_seqspec}} don't return a data.frame. Stops with
error message if this is not a data.frame. Required.}

\item{by}{(character) the column by which to group. For example,
if you want the longest sequence for each unique species name, then
pass \strong{species_name}. If the column doesn't exist, error
with message saying so. Required.}

\item{how}{(character) one of "max" or "min", which get used as
\code{which.max} or \code{which.min} to get the longest or shortest
sequence, respectively. Note that we remove gap/alignment characters
(\code{-})}
}
\value{
a tibble/data.frame
}
\description{
Picks either shortest or longest sequences, for a given grouping variable
(e.g., species name)
}
\examples{
\dontrun{
res <- bold_seqspec(taxon='Osmia')
maxx <- bold_filter(res, by = "species_name")
minn <- bold_filter(res, by = "species_name", how = "min")

vapply(maxx$nucleotides, nchar, 1, USE.NAMES = FALSE)
vapply(minn$nucleotides, nchar, 1, USE.NAMES = FALSE)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bold_filter.R
\name{bold_filter}
\alias{bold_filter}
\title{Filter BOLD specimen + sequence data (output of bold_seqspec)}
\usage{
bold_filter(x, by, how = "max", returnTibble = TRUE)
}
\arguments{
\item{x}{(data.frame) a data.frame, as returned from
\code{\link{bold_seqspec}}. Note that some combinations of parameters
in \code{\link{bold_seqspec}} don't return a data.frame. Stops with
error message if this is not a data.frame. Required.}

\item{by}{(character) the column by which to group. For example,
if you want the longest sequence for each unique species name, then
pass \strong{species_name}. If the column doesn't exist, error
with message saying so. Required.}

\item{how}{(character) one of "max" or "min", which get used as
\code{which.max} or \code{which.min} to get the longest or shortest
sequence, respectively. Note that we remove gap/alignment characters
(\code{-})}

\item{returnTibble}{Whether the output should be a tibble or
a data.frame. Default is TRUE, but verifies that the \code{tibble} package is
installed, if it's not, it will be returned as data.frame.
Since this package is only used in this function, doing this so it can be
moved to suggested instead of dependency without breaking old scripts.}
}
\value{
a data.frame
}
\description{
Picks either shortest or longest sequences, for a given grouping variable
(e.g., species name)
}
\examples{
\dontrun{
res <- bold_seqspec(taxon = 'Osmia')
maxx <- bold_filter(res, by = "species_name")
minn <- bold_filter(res, by = "species_name", how = "min")

vapply(maxx$nucleotides, nchar, 1, USE.NAMES = FALSE)
vapply(minn$nucleotides, nchar, 1, USE.NAMES = FALSE)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bold_identify_taxonomy.R
\name{bold_identify_taxonomy}
\alias{bold_identify_taxonomy}
\alias{bold_identify_taxonomy,list-method}
\alias{bold_identify_taxonomy,matrix-method}
\alias{bold_identify_taxonomy,data.frame-method}
\alias{bold_identify_taxonomy,missing-method}
\title{Add taxonomic parent names to a data set containing the process IDs of identified sequences.}
\usage{
bold_identify_taxonomy(x, taxOnly = TRUE)

\S4method{bold_identify_taxonomy}{list}(x, taxOnly = TRUE)

\S4method{bold_identify_taxonomy}{matrix}(x, taxOnly = TRUE)

\S4method{bold_identify_taxonomy}{data.frame}(x, taxOnly = TRUE)

\S4method{bold_identify_taxonomy}{missing}(x, taxOnly = TRUE)
}
\arguments{
\item{x}{A single data.frame or matrix, or a list of. Usually the output from a call to \code{\link{bold_identify}}. Required.}

\item{taxOnly}{(logical) If TRUE (Default), only the taxonomic names and ids are added (equivalent format to the results of \code{\link{bold_identify_parents}} when \code{wide}is set to TRUE. If FALSE, also joins the rest of the data returned by \code{\link{bold_specimens}}.}
}
\value{
a data.frame or a list of data.frames with added taxonomic
classification.
}
\description{
Add taxonomic parent names to a data set containing the process IDs of identified sequences.
}
\details{
This function gets the process ids from the
input data.frame(s) (ID column), then queries \code{\link{bold_specimens}}
to get the sample information and adds it to the input data.frame(s).

Records in the input data that do not have matches for parent names
simply get NA values in the added columns.
}
\examples{
\dontrun{
seqs <- bold_identify(sequences = bold::sequences$seq2)

seqs_tax <- bold_identify_taxonomy(seqs)
head(seqs_tax[[1]])

x <- bold_seq(taxon = "Satyrium")
seqs <- bold_identify(x$sequence[1:2])
seqs_tax <- bold_identify_taxonomy(seqs)
seqs_tax
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bold_tax_id2.R
\name{bold_tax_id2}
\alias{bold_tax_id2}
\title{Search BOLD for taxonomy data by BOLD ID.}
\usage{
bold_tax_id2(
  id,
  dataTypes = "basic",
  includeTree = FALSE,
  response = FALSE,
  ...
)
}
\arguments{
\item{id}{(integer|numeric|character) One or more BOLD taxonomic identifiers. required.}

\item{dataTypes}{(character) One or more BOLD data types: 'basic', 'stats', 'geo', 'images'/'img', 'sequencinglabs'/'labs', 'depository'/'depo', 'thirdparty'/'wiki' or 'all' (default: 'basic'). Specifies the information that will be returned, see details.}

\item{includeTree}{(logical) If \code{TRUE} (default: \code{FALSE}), returns the information for parent taxa as well as the specified taxon, see details.}

\item{response}{(logical) Default : FALSE. If TRUE, returns the object from
the Curl call. Useful for debugging and getting more detailed info on the
API call.}

\item{...}{Further args passed on to
\code{\link[crul:verb-GET]{crul::verb-GET}}, main purpose being curl
debugging}
}
\description{
Search BOLD for taxonomy data by BOLD ID.
}
\section{dataTypes}{

"basic" returns basic taxonomy info: includes taxid, taxon name, tax rank, tax division, parent taxid, parent taxon name.
"stats" returns specimen and sequence statistics: includes public species count, public BIN count, public marker counts, public record count, specimen count, sequenced specimen count, barcode specimen count, species count, barcode species count.
"geo" returns collection site information: includes country, collection site map.
"images" returns specimen images: includes copyright information, image URL, image metadata.
"sequencinglabs" returns sequencing labs: includes lab name, record count.
"depository" returns specimen depositories: includes depository name, record count.
"thirdparty" returns information from third parties: includes wikipedia_summary summary, wikipedia_summary URL.
"all" returns all information: identical to specifying all data types at once.
}

\section{includeTree}{

When \code{includeTree} is set to true, for the \code{dataTypes} other than 'basic' the information of the parent taxa are identified by their taxonomic id only. To get their ranks and names too, make sure 'basic' is in \code{dataTypes}.
}

\examples{
\dontrun{
bold_tax_id2(id = 88899)
bold_tax_id2(id = 88899, includeTree = TRUE)
bold_tax_id2(id = 88899, includeTree = TRUE, dataTypes = "stats")
bold_tax_id2(id = c(88899, 125295))

## dataTypes parameter
bold_tax_id2(id = 88899, dataTypes = "basic")
bold_tax_id2(id = 88899, dataTypes = "stats")
bold_tax_id2(id = 88899, dataTypes = "images")
bold_tax_id2(id = 88899, dataTypes = "geo")
bold_tax_id2(id = 88899, dataTypes = "sequencinglabs")
bold_tax_id2(id = 88899, dataTypes = "depository")
bold_tax_id2(id = 88899, dataTypes = "thirdparty")
bold_tax_id2(id = 88899, dataTypes = "all")
bold_tax_id2(id = c(88899, 125295), dataTypes = c("basic", "geo"))
bold_tax_id2(id = c(88899, 125295), dataTypes = c("basic", "stats", "images"))

## Passing in NA
bold_tax_id2(id = NA)
bold_tax_id2(id = c(88899, 125295, NA))

## get http response object only
bold_tax_id2(id = 88899, response = TRUE)
bold_tax_id2(id = c(88899, 125295), response = TRUE)

## curl debugging
bold_tax_id2(id = 88899, verbose = TRUE)
}

}
\references{
http://v4.boldsystems.org/index.php/resources/api?type=taxonomy
}
\seealso{
\code{\link{bold_tax_name}}, \code{\link{bold_get_attr}}, \code{\link{bold_get_errors}}, \code{\link{bold_get_params}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bold_seqspec.R
\name{bold_seqspec}
\alias{bold_seqspec}
\title{Get BOLD specimen + sequence data.}
\usage{
bold_seqspec(
  taxon = NULL,
  ids = NULL,
  bin = NULL,
  container = NULL,
  institutions = NULL,
  researchers = NULL,
  geo = NULL,
  marker = NULL,
  response = FALSE,
  format = "tsv",
  sepfasta = FALSE,
  ...
)
}
\arguments{
\item{taxon}{(character) Returns all records containing matching taxa. Taxa
includes the ranks of  phylum, class, order, family, subfamily, genus,
and species.}

\item{ids}{(character) Returns all records containing matching IDs. IDs
include Sample IDs, Process IDs, Museum IDs and Field IDs.}

\item{bin}{(character) Returns all records contained in matching BINs. A
BIN is defined by a Barcode Index Number URI.}

\item{container}{(character) Returns all records contained in matching
projects or datasets. Containers include project codes and dataset codes}

\item{institutions}{(character) Returns all records stored in matching
institutions. Institutions are the Specimen Storing Site.}

\item{researchers}{(character) Returns all records containing matching
researcher names. Researchers include collectors and specimen identifiers.}

\item{geo}{(character) Returns all records collected in matching geographic
sites. Geographic sites includes countries and province/states.}

\item{marker}{(character) Returns all records containing matching marker
codes. See Details.}

\item{response}{(logical) Note that response is the object that returns
from the Curl call, useful for debugging, and getting detailed info on
the API call.}

\item{format}{(character) One of xml or tsv (default). tsv format gives
back a data.frame object. xml gives back parsed xml as a}

\item{sepfasta}{(logical) If \code{TRUE}, the fasta data is separated into
a list with names matching the processid's from the data frame.
Default: \code{FALSE}}

\item{...}{Further args passed on to
\code{\link[crul:verb-GET]{crul::verb-GET}}, main purpose being curl
debugging}
}
\value{
Either a data.frame, parsed xml, a http response object, or a list
with length two (a data.frame w/o nucleotide data, and a list with
nucleotide data)
}
\description{
Get BOLD specimen + sequence data.
}
\section{Large requests}{

Some requests can lead to errors. These often have to do with requesting
data for a rank that is quite high in the tree, such as an Order,
for example, Coleoptera. If your request is taking a long time,
it's likely that something will go wrong on the BOLD server side,
or we'll not be able to parse the result here in R because
R can only process strings of a certain length. \code{bold}
users have reported errors in which the resulting response from
BOLD is so large that we could not parse it.

A good strategy for when you want data for a high rank is to
do many separate requests for lower ranks within your target
rank. You can do this manually, or use the function
\code{taxize::downstream} to get all the names of a lower
rank within a target rank. There's an example in the README
(https://docs.ropensci.org/bold/#large-data)
}

\section{If a request times out}{

This is likely because you're request was for a large number of
sequences and the BOLD service timed out. You still should get
some output, those sequences that were retrieved before the time
out happened. As above, see the README
(https://docs.ropensci.org/bold/#large-data) for an example of
dealing with large data problems with this function.
}

\section{Marker}{

Notes from BOLD on the \code{marker} param:
"All markers for a specimen matching the search string will be returned.
ie. A record with COI-5P and ITS will return sequence data for both
markers even if only COI-5P was specified."

You will likely end up with data with markers that you did not request -
just be sure to filter those out as needed.
}

\examples{
\dontrun{
bold_seqspec(taxon='Osmia')
bold_seqspec(taxon='Osmia', format='xml')
bold_seqspec(taxon='Osmia', response=TRUE)
res <- bold_seqspec(taxon='Osmia', sepfasta=TRUE)
res$fasta[1:2]
res$fasta['GBAH0293-06']

# records that match a marker name
res <- bold_seqspec(taxon="Melanogrammus aeglefinus", marker="COI-5P")

# records that match a geographic locality
res <- bold_seqspec(taxon="Melanogrammus aeglefinus", geo="Canada")

## curl debugging
### You can do many things, including get verbose output on the curl call,
### and set a timeout
head(bold_seqspec(taxon='Osmia', verbose = TRUE))
## timeout
# head(bold_seqspec(taxon='Osmia', timeout_ms = 1))
}
}
\references{
http://v4.boldsystems.org/index.php/resources/api?type=webservices
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bold-package.R
\docType{package}
\name{bold-package}
\alias{bold-package}
\alias{bold}
\title{bold: A programmatic interface to the Barcode of Life data.}
\description{
bold: A programmatic interface to the Barcode of Life data.
}
\section{About}{


This package gives you access to data from BOLD System 
\url{http://www.boldsystems.org/} via their API 
(\url{http://v4.boldsystems.org/index.php/api_home})
}

\section{Functions}{


\itemize{
 \item \code{\link{bold_specimens}} - Search for specimen data.
 \item \code{\link{bold_seq}} - Search for and retrieve sequences.
 \item \code{\link{bold_seqspec}} - Get sequence and specimen data together.
 \item \code{\link{bold_trace}} - Get trace files - saves to disk.
 \item \code{\link{read_trace}} - Read trace files into R.
 \item \code{\link{bold_tax_name}} - Get taxonomic names via input names.
 \item \code{\link{bold_tax_id}} - Get taxonomic names via BOLD identifiers.
 \item \code{\link{bold_identify}} - Search for match given a COI sequence.
}

Interestingly, they provide xml and tsv format data for the specimen data, 
while  they provide fasta data format for the sequence data. So for the 
specimen data  you can get back raw XML, or a data frame parsed from the 
tsv data, while for sequence data you get back a list (b/c sequences are 
quite long and would make a data frame unwieldy).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bold-package.R
\docType{data}
\name{sequences}
\alias{sequences}
\title{List of 3 nucleotide sequences to use in examples for the 
\code{\link{bold_identify}} function}
\description{
List of 3 nucleotide sequences to use in examples for the 
\code{\link{bold_identify}} function
}
\details{
Each sequence is a character string, of lengths 410, 600, and 696.
}
\keyword{data}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bold-package.R
\docType{package}
\name{bold-package}
\alias{bold-package}
\alias{bold}
\title{bold}
\description{
bold: A programmatic interface to the Barcode of Life data
}
\section{About}{


This package gives you access to data from BOLD System
http://www.boldsystems.org/ via their API
(http://v4.boldsystems.org/index.php/api_home)
}

\section{Functions}{

\itemize{
\item \code{\link{bold_specimens}} - Search for specimen data
\item \code{\link{bold_seq}} - Search for and retrieve sequences
\item \code{\link{bold_seqspec}} - Get sequence and specimen data together
\item \code{\link{bold_trace}} - Get trace files - saves to disk
\item \code{\link{read_trace}} - Read trace files into R
\item \code{\link{bold_tax_name}} - Get taxonomic names via input names
\item \code{\link{bold_tax_id}} - Get taxonomic names via BOLD identifiers (Deprecated)
\item \code{\link{bold_tax_id2}} - Get taxonomic names via BOLD identifiers (improved)
\item \code{\link{bold_identify}} - Search for match given a COI sequence
\item \code{\link{bold_identify_parents}} - Adds guessed parent ranks (Deprecated)
\item \code{\link{bold_identify_taxonomy}} - Adds real parent ranks.
}

Interestingly, they provide xml and tsv format data for the specimen data,
while they provide fasta data format for the sequence data. So for the
specimen data you can get back raw XML, or a data frame parsed from the
tsv data, while for sequence data you get back a list (b/c sequences are
quite long and would make a data frame unwieldy).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bold_tax_id.R
\name{bold_tax_id}
\alias{bold_tax_id}
\title{Search BOLD for taxonomy data by BOLD ID.}
\usage{
bold_tax_id(
  id,
  dataTypes = "basic",
  includeTree = FALSE,
  response = FALSE,
  ...
)
}
\arguments{
\item{id}{(integer) One or more BOLD taxonomic identifiers. required.}

\item{dataTypes}{(character) Specifies the datatypes that will be
returned. 'all' returns all data. 'basic' returns basic taxon information.
'images' returns specimen images.}

\item{includeTree}{(logical) If \code{TRUE} (default: \code{FALSE}), returns a list
containing information for parent taxa as well as the specified taxon.}

\item{response}{(logical) Note that response is the object that returns
from the Curl call, useful for debugging, and getting detailed info on
the API call.}

\item{...}{Further args passed on to
\code{\link[crul:verb-GET]{crul::verb-GET}}, main purpose being curl
debugging}
}
\description{
Search BOLD for taxonomy data by BOLD ID.
}
\examples{
\dontrun{
bold_tax_id(id=88899)
bold_tax_id(id=88899, includeTree=TRUE)
bold_tax_id(id=88899, includeTree=TRUE, dataTypes = "stats")
bold_tax_id(id=c(88899,125295))

## dataTypes parameter
bold_tax_id(id=88899, dataTypes = "basic")
bold_tax_id(id=88899, dataTypes = "stats")
bold_tax_id(id=88899, dataTypes = "images")
bold_tax_id(id=88899, dataTypes = "geo")
bold_tax_id(id=88899, dataTypes = "sequencinglabs")
bold_tax_id(id=88899, dataTypes = "depository")
bold_tax_id(id=c(88899,125295), dataTypes = "geo")
bold_tax_id(id=c(88899,125295), dataTypes = "images")

## Passing in NA
bold_tax_id(id = NA)
bold_tax_id(id = c(88899,125295,NA))

## get http response object only
bold_tax_id(id=88899, response=TRUE)
bold_tax_id(id=c(88899,125295), response=TRUE)

## curl debugging
bold_tax_id(id=88899, verbose = TRUE)
}
}
\references{
http://v4.boldsystems.org/index.php/resources/api?type=taxonomy
}
\seealso{
\code{\link[=bold_tax_name]{bold_tax_name()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_attr.R
\name{bold_get_attr}
\alias{bold_get_attr}
\alias{bold_get_errors}
\alias{bold_get_params}
\title{Get the error messages and parameters used for a request from a bold output.}
\usage{
bold_get_attr(x)

bold_get_errors(x)

bold_get_params(x)
}
\arguments{
\item{x}{Any object with an attribute "params". Usually the output of \code{\link{bold_tax_name}} or \code{\link{bold_tax_id2}}.}
}
\value{
A list of the attributes 'errors' and 'params' of the object.

The 'errors' attribute of the object.

The 'params' attribute of the object.
}
\description{
Get the error messages and parameters used for a request from a bold output.

Get the error messages from a bold output.

Get the parameters used for a request from a bold output.
}
\examples{
\dontrun{
x <- bold_tax_name(name=c("Apis","Felis","Pinus"), tax_division = "Animalia")
bold_get_errors(x)
y <- bold_tax_id2(id = c(88899999, 125295, NA_integer_), dataTypes = c("basic", "stats"))
bold_get_errors(y)
}
\dontrun{
x <- bold_tax_name(name=c("Apis","Felis","Pinus"), tax_division = "Animalia")
bold_get_errors(x)
y <- bold_tax_id2(id = c(88899999, 125295, NA_integer_), dataTypes = c("basic", "stats"))
bold_get_errors(y)
}
\dontrun{
x <- bold_tax_name(name=c("Apis","Felis","Pinus"), tax_division = "Animalia")
bold_get_params(x)
y <- bold_tax_id2(id = c(88899999, 125295, NA_integer_), dataTypes = c("basic", "stats"))
bold_get_params(y)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bold_tax_name.R
\name{bold_tax_name}
\alias{bold_tax_name}
\title{Search BOLD for taxonomy data by taxonomic name}
\usage{
bold_tax_name(name, fuzzy = FALSE, response = FALSE, ...)
}
\arguments{
\item{name}{(character) One or more scientific names. required.}

\item{fuzzy}{(logical) Whether to use fuzzy search or not (default: FALSE).}

\item{response}{(logical) Note that response is the object that returns 
from the Curl call, useful for debugging, and getting detailed info on 
the API call.}

\item{...}{Further args passed on to \code{\link[crul]{HttpClient}}, main 
purpose being curl debugging}
}
\description{
Search BOLD for taxonomy data by taxonomic name
}
\details{
The \code{dataTypes} parameter is not supported in this function. 
If you want to use that parameter, get an ID from this function and pass 
it into \code{bold_tax_id}, and then use the \code{dataTypes} parameter.
}
\examples{
\dontrun{
bold_tax_name(name='Diplura')
bold_tax_name(name='Osmia')
bold_tax_name(name=c('Diplura','Osmia'))
bold_tax_name(name=c("Apis","Puma concolor","Pinus concolor"))
bold_tax_name(name='Diplur', fuzzy=TRUE)
bold_tax_name(name='Osm', fuzzy=TRUE)

## get http response object only
bold_tax_name(name='Diplura', response=TRUE)
bold_tax_name(name=c('Diplura','Osmia'), response=TRUE)

## Names with no data in BOLD database
bold_tax_name("Nasiaeshna pentacantha")
bold_tax_name(name = "Cordulegaster erronea")
bold_tax_name(name = "Cordulegaster erronea", response=TRUE)

## curl debugging
bold_tax_name(name='Diplura', verbose = TRUE)
}
}
\references{
\url{http://v4.boldsystems.org/index.php/resources/api?type=taxonomy}
}
\seealso{
\code{\link{bold_tax_id}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bold-package.R
\docType{data}
\name{sequences}
\alias{sequences}
\title{List of 3 nucleotide sequences to use in examples for the
\code{\link{bold_identify}} function}
\format{
list of length 3
}
\description{
List of 3 nucleotide sequences to use in examples for the
\code{\link{bold_identify}} function
}
\details{
Each sequence is a character string, of lengths 410, 600, and 696.
}
\keyword{data}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bold-deprecated.R, R/bold_identify_parents.R,
%   R/bold_tax_id.R
\name{bold-deprecated}
\alias{bold-deprecated}
\alias{bold_identify_parents}
\alias{bold_tax_id}
\title{Deprecated functions in package \pkg{bold}.}
\usage{
bold_identify_parents(
  x,
  wide = FALSE,
  taxid = NULL,
  taxon = NULL,
  tax_rank = NULL,
  tax_division = NULL,
  parentid = NULL,
  parentname = NULL,
  taxonrep = NULL,
  specimenrecords = NULL,
  ...
)

bold_tax_id(
  id,
  dataTypes = "basic",
  includeTree = FALSE,
  response = FALSE,
  ...
)
}
\value{
a list of the same length as the input
}
\description{
The functions listed below are deprecated and will be defunct in
the near future. When possible, alternative functions with similar
functionality are also mentioned. Help pages for deprecated functions are
available at \code{help("<function>-deprecated")}.
}
\details{
DEPRECATED. See \code{\link{bold_identify_taxonomy}}. It's faster and gets the accurate  taxonomy directly from the record of the sequence.

This function gets unique set of taxonomic names from the input
data.frame, then queries \code{\link{bold_tax_name}} to get the
taxonomic ID, passing it to \code{\link{bold_tax_id}} to get the parent
names, then attaches those to the input data.

Records in the input data that do not have matches for parent names
simply get NA values in the added columns.
}
\section{\code{bold_identify_parents}}{

For \code{bold_identify_parents}, use \code{\link{bold_identify_taxonomy}}.
}

\section{Filtering}{

The parameters \code{taxid}, \code{taxon}, \code{tax_rank}, \code{tax_division},
\code{parentid}, \code{parentname},\code{taxonrep}, and \code{specimenrecords} are not used
in the search sent to BOLD, but are used in filtering the data down
to a subset that is closer to the target you want. For all these
parameters, you can use regex strings since we use \code{\link[base]{grep}}
internally to match. Filtering narrows down to the set that matches your
query, and removes the rest. The data.frame that we filter on with these
parameters internally is the result of a call to the
\code{\link{bold_tax_name}} function.
}

\section{wide vs long format}{

When \code{wide = FALSE} you get many rows for each record. Essentially,
we \code{cbind} the taxonomic classification onto the one row from the
result of \code{\link{bold_identify}}, giving as many rows as there are
taxa in the taxonomic classification.

When \code{wide = TRUE} you get one row for each record - thus the
dimensions of the input data stay the same. For this option, we take just
the rows for taxonomic ID and name for each taxon in the taxonomic
classification, and name the columns by the taxon rank, so you get
\code{phylum} and \code{phylum_id}, and so on.
}

\section{\code{bold_tax_id}}{

For \code{bold_tax_id}, use \code{\link{bold_tax_id2}}.
}

\examples{
\dontrun{
df <- bold_identify(sequences = sequences$seq2)

# long format
out <- bold_identify_parents(df)
str(out)
head(out[[1]])

# wide format
out <- bold_identify_parents(df, wide = TRUE)
str(out)
head(out[[1]])

x <- bold_seq(taxon = "Satyrium")
out <- bold_identify(c(x[[1]]$sequence, x[[13]]$sequence))
res <- bold_identify_parents(out)
res

x <- bold_seq(taxon = 'Diplura')
out <- bold_identify(vapply(x, "[[", "", "sequence")[1:20])
res <- bold_identify_parents(out)
}
\dontrun{
bold_tax_id(id = 88899)
bold_tax_id(id = 88899, includeTree = TRUE)
bold_tax_id(id = 88899, includeTree = TRUE, dataTypes = "stats")
bold_tax_id(id = c(88899,125295))

## dataTypes parameters
bold_tax_id(id = 88899, dataTypes = "basic")
bold_tax_id(id = 88899, dataTypes = "stats")
bold_tax_id(id = 88899, dataTypes = "images")
bold_tax_id(id = 88899, dataTypes = "geo")
bold_tax_id(id = 88899, dataTypes = "sequencinglabs")
bold_tax_id(id = 88899, dataTypes = "depository")
bold_tax_id(id = c(88899, 125295), dataTypes = "geo")
bold_tax_id(id = c(88899, 125295), dataTypes = "images")

## Passing in NA
bold_tax_id(id = NA)
bold_tax_id(id = c(88899, 125295, NA))

## get http response object only
bold_tax_id(id = 88899, response=TRUE)
bold_tax_id(id = c(88899, 125295), response=TRUE)

## curl debugging
bold_tax_id(id = 88899, verbose = TRUE)
}

}
\references{
http://v4.boldsystems.org/index.php/resources/api?type=taxonomy
}
\seealso{
\code{\link[=bold_tax_name]{bold_tax_name()}}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bold_seqspec.R
\name{b_sepFasta}
\alias{b_sepFasta}
\title{Seperate sequences (fasta) from \code{bold_seqspec} output.}
\usage{
b_sepFasta(x, format = "tsv")
}
\arguments{
\item{x}{(object) The output of a \code{bold_seqspec} call.}

\item{format}{(character) The format used in the \code{bold_seqspec} call. One of 'tsv' (default) or 'xml'.}
}
\value{
A list of length two : the specimen data and the sequences list.
}
\description{
Seperate sequences (fasta) from \code{bold_seqspec} output.
}
\examples{
\dontrun{
res <- bold_seqspec(taxon='Osmia')
res <- b_sepFasta(res)
# (same as bold_seqspec(taxon='Osmia', sepFasta = TRUE))
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bold_tax_name.R
\name{bold_tax_name}
\alias{bold_tax_name}
\title{Search BOLD for taxonomy data by taxonomic name}
\usage{
bold_tax_name(
  name,
  fuzzy = FALSE,
  response = FALSE,
  tax_division = NULL,
  tax_rank = NULL,
  ...
)
}
\arguments{
\item{name}{(character) One or more scientific names. required.}

\item{fuzzy}{(logical) Whether to use fuzzy search or not (default: \code{FALSE})}

\item{response}{(logical) Default : FALSE. If TRUE, returns the object from
the Curl call. Useful for debugging and getting more detailed info on the
API call.}

\item{tax_division}{(character) Taxonomic division to filter the results.}

\item{tax_rank}{(character) Taxonomic rank to filter the results.}

\item{...}{Further args passed on to
\code{\link[crul:verb-GET]{crul::verb-GET}}, main purpose being curl
debugging}
}
\description{
Search BOLD for taxonomy data by taxonomic name
}
\details{
The \code{dataTypes} parameter is not supported in this function.
If you want to use that parameter, get an ID from this function and pass
it into \code{bold_tax_id}, and then use the \code{dataTypes} parameter.
}
\note{
The column 'specimenrecords' in the returned object represents the number of species records in BOLD's \emph{Taxonomy Browser}, not the number of records in the \emph{Public Data Portal}. To know the amount of public records available, use \code{\link{bold_stats}}.
}
\examples{
\dontrun{
bold_tax_name(name='Diplura')
bold_tax_name(name='Osmia')
bold_tax_name(name=c('Diplura','Osmia'))
bold_tax_name(name=c("Apis","Puma concolor","Pinus concolor"))
bold_tax_name(name='Diplur', fuzzy=TRUE)
bold_tax_name(name='Osm', fuzzy=TRUE)

## get http response object only
bold_tax_name(name='Diplura', response=TRUE)
bold_tax_name(name=c('Diplura','Osmia'), response=TRUE)

## Names with no data in BOLD database
bold_tax_name("Nasiaeshna pentacantha")
bold_tax_name(name = "Cordulegaster erronea")
bold_tax_name(name = "Cordulegaster erronea", response=TRUE)

## curl debugging
bold_tax_name(name='Diplura', verbose = TRUE)
}
}
\references{
Taxonomy API: http://v4.boldsystems.org/index.php/resources/api?type=taxonomy
Taxonomy Browser: https://www.boldsystems.org/index.php/TaxBrowser_Home
Public Data Portal: https://www.boldsystems.org/index.php/Public_BINSearch?searchtype=records
}
\seealso{
\code{\link{bold_tax_id}}, \code{\link{bold_get_attr}}, \code{\link{bold_get_errors}}, \code{\link{bold_get_params}}
}
